'From Squeak 2.0 BETA of May 8, 1998 on 14 May 1998 at 12:41:18 pm'!
MorphicModel subclass: #SystemWindow
	instanceVariableNames: 'labelString label paneColor closeBox collapseBox activeOnlyOnTop '
	classVariableNames: 'TopWindow '
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!SystemWindow commentStamp: 'di 5/14/1998 12:41' prior: 0!
SystemWindow is the Morphic equivalent of StandardSystemView -- a labelled container for rectangular views, with iconic facilities for close, collapse/expand, and resizing.

The attribute onlyActiveOnTop, if set to true (and any call to activate will set this), determines that only the top member of a collection of such windows on the screen shall be active.  To be not active means that a mouse click in any region will only result in bringing the window to the top and then making it active.!

!SystemWindow methodsFor: 'open/close' stamp: 'di 5/14/1998 12:34'!
openInWorldExtent: extent
	"This msg and its callees result in the window being activeOnlyOnTop"
	Smalltalk isMorphic ifFalse: [^ self openInMVCExtent: extent].
	self bounds: (16@0 extent: extent).  "Room on left for scroll bars"
	World addMorph: self.
	self activate! !

!SystemWindow methodsFor: 'top window' stamp: 'di 5/14/1998 11:48'!
activate
	"Bring me to the front and make me able to respond to mouse and keyboard"
	activeOnlyOnTop _ true.
	TopWindow ifNotNil: [TopWindow passivate].
	owner firstSubmorph == self ifFalse: [owner addMorphFront: self].
	self submorphsDo: [:m | m unlock].
	TopWindow _ self! !

!SystemWindow methodsFor: 'top window' stamp: 'di 5/14/1998 11:49'!
activeOnlyOnTop
	^ activeOnlyOnTop ifNil: [false]! !

!SystemWindow methodsFor: 'top window' stamp: 'di 5/14/1998 12:38'!
activeOnlyOnTop: trueOrFalse
	activeOnlyOnTop _ trueOrFalse! !

!SystemWindow methodsFor: 'top window' stamp: 'di 5/14/1998 11:50'!
handlesMouseDown: evt
	"If I am not the topWindow, then my mouseDown action dominates"
	^ self activeOnlyOnTop and: [self ~~ TopWindow]! !

!SystemWindow methodsFor: 'top window' stamp: 'di 5/14/1998 11:55'!
isActive
	self activeOnlyOnTop ifTrue: [^ self == TopWindow].
	^ true! !


!SystemWindow class methodsFor: 'top window' stamp: 'di 5/14/1998 11:52'!
noteTopWindowIn: aWorld
	"TopWindow must be nil or point to the top window in this project."
	TopWindow _ nil.
	aWorld submorphsDo:
		[:m | ((m isKindOf: SystemWindow) and: [m activeOnlyOnTop])
			ifTrue: [^ m activate]]! !


SystemWindow allInstancesDo: [:w | w activeOnlyOnTop: true]!

