'From Squeak 2.0 of May 22, 1998 on 3 June 1998 at 2:42:49 pm'!
"Change Set:		jhmShowRectFix
Date:			3 June 1998
Author:			John Maloney

Fixes the showRect primitive when it is passed
float coordinates."
!


!DisplayScreen methodsFor: 'private' stamp: 'jm 6/3/1998 13:00'!
primRetryShowRectLeft: l right: r top: t bottom: b
	"Copy the given rectangular section of the Display to to the screen. This primitive is not implemented on all platforms. Do nothing if it fails. "

	<primitive: 127>
	"do nothing if primitive fails"
! !

!DisplayScreen methodsFor: 'private' stamp: 'jm 6/3/1998 13:02'!
primShowRectLeft: l right: r top: t bottom: b
	"Copy the given rectangular section of the Display to to the screen. This primitive is not implemented on all platforms. If this fails, retry integer coordinates."

	<primitive: 127>
	"if this fails, coerce coordinates to integers and try again"
	self primRetryShowRectLeft: l truncated
		right: r rounded
		top: t truncated
		bottom: b rounded.
! !


!FormCanvas methodsFor: 'drawing' stamp: 'jm 6/3/1998 14:35'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth topLeftColor: topLeftColor bottomRightColor: bottomRightColor

	| w h rect |
	"First use quick code for top and left borders and fill"
	self frameAndFillRectangle: r
		fillColor: fillColor
		borderWidth: borderWidth
		borderColor: topLeftColor.

	"Now use slow code for bevelled bottom and right borders"
	bottomRightColor isTransparent ifFalse: [
		borderWidth isNumber
			ifTrue: [w _ h _ borderWidth]
			ifFalse: [w _ borderWidth x.   h _ borderWidth y].
		rect _ r translateBy: origin.
		port fillColor: (self drawColor: bottomRightColor);
			 frameRectRight: rect width: w;
			 frameRectBottom: rect height: h].
! !


!Point methodsFor: 'truncation and round off' stamp: 'jm 6/3/1998 12:21'!
rounded
	"Answer a Point that is the receiver's x and y rounded. Answer the receiver if its coordinates are already integral."

	(x isInteger and: [y isInteger]) ifTrue: [^ self].
	^ x rounded @ y rounded
! !


!PolygonMorph methodsFor: 'editing' stamp: 'jm 6/3/1998 14:29'!
newVertex: evt fromHandle: handle afterVert: ix
	"Insert a new vertex and fix everything up!! Install the drag-handle of the new vertex as recipient of further mouse events."

	| pt |
	pt _ evt cursorPoint.
	self setVertices: (vertices copyReplaceFrom: ix + 1 to: ix with: (Array with: pt)).
	evt hand newMouseFocus: (handles at: ((ix + 1) * 2) - 1).
! !


