'From Squeak 2.0 of May 22, 1998 on 16 June 1998 at 12:09:50 am'!
"Change Set:		FasterWindowsEtc-di
Date:			15 June 1998
Author:			Dan Ingalls

Modified posting of damage regions in SystemWindow display, resulting
	in substantially faster window activation for Morphic development.
Transitory world menu no longer shows after returning through a project window.
Resolution of project thumbnail is determined by the sole projectWindow.
Fixes single ChangeSorters so they update upon entry.
"!


!ChangeSorter methodsFor: 'access' stamp: 'di 6/15/1998 20:33'!
modelWakeUp
	"A window with me as model is being entered.  Make sure I am up-to-date with the changeSets."

	self canDiscardEdits ifTrue: [self update]! !


!MenuItemMorph methodsFor: 'events' stamp: 'jm 6/15/1998 12:18'!
mouseUp: evt
	"Handle a mouse up event. Menu items get activated when the mouse is over them."

	| mouseInMe |
	mouseInMe _ self boundsInWorld containsPoint: evt cursorPoint.
	self deselectItem.
	self isInMenu ifTrue: [
		(mouseInMe and: [self selector = #toggleStayUp:])
			ifFalse: [owner deleteIfPopUp].
		subMenu ifNil: [
			mouseInMe ifTrue: [
				evt hand world displayWorld.
				owner invokeItem: self]]].
! !


!ProjectViewMorph methodsFor: 'all' stamp: 'di 6/15/1998 16:21'!
enter
	"Enter my project."
	(owner isKindOf: SystemWindow)
		ifTrue: [project setViewSize: self extent].
	project enter: false.
! !


!SystemWindow methodsFor: 'resize/collapse' stamp: 'di 6/15/1998 23:16'!
addHandles 
	| pt handle |
	isCollapsed ifTrue: [^ self "no handles if collapsed"].
	#(topLeft topRight bottomLeft bottomRight rightCenter leftCenter
		topLeft topRight bottomLeft bottomRight topCenter bottomCenter)
		withIndexDo: [:ptName :i | pt _ self bounds perform: ptName.
			handle _ Morph new color: Color gray; extent: (i<=6 ifTrue: [2@20] ifFalse: [20@2]).
			handle align: (handle bounds perform: ptName) with: pt.
			handle on: #mouseEnter send: #enterHandle:morph:pointName:
					to: self withValue: ptName.
			self addMorph: handle].
! !

!SystemWindow methodsFor: 'top window' stamp: 'di 6/15/1998 23:42'!
activate
	"Bring me to the front and make me able to respond to mouse and keyboard"
	| oldTop |
	oldTop _ TopWindow.
	TopWindow _ self.
	oldTop ifNotNil: [oldTop passivate].
	owner firstSubmorph == self ifFalse: [owner addMorphFront: self].
	self submorphsDo: [:m | m unlock].
	self setStripeColorsFrom: self paneColor.
	self addHandles.
"self world displayWorld."  "update just this damage all in one window"
	self isCollapsed ifFalse: [model modelWakeUp].
! !

!SystemWindow methodsFor: 'top window' stamp: 'di 6/15/1998 23:39'!
passivate
	"Make me unable to respond to mouse and keyboard"
	self setStripeColorsFrom: self paneColor.

	"Note - the following code is equiv to simply:
		self removeHandles.
	It has been rewritten so that only 4 damage rects will get repainted, 
	all within this window, and none within its subpanes"
	"First do the top 3 and bottom 3, together with the label"
	self invalidRect: (self bounds topLeft corner: self right@(self top+2)).
	self invalidRect: (self left@(self bottom-2) corner: self bounds bottomRight).
	(self submorphs select: [:m | (m isMemberOf: Morph)
			and: [m bottom <= (self top+2) or: [m top >= (self bottom-2)]]])
		do: [:m | m delete].
	self world displayWorld.
	"Now do the left 3 and right 3"
	self invalidRect: (self bounds topLeft corner: (self left+2)@self bottom).
	self invalidRect: ((self right-2)@self top corner: self bounds bottomRight).
	self removeHandles.  "Only these are left"
	self world displayWorld.

	self submorphsDo: [:m | m lock].
! !


