'From Squeak 2.0 of May 22, 1998 on 16 June 1998 at 3:18:20 pm'!
"Change Set:		copyRefMethods
Date:			16 June 1998
Author:			Scott Wallace

Fixes bug in copy-player that had neglected to carry over the player-reference jump table properly"!


!Behavior methodsFor: 'copying' stamp: 'sw 6/16/1998 15:15'!
copyOfMethodDictionary
	"Return a copy of the receiver's method dictionary"

	^ methodDict copy! !


!ClassDescription methodsFor: 'copying' stamp: 'sw 6/16/1998 15:01'!
copyMethodDictionaryFrom: donorClass
	"Copy the method dictionary of the donor class over to the receiver"

	methodDict _ donorClass copyOfMethodDictionary.
	organization _ donorClass organization deepCopy! !


!Player methodsFor: 'clone' stamp: 'sw 6/16/1998 15:17'!
duplicatedPlayerForCostume: aCostume
	"Answer a new Player that starts out life wearing aCostume and having the same instance variables and methods as the receiver, but its own private independent uniclass"

	| anInstance itsClass |
	anInstance _ self class officialClass instanceOfUniqueClassWithInstVarString: self class instanceVariablesString andClassInstVarString: self class class instanceVariablesString.
	anInstance costume: aCostume.
	anInstance copyStateFrom: self.
	(itsClass _ anInstance class) copyMethodDictionaryFrom: self class.
	itsClass class copyMethodDictionaryFrom: self class class.
	^ anInstance! !


!Player class methodsFor: 'initialization' stamp: 'sw 6/16/1998 15:12'!
copyStateFrom: anotherClass
	| dupScript |
	self copyAddedStateFrom: anotherClass.  "being the reference table stored in inst vars of the class"
	scripts _ IdentityDictionary new.
	anotherClass userScriptsDo:
		[:aScript | 
			aScript isAnonymous ifFalse:
				[dupScript _ aScript shallowCopy.
				dupScript initializeForPlayer: self flagshipInstance afterShallowCopyFrom: aScript.
				scripts at: aScript selector put: dupScript]].
	slotInfo _ anotherClass slotInfo deepCopy.
	self copyAddedStateFrom: anotherClass.  "The player-ref jump table"! !


Class removeSelector: #copyOfMethodDictionary!
