'From Squeak 2.4b of April 23, 1999 on 30 April 1999 at 5:32:57 am'!
"Change Set:		VMSupportFiles-ar
Date:			30 April 1999
Author:			Andreas Raab

Separates the cross-platform support file writing from the Mac specifics and thus frees me from having to delete all files starting with sqMac* AND reminding myself that sqMachdep.h must not be deleted ;-)
Also uses CrLfStream for support code generation - there is no real use for cross-platform CRs in the C support code :->"!


!CCodeGenerator methodsFor: 'public' stamp: 'ar 4/30/1999 04:54'!
storeCodeOnFile: fileName doInlining: inlineFlag doAssertions: assertionFlag
	"Store C code for this code base on the given file."

	| stream |
	stream _ CrLfFileStream newFileNamed: fileName.
	self emitCCodeOn: stream doInlining: inlineFlag doAssertions: assertionFlag.
	stream close.! !


!InterpreterSupportCode class methodsFor: 'source file exporting' stamp: 'ar 4/30/1999 04:49'!
storeString: s onFileNamed: fileName
	"Store the given string in a file of the given name."

	| f |
	f _ CrLfFileStream newFileNamed: fileName.
	f nextPutAll: s.
	f close.! !

!InterpreterSupportCode class methodsFor: 'source file exporting' stamp: 'ar 4/30/1999 04:44'!
writeMacSourceFiles
	"Store into this image's folder the C sources files required to support the interpreter on the Macintosh. It also generates the code for the sound synthesis primitives. However, because generating code for the interpreter itself takes several minutes, that is not done automatically by this method. To generate that code, use the method 'translate:doInlining:' in Interpreter class."
	"InterpreterSupportCode writeMacSourceFiles"

	self writeSupportFiles.

	self storeString: self macAsyncFilePrimsFile	onFileNamed: 'sqMacAsyncFilePrims.c'.
	self storeString: self macDirectoryFile	onFileNamed: 'sqMacDirectory.c'.
	self storeString: self macJoystickAndTabletFile  onFileNamed: 'sqMacJoystickAndTablet.c'.
	self storeString: self macMinimal		onFileNamed: 'sqMacMinimal.c'.
	self storeString: self macNetworkFile		onFileNamed: 'sqMacNetwork.c'.
	self storeString: self macSerialAndMIDIPortFile	onFileNamed: 'sqMacSerialAndMIDIPort.c'.
	self storeString: self macSoundFile		onFileNamed: 'sqMacSound.c'.
	self storeString: self macWindowFile		onFileNamed: 'sqMacWindow.c'.
	self storeString: self macTCPFile			onFileNamed: 'MacTCP.h'.
	self storeString: self macAddressXlationFile		onFileNamed: 'AddressXlation.h'.
	self storeString: self macDNRFile					onFileNamed: 'dnr.c'.
	self storeString: self macExternalPrimsFile		onFileNamed: 'sqMacExternalPrims.c'.

	self storeProjectArchiveOnFileNamed: 'projectArchive.sit'.
! !

!InterpreterSupportCode class methodsFor: 'source file exporting' stamp: 'ar 4/30/1999 04:43'!
writeSupportFiles
	"Store into this image's folder the C sources files required to support the interpreter on the Macintosh. It also generates the code for the sound synthesis primitives. However, because generating code for the interpreter itself takes several minutes, that is not done automatically by this method. To generate that code, use the method 'translate:doInlining:' in Interpreter class."
	"InterpreterSupportCode writeSupportFiles"

	self storeString: self readmeFile			onFileNamed: 'readme'.
	self storeString: self squeakHeaderFile	onFileNamed: 'sq.h'.
	self storeString: self squeakConfigFile	onFileNamed: 'sqConfig.h'.
	self storeString: self squeakMachDepFile	onFileNamed: 'sqMachDep.h'.
	self storeString: self squeakPlatSpecFile	onFileNamed: 'sqPlatformSpecific.h'.
	self storeString: self squeakVirtualMachineHeaderFile	onFileNamed: 'sqVirtualMachine.h'.
	self storeString: self squeakVirtualMachineFile	onFileNamed: 'sqVirtualMachine.c'.

	self storeString: self squeakADPCMCodecPrimsFile	 onFileNamed: 'sqADPCMPrims.c'.
	self storeString: self squeakFilePrimsFile	onFileNamed:  'sqFilePrims.c'.
	self storeString: self squeakGSMCodecPluginFile	onFileNamed: 'sqGSMCodecPlugin.c'.

	Smalltalk at: #AbstractSound ifPresent: [:abstractSound |
		self storeString: abstractSound cCodeForSoundPrimitives
													onFileNamed: 'sqSoundPrims.c'].
	self storeString: self cCodeForMiscPrimitives
													onFileNamed: 'sqMiscPrims.c'.
	self storeString: self squeakOldSoundPrimsFile	onFileNamed: 'sqOldSoundPrims.c'.

! !


