'From Squeak 2.4b of April 23, 1999 on 4 May 1999 at 11:34:06 pm'!
"Change Set:		snapCursAndRepaint-sw
Date:			4 May 1999
Author:			Scott Wallace

Shows the write cursor on snapshots whether in morphic or not.

Fixes bug reported by Markus Kohler and John Steinmetz regarding repaint."!


!HandMorph methodsFor: 'world menu commands' stamp: 'sw 5/4/1999 09:41'!
makeAliasForArgument
	| aThumbnailMorph |
	argument notNil ifTrue:
		[aThumbnailMorph _ argument newThumbnailOfHeight: 40.
		aThumbnailMorph  setNameTo: '^ ', argument externalName.
		self attachMorph: aThumbnailMorph]! !

!HandMorph methodsFor: 'world menu commands' stamp: 'sw 5/4/1999 09:40'!
openViewerForArgument
	argument notNil ifTrue:
		[argument presenter viewMorph: argument]! !


!SketchMorph methodsFor: 'menu' stamp: 'sw 5/4/1999 09:43'!
editDrawingIn: aPasteUpMorph forBackground: forBackground

	| w oldRotation bnds sketchEditor pal |
	w _ aPasteUpMorph world.
	w stopRunningAll; abandonAllHalos.
	w displayWorld.
	oldRotation _ rotationDegrees.
	forBackground
		ifTrue:
			[bnds _ aPasteUpMorph boundsInWorld]
		ifFalse:
			[bnds _ (self boundsInWorld expandBy: (60 @ 60)) intersect: self world bounds.
			bnds _ (aPasteUpMorph paintingBoundsAround: bnds center) merge: bnds].
	sketchEditor _ SketchEditorMorph new.
	forBackground ifTrue: [sketchEditor setProperty: #background toValue: true].
	w addMorphFront: sketchEditor.
	sketchEditor initializeFor: self inBounds: bnds pasteUpMorph: aPasteUpMorph.
		"self rotationDegrees: 0.  inside the init"
	self rotationDegrees: oldRotation.  "restore old rotation so that cancel leaves it right"
	sketchEditor
		afterNewPicDo: [:aForm :aRect |
			self form: aForm.
			self topRendererOrSelf position: aRect origin.
			self rotationStyle: sketchEditor rotationStyle.
			self setupAngle: sketchEditor forwardDirection.
			self rotationDegrees: sketchEditor forwardDirection.
			self presenter drawingJustCompleted: self.
			forBackground ifTrue: [self goBehind]]  "shouldn't be necessary"
		ifNoBits: ["If no bits drawn.  Must keep old pic.  Can't have no picture"
			((pal _ aPasteUpMorph standardPalette) notNil and: [pal isInWorld]) ifTrue:
				[pal viewMorph: self]]! !


!SystemDictionary methodsFor: 'snapshot and quit' stamp: 'sw 5/4/1999 10:58'!
snapshot: save andQuit: quit
	"Mark the changes file and close all files. If save is true, save the current state of this Smalltalk in the image file. If quit is true, then exit to the outer shell. The latter part of this method runs when resuming a previously saved image. The resume logic checks for a document file to process when starting up."

	| resuming msg sourceLink |
	save & (SourceFiles at: 2) notNil ifTrue:
		[msg _  (quit
			ifTrue: ['----QUIT----']
			ifFalse: ['----SNAPSHOT----'])
			, Date dateAndTimeNow printString.
		sourceLink _ ' priorSource: ' , LastQuitLogPosition printString.
		self assureStartupStampLogged.
		LastQuitLogPosition _ (SourceFiles at: 2) setToEnd; position.
		self logChange: msg , sourceLink.
		Transcript cr; show: msg].

	self processShutDownList.
	Cursor write show.
	save
		ifTrue: [resuming _ self snapshotPrimitive]  "<-- PC frozen here on image file"
		ifFalse: [resuming _ false].
	quit & resuming not ifTrue: [self quitPrimitive].
	Cursor normal show.
	self processStartUpList.
	resuming ifTrue: [
		self clearExternalObjects.
		self readDocumentFile].
! !


Morph removeSelector: #playfield!
Presenter removeSelector: #playfield!
