'From Squeak 2.4c of May 10, 1999 on 21 June 1999 at 4:55:50 pm'!
"Change Set:		alphaNewMorph
Date:			17 June 1999
Author:			Scott Wallace

Adds to the 'new morph' menu a new command allowing you to choose from an alphabetical list of morph types.  The list is of course long, but at least this gives you a deterministic way to locate a morph without needing to know what category it is in."!


!HandMorph methodsFor: 'world menu' stamp: 'sw 6/17/1999 11:47'!
newMorph
	| menu subMenu catDict shortCat class |
	menu _ (MenuMorph entitled: 'Add a new morph') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'from paste buffer' action: #pasteMorph.
	menu add: 'from a file...' target: self action: #readMorphFromAFile.
	menu add: 'from alphabetical list...' action: #newMorphFromAlphabeticalList.
	menu add: 'grab patch from screen' action: #grabDrawingFromScreen.
	menu add: 'make new drawing' target: self action: #newDrawingFromMenu.
	menu add: 'make link to project...' target: self action: #projectThumbnail.

	menu addLine.
	catDict _ Dictionary new.
	SystemOrganization categories do:
		[:cat |
		((cat beginsWith: 'Morphic-')
				and: [(#('Morphic-Menus' 'Morphic-Support') includes: cat) not])
		ifTrue:
			[shortCat _ cat copyFrom: 'Morphic-' size+1 to: cat size.
			(SystemOrganization listAtCategoryNamed: cat) do:
				[:cName | class _ Smalltalk at: cName.
				((class inheritsFrom: Morph)
					and: [class includeInNewMorphMenu])
					ifTrue:
					[(catDict includesKey: shortCat) 
					ifTrue: [(catDict at: shortCat) addLast: class]
					ifFalse: [catDict at: shortCat put: (OrderedCollection with: class)]]]]].

	catDict keys asSortedCollection do:
		[:categ |
		subMenu _ MenuMorph new.
		((catDict at: categ) asSortedCollection: [:c1 :c2 | c1 name < c2 name]) do:
			[:cl | subMenu add: cl name
					target: self
					selector: #newMorphOfClass:event:
					argument: cl].
		menu add: categ subMenu: subMenu].

	menu popUpAt: self position forHand: self.
! !

!HandMorph methodsFor: 'world menu commands' stamp: 'sw 6/17/1999 11:45'!
newMorphFromAlphabeticalList
	| aList aMenu result |
	aList _ Morph withAllSubclasses select:
		[:m | m includeInNewMorphMenu].
	aList _ aList asSortedCollection: [:m :n | m name < n name].
	aMenu _ SelectionMenu labels:
		(aList collect: [:m | m name]) selections: aList.
	result _ aMenu startUpWithCaption: 'Choose morph class'.
	result ifNotNil:
		[self newMorphOfClass: result event: self lastEvent]! !


