'From Squeak 2.4c of May 10, 1999 on 1 July 1999 at 5:37:03 pm'!
"Change Set:		roundedFlaps-sw
Date:			1 July 1999
Author:			Scott Wallace

Makes the corners of textual flaps be rounded."!


!CornerRounder methodsFor: 'all' stamp: 'sw 7/1/1999 17:26'!
tweakCornersOf: aMorph on: aCanvas borderWidth: w corners: cornerList
	"This variant has a cornerList argument, to allow some corners to be rounded and others not"
	| offset corner saveBits c fourColors c14 c23 insetColor mask |
	w > 0 ifTrue:
		[c _ aMorph borderColor.
		fourColors _ Array new: 4 withAll: c.
		c == #raised ifTrue:
			[c14 _ aMorph color lighter. c23 _ aMorph color darker.
			fourColors _ Array with: c14 with: c23 with: c23 with: c14].
		(c == #inset and: [aMorph owner notNil]) ifTrue:
			[insetColor _ aMorph owner colorForInsets.
			c14 _ insetColor lighter. c23 _ insetColor darker.
			fourColors _ Array with: c14 with: c23 with: c23 with: c14]].
	mask _ Form extent: cornerMasks first extent depth: aCanvas depth.
	(1 to: 4) do: 
		[:i | (cornerList includes: i) ifTrue:
			[corner _ aMorph bounds corners at: i.
			saveBits _ underBits at: i.
			i = 1 ifTrue: [offset _ 0@0].
			i = 2 ifTrue: [offset _ 0@saveBits height negated].
			i = 3 ifTrue: [offset _ saveBits extent negated].
			i = 4 ifTrue: [offset _ saveBits width negated@0].

			"Mask out corner area (painting saveBits won't clear if transparent)."
			mask copyBits: mask boundingBox from: (cornerMasks at: i) at: 0@0 clippingBox: mask boundingBox rule: Form over fillColor: nil map: (Bitmap with: 0 with: 16rFFFFFFFF).
			aCanvas image: mask at: corner + offset sourceRect: mask boundingBox rule: Form and.

			"Paint back corner bits."
			aCanvas image: saveBits at: corner + offset.

			w > 0 ifTrue:
				["Paint over with border if any"
				aCanvas stencil: (cornerOverlays at: i) at: corner + offset
						color: (fourColors at: i)]]]! !


!CornerRounder class methodsFor: 'all' stamp: 'sw 7/1/1999 17:27'!
roundCornersOf: aMorph on: aCanvas displayBlock: displayBlock borderWidth: w corners: aList

	| rounder |
	rounder _ CR0.
	w = 1 ifTrue: [rounder _ CR1].
	w = 2 ifTrue: [rounder _ CR2].
	rounder saveBitsUnderCornersOf: aMorph on: aCanvas.
	displayBlock value.
	rounder tweakCornersOf: aMorph on: aCanvas borderWidth: w corners: aList! !


!FlapTab methodsFor: 'textual tabs' stamp: 'sw 7/1/1999 17:32'!
fullDrawOn: aCanvas
	| aList |
	self isCurrentlyTextual ifFalse:
		[^ super fullDrawOn: aCanvas].
	aList _ self orientation == #vertical
		ifTrue:
			[edgeToAdhereTo == #right
				ifTrue:
					[#(1 2)]
				ifFalse:
					[#(3 4)]]
		ifFalse:
			[edgeToAdhereTo == #top
				ifTrue:
					[#(2 3)]
				ifFalse:
					[#(1 4)]].
	CornerRounder roundCornersOf: self on: aCanvas
					displayBlock: [super fullDrawOn: aCanvas]
					borderWidth: borderWidth
					corners: aList! !


