'From Squeak 2.4c of May 10, 1999 on 7 July 1999 at 3:37:12 pm'!
"Change Set:		viewerFlapTweaks-sw
Date:			7 July 1999
Author:			Scott Wallace

The graphical tabs of viewer flaps are now active thumbnails that always reflect the current appearance of the viewee.

Viewer flaps are preset to have the 'automaticPhraseExpansion' property, making them excellent places not only to view an object but also to script it.

Now that the thumbnail is held in the flap tab, the viewer itself no longer needs to have one, so the thumbnail in a viewer-flap-resident viewer is replaced by a menu icon.

Menus for viewer flaps are customized to have only appropriate items -- some items had been misleading or downright damaging."!


!PasteUpMorph methodsFor: 'misc' stamp: 'sw 7/7/1999 13:00'!
viewerFlapTabFor: aMorph
	"Open up a Viewer on aMorph in its own flap, creating it if necessary"
	| bottomMost aPlayer aFlapTab |
	bottomMost _ 0.
	aPlayer _ aMorph assuredPlayer.
	self flapTabs do:
		[:aTab | (aTab isKindOf: ViewerFlapTab)
			ifTrue:
				[bottomMost _ aTab bottom max: bottomMost.
				aTab scriptedPlayer == aPlayer
					ifTrue:
						[^ aTab]]].
	"Not found; make a new one"
	aFlapTab _ (Utilities newFlapTitled: aMorph externalName onEdge: #right) as: ViewerFlapTab.
	aFlapTab initializeFor: aPlayer topAt: bottomMost + 2.
	aFlapTab referent color: (Color green muchLighter alpha: 0.5).
	aFlapTab referent setProperty: #automaticPhraseExpansion toValue: true.
	self addMorphFront: aFlapTab.
	aFlapTab adaptToWorld: self.
	^ aFlapTab! !


!Presenter methodsFor: 'viewer' stamp: 'sw 7/7/1999 15:35'!
viewMorph: aMorph
	| aPlayer aViewer aPalette aRect aPoint nominalHeight aFlapTab |
	Sensor leftShiftDown ifFalse:
		[((aPalette _ aMorph standardPalette) ~~ nil and: [aPalette isInWorld])
			ifTrue:	[^ aPalette viewMorph: aMorph]].

	aPlayer _ aMorph assuredPlayer.

	associatedMorph addMorph: (aViewer _ self nascentPartsViewer).

	(Preferences viewersInFlaps) ifTrue:
		[aViewer initializeFor: aPlayer barHeight: 0 includeDismissButton: false.
		aViewer enforceTileColorPolicy.
		associatedMorph world hideViewerFlapsOtherThanFor: aPlayer.
		aFlapTab _ associatedMorph world viewerFlapTabFor: aMorph.
		aFlapTab referent submorphs do: 
			[:m | (m isKindOf: Viewer) ifTrue: [m delete]].
		aFlapTab referent addMorph: aViewer beSticky.
		aViewer visible: true.
		aFlapTab applyThickness: aViewer width + 25.
		aFlapTab showFlap. 
		aViewer position: aFlapTab referent position.
		associatedMorph world startSteppingSubmorphsOf: aFlapTab.
		^ associatedMorph world startSteppingSubmorphsOf: aViewer].
		
	aViewer initializeFor: aPlayer barHeight: 6.
	aViewer enforceTileColorPolicy.
	Preferences automaticViewerPlacement ifTrue:
		[aPoint _ aMorph bounds right @ 
			(aMorph center y - ((nominalHeight _ aViewer initialHeightToAllow) // 2)).
		aRect _ (aPoint extent: (aViewer width @ nominalHeight)) translatedToBeWithin: associatedMorph world bounds.
		aViewer position: aRect topLeft.
		aViewer visible: true.
		associatedMorph world startSteppingSubmorphsOf: aViewer.
		"it's already in the world, somewhat coincidentally"
		^ self].
	aMorph primaryHand attachMorph: (aViewer visible: true)! !


!ReferenceMorph methodsFor: 'menu' stamp: 'sw 7/7/1999 12:48'!
graphicalMorphForTab
	| formToUse |
	formToUse _ self valueOfProperty: #priorGraphic ifAbsent: [ScriptingSystem formAtKey: 'squeakyMouse'].
	^ SketchMorph new form: formToUse! !

!ReferenceMorph methodsFor: 'menu' stamp: 'sw 7/7/1999 12:49'!
useGraphicalTab
	| aGraphic |
	self preserveDetails.
	self color: Color transparent.
	aGraphic _ self graphicalMorphForTab.
	self borderWidth: 0.
	self removeAllMorphs.
	self addMorphBack: aGraphic.
	aGraphic position: self position.
	aGraphic lock.
	self fitContents.
	self layoutChanged.
	(owner isKindOf: IndexTabs) ifTrue:
		[owner laySubpartsOutInOneRow.
		isHighlighted ifTrue: [self highlight]].! !


!StandardViewer methodsFor: 'as yet unclassified' stamp: 'sw 7/7/1999 15:18'!
addHeaderMorphWithBarHeight: anInteger includeDismissButton: aBoolean
	| header aFont aButton aTextMorph nail wrpr costs headWrapper inner |
	header _ AlignmentMorph newRow color: self color muchLighter; centering: #center.
	aFont _ ScriptingSystem fontForScriptorButtons.
	aBoolean ifTrue:
		[header addMorph: (aButton _ SimpleButtonMorph new label: 'X' font: aFont).
		aButton target: self;
				color:  Color lightRed;
				actionSelector: #dismiss;
				setBalloonText: 'Delete'.
		header addTransparentSpacerOfSize: 4@1].

	header addMorphBack: (aButton _ SimpleButtonMorph new label: '+' font: aFont).
	aButton target: self; beTransparent; borderWidth: 0;
			actionSelector: #addCategoryViewer;
			setBalloonText: 'click here to add
another viewer'.
	header addTransparentSpacerOfSize: 4@1.

	costs _ scriptedPlayer costumes.
	costs ifNotNil:
	[(costs size > 1 or: [costs size = 1 and: [costs first ~~ scriptedPlayer costume]]) ifTrue:
		[header addUpDownArrowsFor: self.
		(wrpr _ header submorphs last) submorphs second setBalloonText: 'switch to previous costume'.	
		wrpr submorphs first  setBalloonText: 'switch to next costume']].	

	aBoolean
		ifTrue:
			[nail _ ThumbnailMorph new objectToView: scriptedPlayer viewSelector: #costume]
		ifFalse:
			[inner _ ImageMorph new image: (ScriptingSystem formAtKey: 'Menu').
			nail _ RectangleMorph new beTransparent extent: inner extent.
			nail addMorph: inner lock].
	nail on: #mouseDown send: #thumbnailMenuEvt:forMorph: to: scriptedPlayer.
	header addMorphBack: nail.
	nail setBalloonText: 'click here to get a menu
to specify new costume,
tear off a tile, etc..'.
	nail borderWidth: 3; borderColor: #raised.
	"nail addDropShadow.
	nail owner color: Color gray."

	header addTransparentSpacerOfSize: 5@5.

"	aButton _ SimpleButtonMorph new target: self; actionSelector: #newEmptyScript; label: 'S' font: (aFont _ StrikeFont familyName: #ComicBold size: 16);  color: Color transparent; borderWidth: 0; actWhen: #buttonDown.
	aButton setBalloonText: 'drag from here to
create a new script
for this object'.	
	header addMorphBack: aButton.

	header addTransparentSpacerOfSize: 8@5.

	aButton _ SimpleButtonMorph new target: scriptedPlayer; actionSelector: #addInstanceVariable; label: 'I' font: aFont;  color: Color transparent; borderWidth: 0; actWhen: #buttonUp.
	aButton setBalloonText: 'click here to add
an instance variable
to this object.'.
	header addMorphBack: aButton.

	header addTransparentSpacerOfSize: 5@5."

	scriptedPlayer costume assureExternalName.
	aTextMorph _ UpdatingStringMorph new
		useStringFormat;
		target:  scriptedPlayer;
		getSelector: #getName;
		putSelector: #setName:;
		setNameTo: 'name';
		font: ScriptingSystem fontForNameEditingInScriptor.
	aTextMorph setProperty: #okToTextEdit toValue: true.
	aTextMorph step.
	header  addMorphBack: aTextMorph.
	aTextMorph setBalloonText: 'Click here to edit the player''s name
use backspace to delete unwanted characters'.	

	header beSticky.
	anInteger > 0
		ifTrue:
			[headWrapper _ AlignmentMorph newColumn color: self color.
			headWrapper addTransparentSpacerOfSize: (0 @ anInteger).
			headWrapper addMorphBack: header.
			self addMorph: headWrapper]
		ifFalse:
			[self addMorph: header]! !


!ViewerFlapTab methodsFor: 'as yet unclassified' stamp: 'sw 7/7/1999 12:58'!
addAddHandMenuItemsForHalo: aMenu hand: aHandMorph
	aMenu add: 'flap color...' target: self action: #changeFlapColor


! !

!ViewerFlapTab methodsFor: 'as yet unclassified' stamp: 'sw 7/7/1999 12:56'!
addCustomMenuItems: aMenu hand: aHandMorph

	aMenu addLine.
	aMenu addUpdating: #dragoverString action: #toggleDragOverBehavior.
	aMenu addUpdating: #mouseoverString action: #toggleMouseOverBehavior.
	aMenu addUpdating: #edgeString action: #setEdgeToAdhereTo.
	aMenu addLine.
	aMenu add: 'destroy this flap' action: #destroyFlap.! !

!ViewerFlapTab methodsFor: 'as yet unclassified' stamp: 'sw 7/7/1999 12:50'!
graphicalMorphForTab
	^ ThumbnailMorph new  objectToView: scriptedPlayer viewSelector: #costume! !

!ViewerFlapTab methodsFor: 'as yet unclassified' stamp: 'sw 7/7/1999 13:14'!
initializeFor: aPlayer topAt: aTop

	scriptedPlayer _ aPlayer.
	self useGraphicalTab.
	self top: aTop! !

!ViewerFlapTab methodsFor: 'as yet unclassified' stamp: 'sw 7/7/1999 13:28'!
isCurrentlyGraphical
	^ true! !


