'From Squeak 2.4b of April 23, 1999 on 25 July 1999 at 11:13:25 pm'!
"Change Set:		Alice2OutWin
Date:			25 July 1999
Author:			Jeff Pierce

Adds the AliceTextOutputWindow that somehow escaped from the earlier Alice v2 updates."!

PluggableTextMorph subclass: #AliceTextOutputWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alice2.0-Interface'!

!AliceTextOutputWindow reorganize!
('initialization' initialize)
('output text' addText: addTextOnNewLine:)
!


!AliceTextOutputWindow methodsFor: 'initialization' stamp: 'jsp 7/25/1999 23:11'!
initialize
	"Initialize the window for output."

	super initialize.

	self color: (Color r: 0.627 g: 0.909 b: 0.972).
	self openInWorld.
! !

!AliceTextOutputWindow methodsFor: 'output text' stamp: 'jsp 7/25/1999 23:09'!
addText: aString
	"Adds the specified string to the output window"

	| textLength |

	self setText: ((textMorph contents) , aString) asText.

	textLength _ textMorph contents size + 1.

	self selectFrom: textLength to: textLength.
	self scrollSelectionIntoView.
! !

!AliceTextOutputWindow methodsFor: 'output text' stamp: 'jsp 7/25/1999 23:05'!
addTextOnNewLine: aString
	"Adds the specified string to the output window as a new line"

	| textLength |

	self setText: ((textMorph contents) , (Character cr asString) , aString) asText.

	textLength _ textMorph contents size + 1.

	self selectFrom: textLength to: textLength.
	self scrollSelectionIntoView.


! !


!AliceWorld methodsFor: 'initialize-reset-release' stamp: 'jsp 7/25/1999 23:10'!
initialize
	"Initialize the Alice world"

	| defaultCamera |

	"Initialize this Wonderland's shared namespace"
	myNamespace _ AliceNamespace new.
	myNamespace at: 'world' put: self.

	"Create the Wonderland's scheduler"
	myScheduler _ AliceScheduler new.
	myNamespace at: 'scheduler' put: myScheduler.

	"Initialize the list of actor UniClasses"
	actorClassList _ OrderedCollection new.

	"Initialize the shared mesh and texture directories"
	sharedMeshDict _ Dictionary new.
	sharedTextureDict _ Dictionary new.

	"Create an output window for us to dump text to"
	myTextOutputWindow _ AliceTextOutputWindow new.
	myTextOutputWindow setText: 'Squeak Alice v2.0.'.

	cameraList _ OrderedCollection new.
	lightList _ OrderedCollection new.

	"-------------------------------"

	"Create the undo stack for this Wonderland."
	myUndoStack _ WonderlandUndoStack new.

	"The scene object is the root of the object tree - all objects in the Wonderland are children (directly or indirectly) of the scene. "
	myScene _ WonderlandScene newFor: self.
	myNamespace at: 'scene' put: myScene.

	"Create the default camera"
	defaultCamera _ WonderlandCamera createFor: self.
	cameraList addLast: defaultCamera.
	myNamespace at: 'camera' put: defaultCamera.
	myNamespace at: 'cameraWindow' put: (defaultCamera getMorph).
	defaultCamera setName: 'camera'.

	myUndoStack reset.
! !


AliceTextOutputWindow removeSelector: #setText:!
