'From Squeak 2.5 of August 6, 1999 on 21 August 1999 at 5:30:40 pm'!
"Change Set:		WnldEditor
Date:			21 August 1999
Author:			Your Name

Changes several WonderlandMorph subclasses to provide a more intelligent resize behavior for the Wonderland Editor.
"!


!WonderlandEditor methodsFor: 'initialization' stamp: 'jsp 8/21/1999 16:52'!
initializeWith: aWonderland
	"Initialize the editor with the Wonderland."

	myWonderland _ aWonderland.

	myTabs _ (WonderlandEditorTabs newFor: aWonderland).
	self addMorph: myTabs.

	myActorBrowser _ (WonderlandActorBrowser newFor: myWonderland).
	myActorBrowser setActorViewer: (myTabs getActorViewer).
	self addMorph: (myActorBrowser getMorph).

	myControls _ WonderlandControls newFor: aWonderland.
	self addMorph: myControls.

	self position: 200@20.
	self extent: 650@375.
	self color: (Color r: 0.784 g: 0.784 b: 0.784).
	self openInWorld.
! !

!WonderlandEditor methodsFor: 'resizing' stamp: 'jsp 8/21/1999 17:25'!
extent: aPoint

	| newPoint aMorph |

	bounds extent = aPoint
		ifFalse: [
			self changed.

			newPoint _ aPoint.
			(aPoint x < 370) ifTrue: [ newPoint _ 370@(aPoint y) ].
			(aPoint y < 130) ifTrue: [ newPoint _ (newPoint x)@130 ].

			aMorph _ myActorBrowser getMorph.
			aMorph extent: 140@((newPoint y) - 52).
			aMorph position: (self position + (0@50)).

			myTabs extent: (newPoint x - 142)@(newPoint y - 4).
			myTabs position: (self position + (142@0)).

			bounds _ bounds topLeft extent: newPoint.
			self layoutChanged.
			self changed.
				].
! !


!WonderlandEditorTabs methodsFor: 'accessing' stamp: 'jsp 8/21/1999 17:19'!
extent: aPoint

	| newPoint |

	bounds extent = aPoint
		ifFalse: [
			self changed.

			newPoint _ (aPoint x)@(aPoint y - 20).

			myScriptEditor getMorph extent: newPoint.
			myActorViewer extent: newPoint.
			myQuickReference getMorph extent: newPoint.

			bounds _ bounds topLeft extent: aPoint.
			self layoutChanged.
			self changed
				].
! !


!WonderlandQuickReference methodsFor: 'initialize-release' stamp: 'jsp 8/21/1999 16:34'!
initialize
	"Create a modified workspace as our script editor"

	super initialize.

	myTextEditor _ (PluggableTextMorph on: self text: #contents accept: #acceptContents:
			readSelection: nil menu: #codePaneMenu:shifted:).

	myTextEditor name: 'Quick Reference'.
	myTextEditor scrollBarOnLeft: false.
	myTextEditor retractable: false.
	myTextEditor extent: 500@350.
	myTextEditor color: (Color r: 0.815 g: 0.972 b: 0.878).
! !


!WonderlandScriptEditor methodsFor: 'initialize-release' stamp: 'jsp 8/21/1999 16:34'!
initialize
	"Create a modified workspace as our script editor"

	super initialize.

	myTextEditor _ (PluggableTextMorph on: self text: #contents accept: #acceptContents:
			readSelection: nil menu: #codePaneMenu:shifted:).

	myTextEditor name: 'Script'.
	myTextEditor scrollBarOnLeft: false.
	myTextEditor retractable: false.
	myTextEditor extent: 500@350.
	myTextEditor color: (Color r: 0.815 g: 0.972 b: 0.878).
! !


