'From Squeak 2.5 of August 6, 1999 on 22 September 1999 at 2:31:35 pm'!
"Change Set:		projectButtonUI-sw
Date:			22 September 1999
Author:			Scott Wallace

Exploratory!!  

Makes the UI of a project-view such that it shows a blue border on mouse rollover, a red border while mouse-down-within, a gray border otherwise.

A quick click on a project link will take you to the project without further ado.

Provides balloon help for the project-view.

Puts up a one-item menu if mouse down lingers; once this has happened, you need to choose the action item in the menu if you want to have the button's action performed.

Directly takes you to the project in question on mouse-up-within if mouse-down has not lingered."!

ImageMorph subclass: #ProjectViewMorph
	instanceVariableNames: 'project lastProjectThumbnail currentBorderColor mouseDownTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!ProjectViewMorph methodsFor: 'copying' stamp: 'sw 9/22/1999 12:54'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	project _ project.		"Weakly copied"
	lastProjectThumbnail _ lastProjectThumbnail.		"Weakly copied"
	currentBorderColor _ currentBorderColor.  "Weakly copied"
	mouseDownTime _ nil! !

!ProjectViewMorph methodsFor: 'as yet unclassified' stamp: 'sw 9/22/1999 11:34'!
balloonText
	^ 'Click here to enter the
project named
"', project name, '"'! !

!ProjectViewMorph methodsFor: 'as yet unclassified' stamp: 'sw 9/22/1999 11:30'!
borderColor

	^ currentBorderColor ifNil: [currentBorderColor _ Color gray]! !

!ProjectViewMorph methodsFor: 'as yet unclassified' stamp: 'sw 9/22/1999 11:26'!
enter
	"Enter my project."
	(owner isKindOf: SystemWindow)
		ifTrue: [project setViewSize: self extent].
	self showBorderAs: Color gray.
	project enter: false.
! !

!ProjectViewMorph methodsFor: 'as yet unclassified' stamp: 'sw 9/22/1999 11:41'!
handlesMouseOver: evt
	^ true! !

!ProjectViewMorph methodsFor: 'as yet unclassified' stamp: 'sw 9/22/1999 11:26'!
initialize
	super initialize.
	currentBorderColor _ Color gray! !

!ProjectViewMorph methodsFor: 'as yet unclassified' stamp: 'sw 9/22/1999 12:48'!
mouseDown: evt
	self showBorderAs: Color red.
	self world displayWorld.
	mouseDownTime _ Time millisecondClockValue! !

!ProjectViewMorph methodsFor: 'as yet unclassified' stamp: 'sw 9/22/1999 11:25'!
mouseEnter: evt
	self showBorderAs: Color blue! !

!ProjectViewMorph methodsFor: 'as yet unclassified' stamp: 'sw 9/22/1999 11:20'!
mouseLeave: evt
	self showBorderAs: Color gray! !

!ProjectViewMorph methodsFor: 'as yet unclassified' stamp: 'sw 9/22/1999 13:02'!
mouseMove: evt
	| menu selection |
	(self containsPoint: evt cursorPoint)
		ifTrue:
			[self showBorderAs: Color red.
			mouseDownTime
				ifNil:
					[mouseDownTime _ Time millisecondClockValue]
				ifNotNil:
					[((Time millisecondClockValue - mouseDownTime) > 1100)
						ifTrue:
							[menu _ CustomMenu new.

							menu add: 'enter this project' action: #enter.
							selection _ (menu build preSelect: #enter) startUpCenteredWithCaption: ('Project Named
', 								'"', project name, '"').
							selection = #enter ifTrue: [^ self enter]]]	]
		ifFalse:
			[self showBorderAs: Color blue.
			mouseDownTime _ nil]
! !

!ProjectViewMorph methodsFor: 'as yet unclassified' stamp: 'sw 9/22/1999 11:27'!
mouseUp: evt
	(self containsPoint: evt cursorPoint) ifTrue:
		[^ self enter].
	self showBorderAs: Color gray
! !

!ProjectViewMorph methodsFor: 'as yet unclassified' stamp: 'sw 9/22/1999 12:37'!
showBorderAs: aColor
	image border: image boundingBox width: 1 fillColor: aColor.
	currentBorderColor _ aColor.
	self changed
! !

!ProjectViewMorph methodsFor: 'object fileIn' stamp: 'sw 9/22/1999 12:55'!
convertbosfceipl0: varDict bosfceiplcm0: smartRefStrm
	"These variables are automatically stored into the new instance ('project' 'lastProjectThumbnail' ).
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: ('currentBorderColor' 'mouseDownTime' )  If a non-nil value is needed, please assign it."
	currentBorderColor _ Color gray.
	mouseDownTime _ nil
! !


