'From Squeak 2.5 of August 6, 1999 [latest update: #1526] on 8 October 1999 at 12:50 pm'!

!ImageSegment methodsFor: 'read/write segment' stamp: 'tk 10/8/1999 12:39'!
localName
	"Return the local file name for this segment."

	^ FileDirectory localNameFor: fileName! !

!ImageSegment methodsFor: 'read/write segment' stamp: 'tk 10/8/1999 12:39'!
segmentName
	"Return the local file name for this segment."

	^ segmentName! !

!ImageSegment methodsFor: 'read/write segment' stamp: 'tk 10/8/1999 11:28'!
writeToFile

	state = #active ifFalse: [self error: 'wrong state'].
	segmentName ifNil: [
		segmentName _ (FileDirectory localNameFor: fileName) sansPeriodSuffix].
		"still has number on end -- OK normally not nil"
	fileName _ self class uniqueFileNameFor: segmentName.
	(FileStream newFileNamed: fileName) nextPutAll: segment; close.
	segment _ nil.
	endMarker _ nil.
	state _ #onFile! !

!ImageSegment methodsFor: 'read/write segment' stamp: 'tk 10/8/1999 12:23'!
writeToFile: shortName
	"The short name can't have any fileDelimiter characters in it.  It is remembered in case the segment must be brought in and then sent out again (see ClassDescription updateInstancesFrom:)."

	segmentName _ (shortName endsWith: '.seg')
		ifTrue: [shortName copyFrom: 1 to: shortName size - 4]
		ifFalse: [shortName].
	segmentName last isDigit ifTrue: [segmentName _ segmentName, '-'].
	self writeToFile.! !

!ImageSegment methodsFor: 'read/write segment' stamp: 'tk 10/8/1999 11:28'!
writeToFileWithSymbols
	| symbols nonSymbols pound |

	state = #extracted ifFalse: [self error: 'wrong state'].
	segmentName ifNil: [
		segmentName _ (FileDirectory localNameFor: fileName) sansPeriodSuffix].
		"still has number on end -- OK normally not nil"
	fileName _ self class uniqueFileNameFor: segmentName.
	symbols _ OrderedCollection new.
	nonSymbols _ OrderedCollection new.
	pound _ '#' asSymbol.
	outPointers do:
		[:s | 
		((s isMemberOf: Symbol) and: [s isLiteral and: [s ~~ pound]])
			ifTrue: [symbols addLast: s]
			ifFalse: [symbols addLast: pound.  nonSymbols addLast: s]].
	(FileStream newFileNamed: fileName)
		store: symbols asArray; cr;
		nextPutAll: segment; close.
	outPointers _ nonSymbols asArray.
	state _ #onFileWithSymbols! !

!ImageSegment methodsFor: 'read/write segment' stamp: 'tk 10/8/1999 12:23'!
writeToFileWithSymbols: shortName

	segmentName _ (shortName endsWith: '.seg')
		ifTrue: [shortName copyFrom: 1 to: shortName size - 4]
		ifFalse: [shortName].
	segmentName last isDigit ifTrue: [segmentName _ segmentName, '-'].
	self writeToFileWithSymbols.! !


!ImageSegment class methodsFor: 'fileIn/Out' stamp: 'tk 10/8/1999 12:50'!
reclaimObsoleteSegmentFiles  "ImageSegment reclaimObsoleteSegmentFiles"
	"Delete segment files that can't be used after this image is saved.
	Note that this is never necessary -- it just saves file space."

	| segDir segFiles |
	segDir _ self segmentDirectory.
	segFiles _ (segDir fileNames select: [:fn | fn endsWith: '.seg']) asSet.
	ImageSegment allInstancesDo: [:is | 
		is isOnFile ifTrue: [
			segFiles remove: is localName ifAbsent: [
				Transcript cr; show: 'Segment file not found: ', is localName].
			segFiles do: [:fName | 
				fName sansPeriodSuffix stemAndNumericSuffix first = is segmentName 
					ifTrue: [segDir deleteFileNamed: fName]]]].! !


