'From Squeak 2.5 of August 6, 1999 [latest update: #1529] on 11 October 1999 at 12:39 pm'!

!ImageSegment class methodsFor: 'fileIn/Out' stamp: 'tk 10/11/1999 11:50'!
reclaimObsoleteSegmentFiles  "ImageSegment reclaimObsoleteSegmentFiles"
	"Delete segment files that can't be used after this image is saved.
	Note that this is never necessary -- it just saves file space."

	| segDir segFiles |
	segDir _ self segmentDirectory.
	segFiles _ (segDir fileNames select: [:fn | fn endsWith: '.seg']) asSet.
	segFiles isEmpty ifTrue: [^ self].
	ImageSegment allInstancesDo: [:is | 
		is isOnFile ifTrue: [
			segFiles remove: is localName ifAbsent: [
				Transcript cr; show: 'Segment file not found: ', is localName].
			segFiles do: [:fName | 
				fName sansPeriodSuffix stemAndNumericSuffix first = is segmentName 
					ifTrue: [segDir deleteFileNamed: fName]]]].! !


!SystemDictionary methodsFor: 'snapshot and quit' stamp: 'TEM 10/9/1999 21:15'!
saveAs

	| dir newName newImageName newChangesName newImageSegDir oldImageSegDir haveSegs |
	dir _ FileDirectory default.
	newName _ FillInTheBlank
		request: 'New File Name?'
		initialAnswer: (FileDirectory localNameFor: self imageName).
	newName = '' ifTrue: [^self].
	newName _ FileDirectory baseNameFor: newName asFileName.

	newImageName _ newName, FileDirectory dot, FileDirectory imageSuffix.
	newChangesName _ newName, FileDirectory dot, FileDirectory changeSuffix.
	((dir includesKey: newImageName) or:
	 [dir includesKey: newChangesName]) ifTrue: [
		^ self notify: newName, ' is already in use.
Please choose another name.'].

	dir copyFileNamed: self changesName toFileNamed: newChangesName.

	haveSegs _ false.
	Smalltalk at: #ImageSegment ifPresent: [:theClass | 
		(haveSegs _ theClass instanceCount ~= 0) ifTrue: [
			oldImageSegDir _ theClass segmentDirectory]].

	self logChange: '----SAVEAS ', newName, '----', Date dateAndTimeNow printString.
	self imageName: (dir fullNameFor: newImageName).
	LastImageName _ self imageName.
	self closeSourceFiles; openSourceFiles.  "so SNAPSHOT appears in new changes file"
	haveSegs ifTrue: [
		Smalltalk at: #ImageSegment ifPresent: [:theClass |
			newImageSegDir _ theClass segmentDirectory.	"create the folder"
			oldImageSegDir fileNames do: [:theName | "copy all segment files"
				newImageSegDir 
					copyFileNamed: oldImageSegDir pathName, FileDirectory slash, theName 
					toFileNamed: theName]]].
	self snapshot: true andQuit: false.
! !


