'From Squeak 2.1 of June 30, 1998 on 15 July 1998 at 11:45:31 pm'!
"Change Set:		fileListTweaks
Date:			15 July 1998
Author:			Lex Spoon

A couple of tweaks to FileList's:

  1) menu item to create directories
  2) directories are listed first, no matter what the sort order


It relies on the DirectoryEntry changeset, but doesn't have to."!


!FileList methodsFor: 'volume list and pattern' stamp: 'ls 7/15/1998 22:18'!
listForPattern: pat
	"Make the list be those file names which match the pattern."
	| entries sizePad newList allFiles sortBlock |
	entries _ directory entries.
	sizePad _ (entries inject: 0 into: [:mx :entry | mx max: (entry at: 5)])
					asStringWithCommas size - 1.

	"create block to decide what order to display the entries"
	sortBlock _ [ :x :y |
			(x isDirectory = y isDirectory) 
				ifTrue: [  
					"sort by user-specified criterion"
					sortMode = #name 
						ifTrue: [(x name compare: y name) <= 2]
						ifFalse: [ sortMode = #date
							ifTrue: [ x modificationTime = y modificationTime
									ifTrue: [ (x name compare: y name) <= 2 ]
									ifFalse: [ x modificationTime > y modificationTime ] ]
							ifFalse: [ "size"
								x size = y size 
									ifTrue: [ (x name compare: y name) <= 2 ]
									ifFalse: [ x fileSize > y fileSize ] ] ] ]
				ifFalse: [
					"directories always precede files"
					x isDirectory ] ].

	newList _ (SortedCollection new: 30) sortBlock: sortBlock.

	allFiles _ pat = '*'.
	entries do:
		[:entry | "<dirflag><name><creationTime><modificationTime><fileSize>"
		(allFiles or: [pat match: entry first]) ifTrue:
			[newList add: entry]].

	newList _ newList collect: [ :e | self fileNameFormattedFrom: e sizePad: sizePad ].

	volList size = 1 ifTrue:
		["Include known servers along with other desktop volumes" 
		^ newList asArray ,
		(ServerDirectory serverNames collect: [:n | '^' , n , self folderString])].
	^ newList asArray.! !

!FileList methodsFor: 'file list menu' stamp: 'ls 7/15/1998 20:59'!
addNewDirectory
	"Add a new directory and update the list"
	| newName index ending |
	self okToChange ifFalse: [^ self].
	newName _ (FillInTheBlank request: 'New Directory Name?'
 					initialAnswer: 'DirectoryName') asFileName.
	Cursor wait showWhile: [
		(directory createDirectory: newName)].
	self updateFileList.
	index _ list indexOf: newName.
	index = 0 ifTrue: [ending _ ') ',newName.
		index _ list findFirst: [:line | line endsWith: ending]].
	self fileListIndex: index.
! !

!FileList methodsFor: 'file list menu' stamp: 'ls 7/15/1998 21:00'!
fileSelectedMenu: aMenu

	^ aMenu
		labels:
'fileIn
file into new change set
browse changes
copy name to clipboard
open image in a window
read image into GIFImports
play midi file
sort by name
sort by size
sort by date
rename
delete
add new file
add new directory
broadcast as update'
		lines: # (4 6 7 11)
		selections: #(fileInSelection fileIntoNewChangeSet browseChanges  copyName
openImageInWindow importImage playMidiFile sortByName sortBySize sortByDate renameFile deleteFile addNewFile addNewDirectory putUpdate)
! !

!FileList methodsFor: 'file list menu' stamp: 'ls 7/15/1998 20:59'!
noFileSelectedMenu: aMenu

	^ aMenu
		labels:
'sort by name
sort by size
sort by date
add new file
add new directory'
		lines: # (3)
		selections: #(sortByName sortBySize sortByDate addNewFile addNewDirectory)
! !


