'From Squeak2.6 of 11 October 1999 [latest update: #1600] on 9 November 1999 at 1:38:45 pm'!
"Change Set:		SliderColor
Date:			9 November 1999
Author:			Dan Ingalls

This supports specification of a color for slider handles, apart from that of the slider as a whole.
Mainly used in MIDI scorePlayers.
"!

MorphicModel subclass: #Slider
	instanceVariableNames: 'slider value setValueSelector sliderShadow sliderColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!ScorePlayerMorph methodsFor: 'layout' stamp: 'di 11/9/1999 13:30'!
panAndVolControlsFor: trackIndex

	| volSlider panSlider c r middleLine pianoRollColor |
	pianoRollColor _ (Color wheel: scorePlayer score tracks size) at: trackIndex.
	volSlider _ SimpleSliderMorph new
		color: color;
		sliderColor: pianoRollColor;
		extent: 101@2;
		target: scorePlayer;
		arguments: (Array with: trackIndex);
		actionSelector: #volumeForTrack:put:;
		minVal: 0.0;
		maxVal: 1.0;
		adjustToValue: (scorePlayer volumeForTrack: trackIndex).
	panSlider _ volSlider fullCopy
		actionSelector: #panForTrack:put:;
		minVal: 0.0;
		maxVal: 1.0;		
		adjustToValue: (scorePlayer panForTrack: trackIndex).
	c _ AlignmentMorph newColumn
		color: color;
		inset: 0;
		centering: #center;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	middleLine _ Morph new  "center indicator for pan slider"
		color: (Color r: 0.4 g: 0.4 b: 0.4);
		extent: 1@(panSlider height - 4);
		position: panSlider center x@(panSlider top + 2).
	panSlider addMorphBack: middleLine.
	r _ self makeRow.
	r addMorphBack: (StringMorph contents: '0').
	r addMorphBack: volSlider.
	r addMorphBack: (StringMorph contents: '10').
	c addMorphBack: r.
	r _ self makeRow.
	r addMorphBack: (StringMorph contents: 'L').
	r addMorphBack: panSlider.
	r addMorphBack: (StringMorph contents: 'R').
	c addMorphBack: r.
	^ c
! !

!ScorePlayerMorph methodsFor: 'layout' stamp: 'di 11/9/1999 13:30'!
rateControl

	| rateSlider middleLine r |
	rateSlider _ SimpleSliderMorph new
		color: color;
		sliderColor: Color gray;
		extent: 180@2;
		target: self;
		actionSelector: #setLogRate:;
		minVal: -1.0;
		maxVal: 1.0;
		adjustToValue: 0.0.
	middleLine _ Morph new  "center indicator for pan slider"
		color: (Color r: 0.4 g: 0.4 b: 0.4);
		extent: 1@(rateSlider height - 4);
		position: rateSlider center x@(rateSlider top + 2).
	rateSlider addMorphBack: middleLine.
	r _ self makeRow
		hResizing: #shrinkWrap;
		vResizing: #rigid;
		height: 24.
	r addMorphBack: (StringMorph contents: 'slow ').
	r addMorphBack: rateSlider.
	r addMorphBack: (StringMorph contents: ' fast').
	^ r
! !

!ScorePlayerMorph methodsFor: 'layout' stamp: 'di 11/9/1999 13:30'!
scrollControl

	| r |
	scrollSlider _ SimpleSliderMorph new
		color: color;
		sliderColor: Color gray;
		extent: 360@2;
		target: scorePlayer;
		actionSelector: #positionInScore:;
		adjustToValue: scorePlayer positionInScore.
	r _ self makeRow
		hResizing: #shrinkWrap;
		vResizing: #rigid;
		height: 24.
	r addMorphBack: (StringMorph contents: 'start ').
	r addMorphBack: scrollSlider.
	r addMorphBack: (StringMorph contents: ' end').
	^ r
! !

!ScorePlayerMorph methodsFor: 'layout' stamp: 'di 11/9/1999 13:30'!
volumeControl

	| volumeSlider r |
	volumeSlider _ SimpleSliderMorph new
		color: color;
		sliderColor: Color gray;
		extent: 80@2;
		target: scorePlayer;
		actionSelector: #overallVolume:;
		adjustToValue: scorePlayer overallVolume.
	r _ self makeRow
		hResizing: #shrinkWrap;
		vResizing: #rigid;
		height: 24.
	r addMorphBack: (StringMorph contents: 'soft  ').
	r addMorphBack: volumeSlider.
	r addMorphBack: (StringMorph contents: ' loud').
	^ r
! !


!Slider methodsFor: 'initialize' stamp: 'di 11/9/1999 13:31'!
initializeSlider
	slider := RectangleMorph newBounds: self totalSliderArea color: self sliderColor.
	sliderShadow := RectangleMorph newBounds: self totalSliderArea
						color: self pagingArea color.
	slider on: #mouseStillDown send: #scrollAbsolute: to: self.
	slider on: #mouseDown send: #mouseDownInSlider: to: self.
	slider on: #mouseUp send: #mouseUpInSlider: to: self.
	slider setBorderWidth: 1 borderColor: #raised.
	sliderShadow setBorderWidth: 1 borderColor: #inset.
	"(the shadow must have the pagingArea as its owner to highlight properly)"
	self pagingArea addMorph: sliderShadow.
	sliderShadow hide.
	self addMorph: slider.
	self computeSlider.
! !

!Slider methodsFor: 'access' stamp: 'di 11/9/1999 13:25'!
sliderColor

	sliderColor ifNil: [^ Color veryLightGray].
	^ sliderColor! !

!Slider methodsFor: 'access' stamp: 'di 11/9/1999 13:29'!
sliderColor: newColor

	sliderColor _ newColor! !

!Slider methodsFor: 'other events' stamp: 'di 11/9/1999 13:35'!
mouseDownInSlider: event
	slider color: self sliderColor lighter.
	sliderShadow bounds: slider bounds.
	sliderShadow show.! !

!Slider methodsFor: 'other events' stamp: 'di 11/9/1999 13:33'!
mouseUpInSlider: event
	slider color: self sliderColor.
	sliderShadow hide.! !


SimpleSliderMorph removeSelector: #sliderColor:!
