'From Squeak2.6 of 11 October 1999 [latest update: #1559] on 10 November 1999 at 4:13:39 pm'!
"Change Set:		WnldDup
Date:			10 November 1999
Author:			Andreas Raab

Make the green duplication halo work in Wonderland."!


!Wonderland methodsFor: 'creating' stamp: 'ar 11/10/1999 15:34'!
duplicateActor: anActor
	"Creates a new actor without any geometry"
	| newActor |
	newActor _ anActor clone postCopy.
	anActor getParent == nil ifFalse:[
		anActor getParent addChild: newActor.
		newActor setParent: anActor getParent].
	newActor setName: anActor getName,'2'.
	scriptEditor updateActorBrowser.

	"Add an undo item to undo the creation of this object"
	myUndoStack push: (UndoAction new: [ newActor removeFromScene.
						 					scriptEditor updateActorBrowser. ]).

	^ newActor.
! !


!WonderlandActor methodsFor: 'private' stamp: 'ar 11/10/1999 15:30'!
postCopy
	| props |
	composite _ composite copy.
	scaleMatrix _ scaleMatrix copy.
	props _ myProperties.
	myProperties _ nil.
	props = nil ifFalse:[
		props keysAndValuesDo:[:k :v| self setProperty: k toValue: v]].! !


!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'ar 11/10/1999 15:17'!
addHandlesTo: aHaloMorph box: box
	| dismissHandle s lab |
	s _ aHaloMorph handleSize.
	myActor getTexturePointer == nil ifFalse:[
		aHaloMorph addHandleAt: box rightCenter color: Color lightGray on: #mouseDown send: #extractTexture: to: aHaloMorph target].

	aHaloMorph addHandleAt: box topLeft color: Color red
		on: #mouseDown send: #doMenu:with: to: aHaloMorph.

	aHaloMorph addHandleAt: (box leftCenter + (0 @ (s+2)) min: box leftCenter + box bottomLeft // 2)
		color: Color lightBrown
		on: #mouseDown send: #yourself "#tearOffTile" to: self.

	dismissHandle _ aHaloMorph addHandleAt: (box topLeft + ((s+2)@0) min: box topLeft + box topCenter // 2)
		color: Color red muchLighter
		on: #mouseDown send: #mouseDownInDimissHandle:with: to: aHaloMorph.
	dismissHandle on: #mouseUp send: #maybeDismiss:with: to: aHaloMorph.
	dismissHandle on: #mouseStillDown send: #setDismissColor:with: to: aHaloMorph.
	dismissHandle addMorphBack: (lab _ StringMorph contents: 'X' font: ScriptingSystem fontForScriptorButtons).
	lab position: dismissHandle position + (4 @ 0).
	lab lock.

	aHaloMorph addHandleAt: box leftCenter color: Color cyan
		on: #mouseDown send: #yourself "#openViewerForArgument" to: self.

	aHaloMorph addHandleAt: box topCenter color: Color black
		on: #mouseDown send: #grabFromHalo:with: to: self.

	(aHaloMorph addHandleAt: (box topCenter + ((s+2)@0) min: box topCenter + box topRight // 2)
		color: Color brown
		on: #mouseDown send: #dragStartFromHalo:with: to: self)
		on: #mouseStillDown send: #dragMoveFromHalo:with: to: self;
		on: #mouseUp send: #dragEndFromHalo:with: to: self.

	(aHaloMorph addHandleAt: box topRight color: Color green
		on: #mouseDown send: #dupStartFromHalo:with: to: self)
		on: #mouseStillDown send: #dupMoveFromHalo:with: to: self;
		on: #mouseUp send: #dupEndFromHalo:with: to: self.

	Preferences showDebugHaloHandle ifTrue:
		[aHaloMorph addHandleAt: ((box topRight + box rightCenter) // 2)
			color: Color blue veryMuchLighter
			on: #mouseDown send: #doDebug:with: to: aHaloMorph].

	(aHaloMorph addHandleAt: box bottomLeft color: Color blue
		on: #mouseDown send: #rotateStartFromHalo:with: to: self)
		on: #mouseStillDown send: #rotateMoveFromHalo:with: to: self;
		on: #mouseUp send: #rotateEndFromHalo:with: to: self.

	(aHaloMorph addHandleAt: box bottomRight color: Color yellow
		on: #mouseDown send: #growStartFromHalo:with: to: self)
		on: #mouseStillDown send: #growMoveFromHalo:with: to: self;
		on: #mouseUp send: #growEndFromHalo:with: to: self.
! !

!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'ar 11/10/1999 15:36'!
balloonHelpTextForHandle: aHandle
	|  itsSelector |
	itsSelector _ aHandle eventHandler firstMouseSelector.
	#(	(rotateStartFromHalo:with:				'Rotate')
		(growStartFromHalo:with:				'Change size') 
		(dupStartFromHalo:with:				'Duplicate')
		(grabFromHalo:with:				'Pick up')
		(dragStartFromHalo:with:				'Move')
		(extractTexture:							'Extract texture')
	) do:
		[:pair | itsSelector == pair first ifTrue: [^ pair last]].
	^super balloonHelpTextForHandle: aHandle! !

!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'ar 11/10/1999 15:32'!
dupEndFromHalo: evt with: handle
	^self dragEndFromHalo: evt with: handle! !

!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'ar 11/10/1999 15:16'!
dupMoveFromHalo: evt with: handle
	^self dragMoveFromHalo: evt with: handle! !

!WonderlandWrapperMorph methodsFor: 'handles' stamp: 'ar 11/10/1999 15:16'!
dupStartFromHalo: evt with: handle
	| newActor |
	self removeAllHandlesBut: handle.
	newActor _ myWonderland duplicateActor: myActor.
	myActor _ newActor.
	self dragPositionOffset: handle center - self positionInWorld.! !


WonderlandWrapperMorph removeSelector: #dupFromHalo:with:!
