'From Squeak2.6 of 11 October 1999 [latest update: #1613] on 21 November 1999 at 4:18:11 pm'!
"Change Set:		BalancedStack
Date:			19 November 1999
Author:			Dan Ingalls

Removes an age-old feature in Squeak that elides pops before some returns to save code.  This expands code in the system by about 1500 bytecodes (about 0.1%), but it leaves the stack balanced.  If Jitter is happy I am happy.

naturally you need to execute...
	Smalltalk recompileAllFrom: 'Aardvark'.
...to see the benefit of this change.

The bizarre inclusion of a change to TextStyle>>veryDeepCopyWith: is because the stack-proper code causes the null statement '#veryDeepCopyWith:.' to generate no code and hence to fail a test it was put there to satisfy.  It ain't pretty, but it had to be fixed.
 "!


!BlockNode methodsFor: 'code generation' stamp: 'di 11/19/1999 19:32'!
emitExceptLast: stack on: aStream
	| nextToLast |
	nextToLast _ statements size - 1.
	nextToLast < 1 ifTrue: [^ self].  "Only one statement"
	1 to: nextToLast do:
		[:i | (statements at: i) emitForEffect: stack on: aStream].
! !

!BlockNode methodsFor: 'code generation' stamp: 'di 11/19/1999 19:44'!
emitForEvaluatedValue: stack on: aStream
	self emitExceptLast: stack on: aStream.
	statements last emitForValue: stack on: aStream.
! !

!BlockNode methodsFor: 'code generation' stamp: 'di 11/19/1999 19:33'!
sizeExceptLast: encoder
	| codeSize nextToLast |
	nextToLast _ statements size - 1.
	nextToLast < 1 ifTrue: [^ 0]. "Only one statement"
	codeSize _ 0.
	1 to: nextToLast do: 
		[:i | codeSize _ codeSize + ((statements at: i) sizeForEffect: encoder)].
	^ codeSize! !


!TextStyle methodsFor: 'Disk I/O' stamp: 'di 11/19/1999 20:12'!
veryDeepCopyWith: deepCopier
	"All inst vars are meant to be shared"

	self == #veryDeepCopyWith:.	"to satisfy checkVariables"
	^ deepCopier references at: self ifAbsent: [
		deepCopier references at: self put: self clone].	"remember"! !


ParseNode removeSelector: #prefersValue!
MessageNode removeSelector: #prefersValue!
