'From Squeak2.6 of 11 October 1999 [latest update: #1684] on 1 December 1999 at 4:18:40 pm'!
"Change Set:		reorderChangeSets-sw
Date:			1 December 1999
Author:			Scott Wallace

Provides a simple do-it that will change the order of change sets, allowing the system-defined changesets and numbered updates to occur beneath other change sets in change sorters.

You can invoke this facility at any time by evaluating:

	ChangeSorter reorderChangeSets.

Also, for convenience, adds that very phrase to the bottom of the 'do' menu.  And makes it more convenient for other items to be similarly added by implementing Utilities.appendToCommonRequests:"!


!ChangeSorter class methodsFor: 'as yet unclassified' stamp: 'sw 12/1/1999 15:59'!
reorderChangeSets
	"ChangeSorter reorderChangeSets"
	"Change the order of the change sets to something more convenient:
		First come the unnumbered changesets that come with the release.
		Next come the numbered updates.
		Next come all remaining changesets
	In a ChangeSorter, they will appear in the reversed order."

	| newHead newMid newTail itsName |

	self gatherChangeSets.
	newHead _ OrderedCollection new.
	newMid _ OrderedCollection new.
	newTail _ OrderedCollection new.
	AllChangeSets do:
		[:aSet |
			itsName _ aSet name.
			((itsName beginsWith:  'Play With Me') or: [#('New Changes' 'MakeInternal') includes: itsName])
				ifTrue:
					[newHead add: aSet]
				ifFalse:
					[itsName startsWithDigit
						ifTrue:
							[newMid add: aSet]
						ifFalse:
							[newTail add: aSet]]].
	AllChangeSets _ newHead, newMid, newTail! !


!Utilities class methodsFor: 'common requests' stamp: 'sw 12/1/1999 16:09'!
appendToCommonRequests: aString
	self commonRequestStrings: (CommonRequestStrings contents, String cr, aString)

"Utilities appendToCommonRequests: 'self beep'"
! !


"Postscript:"
Utilities appendToCommonRequests: 'ChangeSorter reorderChangeSets'.!

