'From Squeak2.7 of 5 January 2000 [latest update: #1762] on 7 January 2000 at 8:06:42 am'!
"Change Set:		FileDirectoryFix
Date:			7 January 2000
Author:			Andrew C. Greenberg

Fixes a bug, introduced in 2.7alpha, in FileDirectory>>fullNameFor:  This message formerly threw a notifier when sent to a root directory.  This fixes the apparent bug in StandardFileMenu that could be found by selecting open->file... from the main menu, and then selecting the root directory."!


!FileDirectory methodsFor: 'file name utilities' stamp: 'acg 1/7/2000 08:00'!
fullNameFor: fileName
	"Return a corrected, fully-qualified name for the given file name. If the given name is already a full path (i.e., it contains a delimiter character), assume it is already a fully-qualified name. Otherwise, prefix it with the path to this directory. In either case, correct the local part of the file name."
	"Details: Note that path relative to a directory, such as '../../foo' are disallowed by this algorithm."
	| correctedLocalName prefix |
	self class splitName: fileName to:
		[:filePath :localName |
			correctedLocalName _ localName isEmpty 
				ifFalse: [self checkName: localName fixErrors: true]
				ifTrue: [localName].
			prefix _ self fullPathFor: filePath].
	prefix isEmpty
		ifTrue: [^correctedLocalName].
	prefix last = self pathNameDelimiter
		ifTrue:[^ prefix, correctedLocalName]
		ifFalse:[^ prefix, self slash, correctedLocalName]! !


