'From Squeak2.8alpha of 13 January 2000 [latest update: #1873] on 23 February 2000 at 11:53:04 pm'!
"Change Set:		cleanup-tkNE
Date:			23 February 2000
Author:			Ted Kaehler

Defines (SmartRefStream cleanUpCategories) to remove obsolete conversion methods.  
Includes 29 removals or currently obsolete conversion methods."!


!SmartRefStream class methodsFor: 'as yet unclassified' stamp: 'tk 2/23/2000 23:44'!
cleanUpCategories
	| list valid removed newList newVers |
	"Look for all conversion methods that can't be used any longer.  Delete them."
	" SmartRefStream cleanUpCategories "

	"Two part selectors that begin with convert and end with a digit."
	"convertasossfe0: varDict asossfeu0: smartRefStrm"
	list _ Symbol selectorsContaining: 'convert'.
	list _ list select: [:symb | (symb beginsWith: 'convert') & (symb allButLast last isDigit)
				ifTrue: [(symb numArgs = 2)]
				ifFalse: [false]].
	valid _ 0.  removed _ 0.
	list do: [:symb |
		(Smalltalk allClassesImplementing: symb) do: [:newClass |
			newList _ (Array with: newClass classVersion), (newClass allInstVarNames).
			newVers _ self new versionSymbol: newList.
			(symb endsWith: (':',newVers,':')) 
				ifFalse: [
					"method is useless because can't convert to current shape"
					newClass removeSelector: symb.	"get rid of it"
					removed _ removed + 1]
				ifTrue: [valid _ valid + 1]]].
	Transcript cr; show: 'Removed: '; print: removed; 
		show: '		Kept: '; print: valid; show: ' '.! !


CodeHolder removeSelector: #convertdcs0:dcscm0:!
Morph removeSelector: #convertbosfce0:bosfcep0:!
Morph removeSelector: #convertbosfcep0:bosfcepc0:!
BookMorph removeSelector: #convertbosfcepbbochvimolppccs0:bosfcepbbochvimolppcc0:!
BookMorph removeSelector: #convertbosfcepbbochvimolppcc0:bosfcepcbbochvimolppccn0:!
BookMorph removeSelector: #convertbosfcepcbbochvimolppcc0:bosfcepcbbochvimolppccn0:!
GraphMorph removeSelector: #convertbosfcebbddcccsmmc0:bosfcebbddcccsmmc0:!
GraphMorph removeSelector: #convertbosfcebbddcccsmmcll0:bosfcebbddcccsmmc0:!
NewParagraph removeSelector: #convertttfclpm0:ttfclpom0:!
PasteUpMorph removeSelector: #convertbosfcepcbbfgccpmcpbttloiairfidcuw0:bosfcepcbbfgccpmcpbttloiairfidcu0:!
PasteUpMorph removeSelector: #convertbosfcepc0:bosfcepcbbfgccpmcpbttloiairfidcu0:!
PasteUpMorph removeSelector: #convertbosfcephvcdslm0:bosfcepcbbfgccpmcpbttloiairfidcuhavcdslp0:!
PasteUpMorph removeSelector: #convertbosfcep0:bosfcepcbbfgccpmcpbttloiairfidcu0:!
PasteUpMorph removeSelector: #convertbosfcepcbbfgcc0:bosfcepcbbfgccpmcpbttloiairfidcu0:!
PasteUpMorph removeSelector: #convertbosfcebbfgccpmcpbttloiairfidcuwhavcdsllb0:bosfcebbfgccpmcpbttloiairfidcuwhavcdsll0:!
PasteUpMorph removeSelector: #convertbosfcebbfgccpmcpbttloiairfidcuw0:bosfcebbfgccpmcpbttloiairfidcuwp0:!
PasteUpMorph removeSelector: #convertbosfcepcbbfgccpmcpbttloiairfidcuwhavcdslp0:bosfcepcbbfgccpmcpbttloiairfidcuwhavcdslpl0:!
PluggableListMorph removeSelector: #convertbosfcebbmsopssrsggslssggska0:bosfcebbmsopssrsggslssggskaf0:!
PluggableListMorph removeSelector: #convertbosfcebbmsopssrsggslssggskafll0:bosfcebbmsopssrsggslssggskafllvs0:!
Presenter removeSelector: #convertassgbmsfcvsssspbb0:assgmsfcvsssspbb0:!
Project removeSelector: #convertdwctppdaevt0:dwctppdaevtngpiicmo0:!
Project removeSelector: #convertdwctppdaevtngp0:dwctppdaevtngpiicmo0:!
Project removeSelector: #convertdwctppdaevt0:dwctppdaevtn0:!
SoundRecorder removeSelector: #convertssrrbpmmscn0:ssrrrbpmmscn0:!
SystemWindow removeSelector: #convertbosfcebbmsolslccappcfim0:bosfcebbmsolslccappcfimm0:!
TextMorph removeSelector: #convertbosfcepttwpe0:bosfcepttwpecps0:!
TextMorph removeSelector: #convertbosfceptthpeh0:bosfcepttwpe0:!
TextStyle removeSelector: #convertfflbafrrtml0:fflbafrrtmldt0:!
UpdatingStringMorph removeSelector: #convertbosfcefechftlgpfgs0:bosfcefechftlgpfgsa0:!
