'From Squeak2.8alpha of 13 January 2000 [latest update: #1875] on 28 February 2000 at 10:59:11 am'!
"Change Set:		more-tkNL
Date:			28 February 2000
Author:			Ted Kaehler

Update 1860 added debugging class variables to ImageSegmentRootStub.  They allow the user to see the stack of what caused a segment fault.  Very useful.  However, the new class variables were never defined in the fileOut.  Nor were they initialized.  Any fault caused an error.  We fix it here."!

ProtoObject subclass: #ImageSegmentRootStub
	instanceVariableNames: 'shadowSuper shadowMethodDict shadowFormat imageSegment '
	classVariableNames: 'FaultLogs LoggingFaults '
	poolDictionaries: ''
	category: 'System-Object Storage'!

!FileDirectory methodsFor: 'file operations' stamp: 'tk 2/26/2000 12:54'!
putFile: file1 named: destinationFileName retry: aBool
	"Copy the contents of the existing fileStream into the file destinationFileName in this directory.  fileStream can be anywhere in the fileSystem.  No retrying for local file systems."

	^ self putFile: file1 named: destinationFileName
! !


!ImageSegmentRootStub methodsFor: 'fetch from disk' stamp: 'tk 2/28/2000 10:50'!
doesNotUnderstand: aMessage 
	 "Any normal message sent to this object is really intended for another object that is in a non-resident imageSegment.  Reinstall the segment and resend the message."

	imageSegment install.
	LoggingFaults ifTrue:		"Save the stack printout to show who caused the fault"
		[FaultLogs at: Time millisecondClockValue printString
			put: (String streamContents:
				[:strm | 
				strm print: self class; space; print: aMessage selector; cr.
				(thisContext sender stackOfSize: 30)
					do: [:item | strm print: item; cr]])].

	"NOTE:  The following should really be (aMessage sentTo: self)
		in order to recover properly from a fault in a super-send,
		however, the lookupClass might be bogus in this case, and it's
		almost unthinkable that the first fault would be a super send."
	^ self perform: aMessage selector withArguments: aMessage arguments! !


"Postscript:
Now that we have logging ability, initialize it (off), so it won't cause an error."

ImageSegmentRootStub compileAll.
ImageSegmentRootStub dontLogFaults.!

