'From Squeak2.8alpha of 12 January 2000 [latest update: #2139] on 16 May 2000 at 10:23:07 pm'!
"Change Set:		WatchTweaks
Date:			16 May 2000
Author:			Dan Ingalls

A TerseMan pass over the WatchMorph.
Lots of code went away by defining radius:hourAngle:
"!


!WatchMorph commentStamp: 'di 5/16/2000 21:59' prior: 0!
This class is a representation of a watch.
The labels' font is changeble. Labels' font size increase or decrease when resizing me.

WatchMorph new openInWorld
(WatchMorph fontName: 'ComicPlain') openInWorld		" transparent "
(WatchMorph fontName: 'ComicBold' bgColor: Color white centerColor: Color black) openInWorld

Structure:
 fontName		String -- the labels' font name
 cColor			Color -- center color
 handsColor		Color!

!WatchMorph methodsFor: 'initialization' stamp: 'di 5/16/2000 21:18'!
extent: newExtent

	super extent: newExtent.
	self createLabels! !

!WatchMorph methodsFor: 'initialization' stamp: 'di 5/16/2000 21:55'!
initialize  "Establish all default parameters..."
	super initialize.
	self color: Color green.
	self handsColor: Color red.
	self centerColor: Color gray.
	romanNumerals _ false.
	fontName _ 'NewYork'.
	self extent: 130@130.
	self start.! !

!WatchMorph methodsFor: 'accessing' stamp: 'di 5/16/2000 21:45'!
fontName: aString

	fontName _ aString.
	self createLabels! !

!WatchMorph methodsFor: 'labels' stamp: 'di 5/16/2000 21:42'!
createLabels

	| numeral font h r |
	self removeAllMorphs.
	font _ StrikeFont familyName: fontName size: (h _ self height min: self width)//8.
	r _ 1.0 - (1.4 * font height / h).
	1 to: 12 do:
		[:hour |
		numeral _ romanNumerals
			ifTrue: [#('I' 'II' 'III' 'IV' 'V' 'VI' 'VII' ' VIII' 'IX' 'X' 'XI' 'XII') at: hour]
			ifFalse: [hour asString].
		self addMorphBack: ((StringMorph contents: numeral font: font emphasis: 1)
			center: (self radius: r hourAngle: hour)) lock].
! !

!WatchMorph methodsFor: 'drawing' stamp: 'di 5/16/2000 21:16'!
drawOn: aCanvas
	| pHour pMin pSec time |
	time _ Time now.
	pHour _ self radius: 0.6 hourAngle: time hours + (time minutes/60.0).
	pMin _ self radius: 0.72 hourAngle: (time minutes / 5.0) + (time seconds / 300.0).
	pSec _ self radius: 0.8 hourAngle: (time seconds / 5.0).
	aCanvas fillOval: bounds color: color;
			 fillOval: (bounds insetBy: self extent*0.35) color: cColor;
			 frameOval: bounds width: 1 color: Color gray;
			 line: self center to: pHour width: 3 color: handsColor;
			 line: self center to: pMin width: 2 color: handsColor;
			 line: self center to: pSec width: 1 color: handsColor.
! !

!WatchMorph methodsFor: 'menus' stamp: 'di 5/16/2000 21:48'!
changeFont

	self fontName: ((SelectionMenu labelList: StrikeFont familyNames
							selections: StrikeFont familyNames) startUp
					ifNil: [^ self])! !

!WatchMorph methodsFor: 'menus' stamp: 'di 5/16/2000 21:19'!
toggleRoman

	romanNumerals _ romanNumerals not.
	self createLabels! !

!WatchMorph methodsFor: 'private' stamp: 'di 5/16/2000 22:22'!
radius: unitRadius hourAngle: hourAngle
	"unitRadius goes from 0.0 at the center to 1.0 on the circumference.
	hourAngle runs from 0.0 clockwise around to 12.0 with wrapping."

	^ self center + (self extent * (Point r: 0.5 * unitRadius
									degrees: hourAngle * 30.0 - 90.0)).! !


!WatchMorph class methodsFor: 'as yet unclassified' stamp: 'di 5/16/2000 21:43'!
fontName: aString bgColor: aColor centerColor: otherColor
	^ self new
		fontName: aString;
		color: aColor;
		centerColor: otherColor! !

WatchMorph class removeSelector: #initialize!
WatchMorph removeSelector: #alignLabels!
WatchMorph removeSelector: #cColor:!
WatchMorph removeSelector: #color:!
WatchMorph removeSelector: #defaultCenterColor!
WatchMorph removeSelector: #defaultColor!
WatchMorph removeSelector: #defaultExtent!
WatchMorph removeSelector: #defaultHandsColor!
WatchMorph removeSelector: #pointR:hourAngle:!
WatchMorph removeSelector: #radius!

!WatchMorph reorganize!
('initialization' extent: initialize)
('accessing' centerColor: fontName: handsColor:)
('labels' createLabels)
('drawing' drawOn:)
('menus' addCustomMenuItems:hand: changeCenterColor changeFont changeHandsColor toggleRoman)
('private' radius:hourAngle:)
('stepping' step)
!

