'From Squeak2.8alpha of 16 February 2000 [latest update: #2182] on 23 May 2000 at 3:30:32 pm'!
"Change Set:		FontFix-ar
Date:			23 May 2000
Author:			Andreas Raab

Fixes a problem with colored fonts."!


!BitBlt methodsFor: 'private' stamp: 'ar 5/23/2000 15:27'!
installStrikeFont: aStrikeFont foregroundColor: foregroundColor backgroundColor: backgroundColor
	| lastSourceDepth |
	sourceForm ifNotNil:[lastSourceDepth _ sourceForm depth].
	sourceForm _ aStrikeFont glyphs.
	(colorMap notNil and:[lastSourceDepth = sourceForm depth]) ifFalse:
		["Set up color map for a different source depth (color font)"
		"Note this may need some caching for reasonable efficiency"
		colorMap _ (Color cachedColormapFrom: sourceForm depth to: destForm depth) copy.
		colorMap at: 1 put: (backgroundColor pixelValueForDepth: destForm depth)].
	sourceForm depth = 1 ifTrue:
		[colorMap at: 2 put: (foregroundColor pixelValueForDepth: destForm depth).
		"Ignore any halftone pattern since we use a color map approach here"
		halftoneForm _ nil].
	sourceY _ 0.
	height _ aStrikeFont height.
! !


!FormCanvas methodsFor: 'private' stamp: 'ar 5/23/2000 15:21'!
setPaintColor: aColor
	"Install a new color used for filling."
	| paintColor screen patternWord |
	paintColor _ self shadowColor ifNil:[aColor].
	paintColor ifNil:[paintColor _ Color transparent].
	paintColor isColor ifFalse:[
		(paintColor isKindOf: InfiniteForm) ifFalse:[^self error:'Cannot install color'].
		^port fillPattern: paintColor; combinationRule: Form paint].
	"Okay, so paintColor really *is* a color"
	port sourceForm: nil.
	(paintColor isTranslucent) ifFalse:[
		port fillPattern: paintColor.
		port combinationRule: Form paint.
		self depth = 8 ifTrue:[
			port fillColor: (paintColor balancedPatternForDepth: 8)].
		^self].
	self depth < 16 ifTrue:[
		screen _ Color translucentMaskFor: paintColor alpha depth: self depth.
		patternWord _ paintColor pixelWordForDepth: self depth.
		port fillPattern: (screen collect: [:maskWord | maskWord bitAnd: patternWord]).
		^port combinationRule: Form paint].

	port fillPattern: paintColor.
	self depth = 16
		ifTrue:[port alphaBits: paintColor privateAlpha; combinationRule: 31]
		ifFalse:[port combinationRule: Form blend].! !

