'From Squeak2.8alpha of 12 January 2000 [latest update: #2210] on 2 June 2000 at 9:40:50 am'!
"Change Set:		FirstAndLastN
Date:			2 June 2000
Author:			Dan Ingalls

Extends the first/last/allButFirst/allButLast protocol to N items.
Suggested by David N. Smith.
"!


!SequenceableCollection methodsFor: 'accessing' stamp: 'di 6/2/2000 09:18'!
allButFirst
	"Answer all but the first element of the receiver."

	^ self copyFrom: 2 to: self size! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'di 6/2/2000 09:19'!
allButFirst: nElements
	"Answer all but the first N elements of the receiver."

	^ self copyFrom: nElements + 1 to: self size! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'di 6/2/2000 09:20'!
allButLast
	"Answer all but the last element of the receiver."

	^ self copyFrom: 1 to: self size - 1! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'di 6/2/2000 09:20'!
allButLast: nElements
	"Answer all but the last N elements of the receiver."

	^ self copyFrom: 1 to: self size - nElements! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'di 6/2/2000 09:16'!
first
	"Answer the first element of the receiver.
	Raise an error if the collection is empty."

	self size = 0 ifTrue: [self errorEmptyCollection].
	^ self at: 1! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'di 6/2/2000 09:21'!
first: nElements
	"Answer the first N elements of the receiver."

	^ self copyFrom: 1 to: nElements! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'di 6/2/2000 09:15'!
last
	"Answer the last element of the receiver.
	Raise an error if the collection is empty."

	| size |
	(size _ self size) = 0 ifTrue: [self errorEmptyCollection].
	^ self at: size! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'di 6/2/2000 09:23'!
last: nElements
	"Answer the last N elements of the receiver."

	^ self copyFrom: self size - nElements + 1 to: self size! !

OrderedCollection removeSelector: #first!
OrderedCollection removeSelector: #last!
