'From Squeak2.8alpha of 4 February 2000 [latest update: #2310] on 12 June 2000 at 12:59:55 pm'!
"Change Set:		132DndImprovement-sr
Date:			6 June 2000
Author:			Stephan Rudlof

- TransferMorph is grabbed at bottomLeft corner
	- animation starts at correct position;
- less animation artifacts:
	- TransferMorph will be erased at start of animation,
	- also its shadow,
	- the HandMorph, and
	- the CopyPlusIcon.
"!


!DisplayObject methodsFor: 'displaying-Display' stamp: 'sr 6/6/2000 05:37'!
slideWithFirstFrom: startPoint to: stopPoint nSteps: nSteps delay: milliSecs 
	"Slide this object across the display over the given number of steps, 
	pausing for the given number of milliseconds after each step."
	"Note: Does display at the first point and at the last."
	| i p delta |
	i _ 0.
	delta _ stopPoint - startPoint / nSteps asFloat.
	p _ startPoint - delta.
	^ self follow: [(p _ p + delta) truncated]
		while: 
			[(Delay forMilliseconds: milliSecs) wait.
			(i _ i + 1) <= nSteps]! !


!TransferMorph methodsFor: 'private' stamp: 'sr 6/6/2000 07:19'!
animationForMoveSuccess: success 
	| start stop slideForm |
	success
		ifTrue: [^ self]
		ifFalse: 
			[start _ self fullBounds origin.
			stop _ self source bounds origin].
	start = stop ifTrue: [^ self].
	slideForm _ self imageFormForRectangle: ((self fullBounds origin corner: self fullBounds corner + self activeHand shadowOffset)
					merge: self activeHand bounds).
	slideForm offset: 0 @ 0.
	slideForm
		slideWithFirstFrom: start
		to: stop
		nSteps: 12
		delay: 20! !

!TransferMorph methodsFor: 'dropping/grabbing' stamp: 'sr 6/6/2000 05:01'!
aboutToBeGrabbedBy: aHand 
	"The receiver is being grabbed by a hand.                           
	Perform necessary adjustments (if any) and return the actual morph    
	     that should be added to the hand."
	"Since this morph has been initialized automatically with bounds origin   
	     0@0, we have to move it to aHand position."
	self draggedMorph.
	self align: self bottomLeft with: aHand position! !

