'From Squeak2.8alpha of 4 February 2000 [latest update: #2310] on 12 June 2000 at 1:00:22 pm'!
"Change Set:		140CelesteMailer-kfr
Date:			12 June 2000
Author:			Karl Ramberg

Here is an enhancement to MailToUrl that will try to open a CelesteComposer (Mr Postman) if the link you click on is a mail address.

[I picked up the idea and cleaned up the way it is checked for an open Celeste. --sma]"!


!Celeste class methodsFor: 'instance creation' stamp: 'sma 6/12/2000 12:21'!
current
	"Answer the currently active Celeste (assuming that there's
	only one Celeste open at a given time) or open a new one."

	Celeste instanceCount = 0 ifTrue: [self open].
	^ Celeste someInstance! !

!Celeste class methodsFor: 'instance creation' stamp: 'sma 6/12/2000 12:09'!
open
	"Open a MailReader on the default mail database."

	^ self openOn: 'EMAIL'! !


!ChangeSet methodsFor: 'fileIn/Out' stamp: 'sma 6/12/2000 12:20'!
mailOut
	"File out the receiver, to a file whose name is a function of the           
	change-set name and either of the date & time or chosen to have a
	unique numeric tag, depending on the preference
	'sequentialChangeSetRevertableFileNames'."

	| slips messageStrm message compressBuffer compressStream data compressedStream compressTarget |
	(Smalltalk includesKey: #Celeste)
		ifFalse: [^ self notify: 'no mail reader present'].

	self checkForConversionMethods.
	Cursor write
		showWhile: 
			["Prepare the message"
			messageStrm _ WriteStream on: (String new: 30).
			messageStrm nextPutAll: 'From: ';
			 nextPutAll: Celeste userName;
			 cr;
			 nextPutAll: 'To: squeak@cs.uiuc.edu';
			 cr;
			 nextPutAll: 'Subject: [CS] ';
			 nextPutAll: name;
			 cr;
			 nextPutAll: 'from preamble:';
			 cr;
			 cr.
			self fileOutPreambleOn: messageStrm.
			"Prepare the gzipped data"
			message _ MailMessage from: messageStrm contents.
			message _ MailMessage from: message asMultipartText.
			data _ WriteStream on: String new.
			data header.
			self fileOutPreambleOn: data.
			self fileOutOn: data.
			self fileOutPostscriptOn: data.
			data trailer.
			data _ ReadStream on: data contents.
			compressBuffer _ ByteArray new: 1000.
			compressStream _ GZipWriteStream on: (compressTarget _ WriteStream on: (ByteArray new: 1000)).
			[data atEnd]
				whileFalse: [compressStream nextPutAll: (data nextInto: compressBuffer)].
			compressStream close.
			compressedStream _ ReadStream on: compressTarget contents asString.
			CelesteComposition
				openForCeleste: Celeste current 
				initialText: (message asTextEncodingNewPart: compressedStream named: name , '.cs.gz')].
	Preferences suppressCheckForSlips ifTrue: [^ self].
	slips _ self checkForSlips.
	(slips size > 0 and: [self confirm: 'Methods in this fileOut have halts
or references to the Transcript
or other ''slips'' in them.
Would you like to browse them?'])
		ifTrue: [Smalltalk browseMessageList: slips name: 'Possible slips in ' , name]! !


!HandMorph methodsFor: 'world menu commands' stamp: 'sma 6/12/2000 12:10'!
openEmail
	"Open an email interface."

	Celeste open! !


!MailtoUrl methodsFor: 'downloading' stamp: 'sma 6/12/2000 12:15'!
activate
	(Smalltalk includesKey: #Celeste)
		ifFalse: [^ self notify: 'no mail reader present'].
	^ CelesteComposition
		openForCeleste: Celeste current
		initialText: self composeText! !

!MailtoUrl methodsFor: 'downloading' stamp: 'kfr 6/11/2000 16:47'!
composeText
	"Answer the template for a new message."

	^ String streamContents: [:str |
		str nextPutAll: 'From: '.
		str nextPutAll: Celeste userName; cr.
		str nextPutAll: 'To: '.
		str nextPutAll: locator asString; cr.

		str nextPutAll: 'Subject: '; cr.

		Celeste ccList isEmpty ifFalse: [
			str nextPutAll: 'Cc: '.
			str nextPutAll: Celeste ccList; cr].
		str cr].! !

