'From Squeak2.9alpha of 12 June 2000 [latest update: #2554] on 1 September 2000 at 10:25:21 am'!
"Change Set:		TwoFixes-ar
Date:			1 September 2000
Author:			Andreas Raab

#1: A wakeup fix for the Wonderland scheduler.
#2: A 'workaround-fix' for annoying primitive failures in the 3D engine.
"!


!B3DHardwareRasterizer methodsFor: 'processing' stamp: 'ar 9/1/2000 10:22'!
processVertexBuffer: vb
	| box |
	box _ self primProcessVB: vb primitive 
			texture: (target textureHandleOf: texture) 
			vertices: vb vertexArray 
			vertexCount: vb vertexCount 
			faces: vb indexArray 
			faceCount: vb indexCount.
	^box ifNotNil:[(box at: 1) @ (box at: 2) corner: (box at: 3) @ (box at: 4)]! !

!B3DHardwareRasterizer methodsFor: 'primitives' stamp: 'ar 9/1/2000 10:23'!
primProcessVB: primitiveType texture: textureHandle vertices: vtxArray vertexCount: vtxCount faces: idxArray faceCount: idxCount
	<primitive:'primitiveProcessVertexBuffer' module:'Squeak3DX'>
	"There's a bug somewhere in the primitive code leading to failures every now and then which can be safely ignored since the next frame will almost always be fine. I need to track this down but it takes time and these primitive failures are annoying..."
	^nil! !


!Scheduler methodsFor: 'ticking' stamp: 'ar 9/1/2000 10:24'!
tick
	"Figure out how much time has elapsed since the last Scheduler tick and update all our actions, alarms, and animations"
	| deltaTime |
	isRunning ifTrue: [
		deltaTime _ (Time millisecondClockValue / 1000.0) - lastSystemTime.
		"See if the clock rolled over or the scheduler has been put to sleep for too long"
		(deltaTime < 0.0 or:[deltaTime > 2.0]) ifTrue:[
			"adjust for extra time"
			lastSystemTime _ (Time millisecondClockValue - 1) / 1000.0.
			deltaTime _ 1.0 / 1000.0].
		elapsedTime _ deltaTime * speed.
		currentTime _ currentTime + elapsedTime.
		lastSystemTime _ lastSystemTime + elapsedTime.
	
		self processAlarms.
		self processAnimations.
		self processActions.
	].
! !

