'From Squeak2.9alpha of 12 June 2000 [latest update: #2575] on 8 September 2000 at 4:04:46 pm'!
"Change Set:		FixArrows-nk
Date:			2 September 2000
Author:			Ned Konz

This change set fixes the arrow offset caused by bad geometry, and factors out the arrow shape so that it can be overridden by subclasses."!


!PolygonMorph methodsFor: 'drawing' stamp: 'nk 9/2/2000 11:09'!
drawArrowOn: aCanvas at: endPoint from: priorPoint 
	"Draw a triangle oriented along the line from priorPoint to  
	endPoint."
	| pts |
	pts _ self arrowBoundsAt: endPoint from: priorPoint.
	aCanvas drawPolygon: pts fillStyle: borderColor! !

!PolygonMorph methodsFor: 'private' stamp: 'di 9/8/2000 15:41'!
arrowBoundsAt: endPoint from: priorPoint 
	"Compute a triangle oriented along the line from priorPoint to endPoint."
	| d v angle |
	d _ borderWidth max: 1.
	v _ endPoint - priorPoint.
	angle _ v theta radiansToDegrees.
	^  { endPoint + (Point r: d * 5 degrees: angle).
		endPoint + (Point r: d * 4 degrees: angle + 135.0).
		endPoint + (Point r: d * 4 degrees: angle - 135.0) }! !

!PolygonMorph methodsFor: 'private' stamp: 'nk 9/2/2000 11:09'!
computeArrowFormAt: endPoint from: priorPoint 
	"Compute a triangle oriented along the line from priorPoint to  
	endPoint. Then draw those lines in a form and return that  
	form, with appropriate offset"
	| p1 pts box arrowForm bb origin  |
	pts _ self arrowBoundsAt: endPoint from: priorPoint.
	box _ ((pts first rect: pts last)
				encompass: (pts at: 2))
				expandBy: 1.
	arrowForm _ Form extent: box extent asIntegerPoint.
	bb _ (BitBlt current toForm: arrowForm) sourceForm: nil;
				 fillColor: Color black;
				 combinationRule: Form over;
				 width: 1;
				 height: 1.
	origin _ box topLeft.
	p1 _ pts last - origin.
	pts
		do: [:p | 
			bb drawFrom: p1 to: p - origin.
			p1 _ p - origin].
	arrowForm convexShapeFill: Color black.
	^ arrowForm offset: box topLeft! !

!PolygonMorph methodsFor: 'private' stamp: 'di 9/8/2000 16:04'!
privateMoveBy: delta 
	super privateMoveBy: delta.
	vertices _ vertices collect: [:p | p + delta].
	self arrowForms do: [:f | f offset: f offset + delta].
	coeffs _ nil.  "Force recomputation"
	ptAfterFirst_ ptBeforeLast_ nil.
! !

