'From Squeak2.9alpha of 13 June 2000 [latest update: #2966] on 7 November 2000 at 2:59:15 pm'!
"Change Set:		OpaqueImages-ar
Date:			7 November 2000
Author:			Andreas Raab

Allow ImageMorphs to be flagged as being opaque so that #drawImage instead of #paintImage is used."!


!ImageMorph methodsFor: 'accessing' stamp: 'ar 11/7/2000 14:57'!
isOpaque
	"Return true if the receiver is marked as being completely opaque"
	extension == nil ifTrue:[^false].
	^self valueOfProperty: #isOpaque ifAbsent:[false]! !

!ImageMorph methodsFor: 'accessing' stamp: 'ar 11/7/2000 14:57'!
isOpaque: aBool
	"Mark the receiver as being completely opaque or not"
	aBool == false
		ifTrue:[self removeProperty: #isOpaque]
		ifFalse:[self setProperty: #isOpaque toValue: aBool].
	self changed! !

!ImageMorph methodsFor: 'drawing' stamp: 'ar 11/7/2000 14:57'!
drawOn: aCanvas
	self isOpaque
		ifTrue:[aCanvas drawImage: image at: bounds origin]
		ifFalse:[aCanvas paintImage: image at: bounds origin]! !

!ImageMorph methodsFor: 'menu' stamp: 'ar 11/7/2000 14:55'!
addCustomMenuItems: aMenu hand: aHand
	super addCustomMenuItems: aMenu hand: aHand.
	aMenu addUpdating: #opacityString action: #changeOpacity! !

!ImageMorph methodsFor: 'menu' stamp: 'ar 11/7/2000 14:57'!
changeOpacity
	self isOpaque: self isOpaque not! !

!ImageMorph methodsFor: 'menu' stamp: 'ar 11/7/2000 14:58'!
opacityString
	^self isOpaque ifTrue:['<on>opaque'] ifFalse:['<off>opaque']! !

