'From Squeak2.9alpha of 17 July 2000 [latest update: #3012] on 15 November 2000 at 2:35:57 pm'!
"Change Set:		limbo
Date:			14 November 2000
Author:			Bob Arning

- try real hard to keep the project thumbnails a reasonable size in the sorter
- provide a different collapse/expand mechanism for sketches
- ensure that InternalThreadNavigationMorphs update themselves is their thread is altered elsewhere"!


!Morph methodsFor: 'menus' stamp: 'RAA 11/14/2000 13:46'!
uncollapseSketch

	| uncollapsedVersion w whomToDelete |

	(w _ self world) ifNil: [^self].
	uncollapsedVersion _ self valueOfProperty: #uncollapsedMorph.
	uncollapsedVersion ifNil: [^self].
	whomToDelete _ self valueOfProperty: #collapsedMorphCarrier.
	uncollapsedVersion setProperty: #collapsedPosition toValue: whomToDelete position.

	whomToDelete delete.
	w addMorphFront: uncollapsedVersion.

! !


!BookPageSorterMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/14/2000 12:10'!
changeExtent: aPoint

	self extent: aPoint.
	pageHolder extent: self extent - borderWidth.

! !


!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/14/2000 19:23'!
addButtonsAlan

	| marginPt i sz data images pageNumber proj f m b1 b2 dot arrowWidth arrowCenter vertices arrowHeight allMorphicProjects nameMorph |

	allMorphicProjects _ Project allMorphicProjects.
	self changeNoLayout.
	self hResizing: #rigid. "... this is very unlikely..."
	self vResizing: #rigid.
	marginPt _ 4@4.
	i _ self currentIndex.
	sz _ 50@40.
	arrowWidth _ 14.
	arrowHeight _ 17.
	data _ {
		{i - 1. 'Previous:'. #previousPage. #rightCenter. arrowWidth negated}.
		{i + 1. 'Next:'. #nextPage. #leftCenter. arrowWidth}
	}.
	images _ data collect: [ :tuple |
		pageNumber _ tuple first.
		((pageNumber between: 1 and: listOfPages size) and: 
				[(proj _ Project named: (listOfPages at: pageNumber) first in: allMorphicProjects) notNil]) ifTrue: [
			f _ proj thumbnail scaledToSize: sz.
			arrowCenter _ f boundingBox perform: tuple fourth.
			vertices _ {
				arrowCenter - (0@arrowHeight).
				arrowCenter + (0@arrowHeight).
				arrowCenter + (tuple fifth @ 0).
			}.
			f getCanvas
				drawPolygon: vertices 
				color: Color orange 
				borderWidth: 0 
				borderColor: Color transparent.
			m _ ImageMorph new image: f.
			m setBalloonText: tuple second,' ',(listOfPages at: pageNumber) first.
			m addMouseUpActionWith: (
				MessageSend receiver: self selector: tuple third
			).
		] ifFalse: [
			f _ (Form extent: sz depth: 16) fillColor: Color lightGray.
			m _ ImageMorph new image: f.
		].
		m
	].
	b1 _ images first.
	b2 _ images second.
	dot _ EllipseMorph new extent: 16@16; color: Color orange lighter; borderWidth: 0.
	self addMorph: (b1 position: self position + marginPt).
	self addMorph: (b2 position: b1 topRight + (marginPt x @ 0)).
	self extent: b2 bottomRight - self position + marginPt.
	self addMorph: dot.
	dot align: dot center with: b1 bounds rightCenter + ((marginPt x @ 0) // 2).
	dot setBalloonText: threadName,'
more commands'.
	dot on: #mouseDown send: #moreCommands to: self.
	self fullBounds.
	self addMorph: (nameMorph _ SquishedNameMorph new).
	nameMorph
		target: self getSelector: #threadName setSelector: nil;
		color: Color transparent;
		width: self width;
		height: 15;
		align: nameMorph bottomLeft with: self bottomLeft.

! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/14/2000 19:23'!
bookOfAllProjects

	BookMorph 
		makeBookOfProjects: Project allMorphicProjects
		named: 'All projects @ ',Time now printString! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/14/2000 12:32'!
editThisThread

	| sz morphsForPageSorter sorter pixelsAvailable pixelsNeeded scale |

	"a bit of fudging to try to outguess the layout mechanism and get best possible scale"
	pixelsAvailable _ Display extent - 130.
	pixelsAvailable _ pixelsAvailable x * pixelsAvailable y.
	pixelsNeeded _ 100@75.
	pixelsNeeded _ pixelsNeeded x * pixelsNeeded y  * listOfPages size.
	scale _ (pixelsAvailable / pixelsNeeded min: 1) sqrt.
	sz _ (100@75 * scale) rounded.

	morphsForPageSorter _ self morphsForMyContentsSizedTo: sz.
	morphsForPageSorter _ morphsForPageSorter reject: [ :each | each isNil].
	sorter _ BookPageSorterMorph new.
	sorter changeExtent: Display extent.

	sorter
		book: self 
		morphsToSort: morphsForPageSorter.
	sorter pageHolder cursor: self currentIndex.
	self currentWorld addMorphFront: sorter.
	sorter align: sorter center with: self currentWorld center.

! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/14/2000 19:25'!
ensureSuitableDefaults

	listOfPages ifNil: [
		listOfPages _ Project allMorphicProjects collect: [ :each | {each name}].
		threadName _ 'all (default)'.
		self class know: listOfPages as: threadName.
	].
	currentIndex ifNil: [currentIndex _ 0].
! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/14/2000 19:23'!
morphsForMyContentsSizedTo: sz

	| allMorphicProjects morphsForPageSorter proj pvm |

	allMorphicProjects _ Project allMorphicProjects.
	'Assembling thumbnail images...'
		displayProgressAt: self cursorPoint
		from: 0 to: listOfPages size
		during: [:bar |
			morphsForPageSorter _ listOfPages withIndexCollect: [ :each :index | 
				bar value: index.
				(proj _ Project named: each first in: allMorphicProjects) ifNil: [
					nil
				] ifNotNil: [
					pvm _ ProjectViewMorph on: proj.
					pvm _ pvm imageForm scaledToSize: sz.
					pvm _ pvm asMorph.
					pvm setProperty: #nameOfThisProject toValue: each first.
					pvm setBalloonText: each first.
					pvm
				]
			].
		].
	^morphsForPageSorter
! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/14/2000 15:15'!
step

	super step.
	self class knownThreads
		at: threadName
		ifPresent: [ :known |
			known == listOfPages ifFalse: [
				listOfPages _ known.
				self removeAllMorphs.
				self addButtons.
			].
		].
! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 11/14/2000 19:24'!
threadOfAllProjects

	| nameList nav |

	nameList _ Project allMorphicProjects collect: [ :each | {each name}].
	nav _ self class basicNew.
	nav
		listOfPages: nameList;
		threadName: '';
		initialize.
	nav editThisThread.
! !


!Project class methodsFor: 'utilities' stamp: 'RAA 11/14/2000 19:14'!
allMorphicProjects

	^ self allProjects select: [:p | p world isMorph]! !


!SketchMorph methodsFor: 'menu' stamp: 'RAA 11/14/2000 13:44'!
collapse
	
	| priorPosition w collapsedVersion a |

	(w _ self world) ifNil: [^self].
	collapsedVersion _ (self imageForm scaledToSize: 50@50) asMorph.
	collapsedVersion setProperty: #uncollapsedMorph toValue: self.
	collapsedVersion on: #mouseUp send: #uncollapseSketch to: collapsedVersion.
	collapsedVersion setBalloonText: 'A collapsed version of ',self name.
			
	self delete.
	w addMorphFront: (
		a _ AlignmentMorph newRow
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap;
			borderWidth: 4;
			borderColor: Color white;
			addMorph: collapsedVersion
	).
	collapsedVersion setProperty: #collapsedMorphCarrier toValue: a.

	(priorPosition _ self valueOfProperty: #collapsedPosition ifAbsent: [nil])
	ifNotNil:
		[a position: priorPosition].
! !

