'From Squeak2.9alpha of 12 June 2000 [latest update: #3046] on 28 November 2000 at 10:44:17 am'!
"Change Set:		CrosticFix
Date:			28 November 2000
Author:			Dan Ingalls

Removes the method minExtent from TextMorph, which had clashed with the new alignment protocol.

Includes two other changes to restore CrosticPanels to operation in the new world.
"!


!CrosticPanel methodsFor: 'initialization' stamp: 'di 11/25/2000 19:17'!
breakColumnAndResizeWithButtons: buttonRow
	| indexToSplit yToSplit |
	"The column of clues has been laid out, and the crostic panel has been resized to that width and embedded as a submorph.  This method breaks the clues in two, placing the long part to the left of the crostic and the short one below it."

	yToSplit _ cluesPanel height + quotePanel height // 2 + self top.
	indexToSplit _ cluesPanel submorphs findFirst: [:m | m bottom > yToSplit].
	cluesCol2 _ AlignmentMorph newColumn color: self color;
		hResizing: #shrinkWrap; vResizing: #shrinkWrap; layoutInset: 0;
		cellPositioning: #topLeft.
	cluesCol2 addAllMorphs: (cluesPanel submorphs copyFrom: indexToSplit + 1
							to: cluesPanel submorphs size).
	cluesPanel position: self position + self borderWidth + (0 @ 4).
	quotePanel position: self position + (quotePanel width @ 0).
	cluesCol2 position: self position + quotePanel extent + (0 @ 4).
	self addMorph: cluesCol2.
	self addMorph: buttonRow.
	buttonRow align: buttonRow topLeft with: cluesCol2 bottomLeft.
	self extent: 100@100; bounds: ((self fullBounds topLeft - self borderWidth asPoint)
							corner: (self fullBounds bottomRight - (2@0))).
! !

!CrosticPanel methodsFor: 'initialization' stamp: 'di 11/28/2000 10:40'!
quote: indexableQuote clues: clueStrings answers: answerIndices quotePanel: panel

	| row clue answer answerMorph letterMorph prev clueText clueStyle |
	quote _ indexableQuote.
	quotePanel _ panel.
	clues _ clueStrings.
	answers _ answerIndices.
	cluesPanel _ AlignmentMorph newColumn color: self color;
		hResizing: #shrinkWrap; vResizing: #shrinkWrap;
		cellPositioning: #topLeft; layoutInset: 1.
	letterMorphs _ Array new: quotePanel letterMorphs size.
	clueStyle _ nil.
	1 to: clues size do:
		[:i |  clue _ clues at: i.  answer _ answers at: i.
		row _ AlignmentMorph newRow cellPositioning: #bottomLeft.
		clueText _ (TextMorph newBounds: (0@0 extent: 120@20) color: Color black)
				string: (CrosticPanel oldStyle
							ifTrue: [(($A to: $Z) at: i) asString , '.  ' , clue]
							ifFalse: [clue])
				fontName: 'ComicPlain' size: 13.
		clueStyle ifNil: ["Make up a special style with decreased leading"
						clueStyle _ clueText textStyle copy.
						clueStyle gridForFont: 1 withLead: -2].
		clueText text: clueText asText textStyle: clueStyle.  "All clues share same style"
		clueText composeToBounds.
		row addMorphBack: clueText.
		answerMorph _ AlignmentMorph newRow layoutInset: 0.
		prev _ nil.
		answer do:
			[:n | letterMorph _ WordGameLetterMorph new underlined
						indexInQuote: n
						id1: (CrosticPanel oldStyle ifTrue: [n printString] ifFalse: [nil]);
						setLetter: Character space.
			letterMorph on: #mouseDown send: #mouseDownEvent:letterMorph: to: self.
			letterMorph on: #keyStroke send: #keyStrokeEvent:letterMorph: to: self.
			letterMorph predecessor: prev.
			prev ifNotNil: [prev successor: letterMorph].
			prev _ letterMorph.
			letterMorphs at: n put: letterMorph.
			answerMorph addMorphBack: letterMorph].
		answerMorph color: answerMorph firstSubmorph color.
		row addMorphBack: answerMorph.
row fullBounds.
		row color: answerMorph firstSubmorph color.
		cluesPanel addMorphBack: row].
	self addMorph: cluesPanel.
	self bounds: cluesPanel fullBounds.
! !

TextMorph removeSelector: #minExtent!
