'From Squeak2.9alpha of 13 June 2000 [latest update: #2915] on 11 November 2000 at 2:15:54 pm'!
"Change Set:		206PackageBrAnnPanes-rhi
Date:			10 September 2000
Author:			Robert Hirschfeld

Fixes PackageBrowser>>openAsMorphEditing: to be sensitive to Preferences for #annotationPanes and #optionalButtons. (Was already in the update stream as 2280PackBrOptBnt-rh but got lost. Now merged with drag-and-drop changes ...)"!


!PackageBrowser methodsFor: 'initialize-release' stamp: 'rhi 9/10/2000 11:09'!
openAsMorphEditing: editString 
	"Create a pluggable version of all the views for a Browser, including views and controllers."
	"PackageBrowser openBrowser"

	| listHeight buttonHeight window switches codePane dragNDropFlag baseline annoHeight optButtonHeight |
	listHeight _ 0.4.
	buttonHeight _ 0.09.
	annoHeight _ 0.05.
	optButtonHeight _ 0.08.
	dragNDropFlag _ Preferences browseWithDragNDrop.

	(window _ SystemWindow labelled: 'later')
		model: self.

	window addMorph: (PluggableListMorph
				on: self
				list: #packageList
				selected: #packageListIndex
				changeSelected: #packageListIndex:
				menu: #packageMenu:
				keystroke: #packageListKey:from:)
		frame: (0 @ 0 extent: 0.15 @ listHeight).

	window addMorph: ((PluggableListMorph
				on: self
				list: #systemCategoryList
				selected: #systemCategoryListIndex
				changeSelected: #systemCategoryListIndex:
				menu: #systemCategoryMenu:
				keystroke: #systemCatListKey:from:)
			enableDrag: false;
			enableDrop: dragNDropFlag)
		frame: (0.15 @ 0 extent: 0.2 @ listHeight).

	window addMorph: ((PluggableListMorph
				on: self
				list: #classList
				selected: #classListIndex
				changeSelected: #classListIndex:
				menu: #classListMenu:
				keystroke: #classListKey:from:)
			enableDragNDrop: dragNDropFlag)
		frame: (0.35 @ 0 extent: 0.25 @ (listHeight - buttonHeight)).

	switches _ self buildMorphicSwitches.
	window addMorph: switches
		frame: (0.35 @ (listHeight - buttonHeight) extent: 0.25 @ buttonHeight).
	switches borderWidth: 0.

	window addMorph: ((PluggableListMorph
				on: self
				list: #messageCategoryList
				selected: #messageCategoryListIndex
				changeSelected: #messageCategoryListIndex:
				menu: #messageCategoryMenu:)
			enableDrag: false;
			enableDrop: dragNDropFlag)
		frame: (0.6 @ 0 extent: 0.15 @ listHeight).

	window addMorph: ((PluggableListMorph
				on: self
				list: #messageList
				selected: #messageListIndex
				changeSelected: #messageListIndex:
				menu: #messageListMenu:shifted:
				keystroke: #messageListKey:from:)
			enableDragNDrop: dragNDropFlag;
			menuTitleSelector: #messageListSelectorTitle)
		frame: (0.75 @ 0 extent: 0.25 @ listHeight).

	Preferences useAnnotationPanes
		ifFalse:
			[baseline _ listHeight]
		ifTrue:
			[window addMorph: (	(PluggableTextMorph on: self
						text: #annotation accept: nil
						readSelection: nil menu: nil)
					askBeforeDiscardingEdits: false)
				frame: (0@listHeight extent: 1@annoHeight).
			baseline _ listHeight + annoHeight].

	Preferences optionalButtons
		ifTrue:
			[window addMorph: self optionalButtonRow
				frame: (0@baseline extent: 1@optButtonHeight).
			baseline _ baseline + optButtonHeight].

	codePane _ PluggableTextMorph
				on: self
				text: #contents
				accept: #contents:notifying:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
	editString
		ifNotNil:
			[codePane editString: editString.
			codePane hasUnacceptedEdits: true].
	window addMorph: codePane frame: (0 @ baseline extent: 1 @(1 - baseline)).
	window setUpdatablePanesFrom:
		#(packageList systemCategoryList classList messageCategoryList messageList ).
	^window! !

