'From Squeak 2.2beta of Sept 16, 1998 on 22 September 1998 at 4:07:12 pm'!
"Change Set:		NewMVCMenus-di
Date:			22 September 1998
Author:			Dan Ingalls

Reworks the logic of ScreenController menus to remove caching.
Reworks the logic of durable menu creation for simplicity.
Rearranges a number of menu items for better grouping.
"!

!Preferences class methodsFor: 'initialization' stamp: 'di 9/22/1998 15:56'!
chooseInitialSettings
	"Restore the default choices for Preferences."
	"Preferences chooseInitialSettings"

	self disable: #browseWithPrettyPrint.
	self enable: #cautionBeforeClosing.
	self enable: #cmdDotEnabled.
	self enable: #confirmFirstUseOfStyle.
	self disable: #disableSounds.
	self disable: #editPlayerScriptsInPlace.
	self disable: #fastDragWindowForMorphic.
	self enable: #ignoreStyleIfOnlyBold.
	self enable: #logDebuggerStackToFile.
	self disable: #noviceMode.
	self enable: #reverseWindowStagger.
	self enable: #showDebugHaloHandle.
	self disable: #showTimeStampsInMenuTitles.
	self disable: #suppressCheckForSlips.
	self enable: #thoroughSenders.
	self disable: #uniformWindowColors.
	self enable: #warnIfNoChangesFile.
	self enable: #warnIfNoSourcesFile.
! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'di 9/22/1998 15:54'!
disable: preferenceNameSymbol
	"Shorthand access"
	self setPreference: preferenceNameSymbol toValue: false! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'di 9/22/1998 15:54'!
enable: preferenceNameSymbol
	"Shorthand access"
	self setPreference: preferenceNameSymbol toValue: true! !


!ScreenController methodsFor: 'menu messages' stamp: 'di 9/22/1998 15:09'!
durableChangesMenu 
	Utilities windowFromMenu: self changesMenu target: self title: 'Changes'! !

!ScreenController methodsFor: 'menu messages' stamp: 'di 9/22/1998 15:29'!
durableHelpMenu 
	Utilities windowFromMenu: self helpMenu target: self title: 'Help'! !

!ScreenController methodsFor: 'menu messages' stamp: 'di 9/22/1998 14:40'!
durableOpenMenu 
	Utilities windowFromMenu: self openMenu target: self title: 'Openers'
		colorPattern:
		#(blue lightGreen lightYellow lightMagenta  lightOrange lightCyan lightBlue lightBlue white white lightOrange lightOrange lightOrange )! !

!ScreenController methodsFor: 'menu messages' stamp: 'di 9/22/1998 14:36'!
durableScreenMenu 
	Utilities windowFromMenu: self projectScreenMenu target: self title: 'Squeak'! !

!ScreenController methodsFor: 'menu messages' stamp: 'di 9/22/1998 15:15'!
durableWindowMenu 
	Utilities windowFromMenu: self windowMenu target: self title: 'Window controls'! !

!ScreenController methodsFor: 'nested menus' stamp: 'di 9/22/1998 14:54'!
changesMenu
	"Answer a menu for changes-related items"
	^ SelectionMenu labelList:
		#(	'keep this menu up'

			'file out changes'
			'create new change set...'
			'browse changed methods'

			'simple change sorter'
			'dual change sorter'

			'browse recent submissions'
			'recent change log'
			)
		lines: #(1 4 6)
		selections: #(durableChangesMenu
fileOutChanges newChangeSet browseChangedMessages
openSimpleChangeSorter openChangeManager
browseRecentSubmissions browseRecentLog )
"
ScreenController new changesMenu startUp
"! !

!ScreenController methodsFor: 'nested menus' stamp: 'di 9/22/1998 15:26'!
helpMenu 
	"Answer the help menu to be put up as a screen submenu"

	^ SelectionMenu labelList:
		#(	'keep this menu up'

			'preferences...'
			'command-key help'
			'useful expressions'
			'view image imports'

			'set desktop color...'
			'set display depth...'
			'full screen on'
			'full screen off' ) , 
			(Array with: ((Preferences valueOfFlag: #disableSounds)
							ifTrue: ['turn sound on']
							ifFalse: ['turn sound off'])) ,

		#(	'update code from server'
			'about this system...'
			'set author initials...'
			'vm statistics'
			'space left')
		lines: #(1 5 10)
		selections: #(durableHelpMenu
editPreferences  openCommandKeyHelp openStandardWorkspace viewImageImports
setDesktopColor setDisplayDepth fullScreenOn fullScreenOff soundOnOrOff
absorbUpdatesFromServer aboutThisSystem setAuthorInitials vmStatistics garbageCollect)
"
ScreenController new helpMenu startUp
"! !

!ScreenController methodsFor: 'nested menus' stamp: 'di 9/22/1998 14:29'!
openMenu
	^ SelectionMenu labelList:
		#(	'keep this menu up'

			'browser'
			'workspace'
			'file list'
			'transcript'
			'selector finder'
			'simple change sorter'
			'dual change sorter'

			'morphic window'
			'construction window'

			'project (mvc)'
			'project (morphic)'
			'project (construction)'
			)
		lines: #(1 8 10)
		selections: #(durableOpenMenu
openBrowser openWorkspace openFileList openTranscript openSelectorBrowser openSimpleChangeSorter openChangeManager
openMorphicWorld openMorphicConstructionWorld
openProject  openMorphicProject  openConstructionProject )
"
ScreenController  new openMenu startUp
"! !

!ScreenController methodsFor: 'nested menus' stamp: 'di 9/22/1998 14:00'!
projectScreenMenu
	"Answer the project screen menu."

	^ SelectionMenu labelList:
		#(	'keep this menu up'
			'previous project'
			'jump to project...'
			'restore display'
			'open new...'
			'changes...'
			'windows...'
			'help...'
			'do...'
			'save'
			'save as...'
			'save and quit'
			'quit')
		lines: #(1 4 9)
		selections: #(durableScreenMenu
returnToPreviousProject jumpToProject restoreDisplay
presentOpenMenu presentChangesMenu presentWindowMenu presentHelpMenu commonRequests
snapshot saveAs snapshotAndQuit quit )
"
ScreenController new projectScreenMenu startUp
"! !

!ScreenController methodsFor: 'nested menus' stamp: 'di 9/22/1998 15:14'!
windowMenu
	"Answer a menu for windows-related items.  "

	^ SelectionMenu labelList:
		#(	'keep this menu up'

			'find window...'
			'find changed browsers...'
			'find changed windows...'

			'collapse all windows'
			'expand all windows'
			'close unchanged windows' ) , 
			(Array with: (StandardSystemView cachingBits
							ifTrue: ['dont save bits (compact)']
							ifFalse: ['save bits (fast)'])
				with: ((Preferences valueOfFlag: #reverseWindowStagger)
							ifTrue: ['tile windows']
							ifFalse: ['stagger windows']))
		lines: #(1 4 7)
		selections: #(durableWindowMenu
findWindow chooseDirtyBrowser chooseDirtyWindow
collapseAll expandAll closeUnchangedWindows
fastWindows changeWindowPolicy)
"
ScreenController new windowMenu startUp
"! !


!Utilities class methodsFor: 'common requests' stamp: 'di 9/22/1998 16:04'!
closeAllDebuggers
	"Utilities closeAllDebuggers"
	Smalltalk isMorphic
	ifTrue:
		[(SystemWindow allInstances select: [:w | w model isKindOf: Debugger])
			do: [:w | w delete]]
	ifFalse:
		[(StandardSystemController allInstances select: [:w | w model isKindOf: Debugger])
			do: [:w | w closeAndUnscheduleNoTerminate]]! !

!Utilities class methodsFor: 'common requests' stamp: 'di 9/22/1998 16:06'!
initializeCommonRequestStrings
	"Initialize an array of common request strings.  2/1/96 sw
	 5/10/96 sw: converted over to new format of StringHolder"

	CommonRequestStrings _ StringHolder new contents: 
'Utilities emergencyCollapse
Utilities closeAllDebuggers
Sensor keyboard
Cursor normal show
----------------------------------
ScriptingSystem inspectFormDictionary
Preferences enable: #showTimeStampsInMenuTitles
Preferences enable: #cmdDotEnabled
Form fromUser bitEdit
Display border: (0@0 extent: 640@480) width: 2
----------------------------------
Undeclared inspect
Undeclared removeUnreferencedKeys; inspect
Transcript clear
ChangeSorter removeEmptyUnnamedChangeSets'

"Utilities initializeCommonRequestStrings"! !

!Utilities class methodsFor: 'durable menus' stamp: 'di 9/22/1998 14:49'!
windowFromMenu: aMenu target: aTarget title: aTitle
	"Supply a default list of colors"
	^ self windowFromMenu: aMenu target: aTarget title: aTitle
		colorPattern: #(lightRed lightGreen lightBlue lightYellow lightGray lightCyan lightMagenta lightOrange)! !

!Utilities class methodsFor: 'durable menus' stamp: 'di 9/22/1998 14:48'!
windowFromMenu: aMenu target: aTarget title: aTitle colorPattern: aColorPattern
	| labelList targetList selectionList i |
	selectionList _ aMenu selections.
	labelList _ (1 to: selectionList size) collect:
		[:ind | aMenu labelString lineNumber: ind].
	targetList _  (1 to: selectionList size) collect: [:ind | aTarget].

	(i _ labelList indexOf: 'keep this menu up') > 0 ifTrue:
		[selectionList _ selectionList copyReplaceFrom: i to: i with: Array new.
		labelList _ labelList copyReplaceFrom: i to: i with: Array new.
		targetList _ targetList copyReplaceFrom: i to: i with: Array new].

	self windowMenuWithLabels:  labelList colorPattern: aColorPattern targets: targetList selections: selectionList title: aTitle! !

!Utilities class methodsFor: 'durable menus' stamp: 'di 9/22/1998 14:44'!
windowMenuWithLabels: labelList colorPattern: colorPattern  targets: targetList selections: selectionList title: aTitle
	| aWorld colorList  pos delta aButton  rightmost widthToUse |
	Smalltalk verifyMorphicAvailability ifFalse: [^ self].
	aWorld _ WorldMorph new.
	colorList _  (1 to: labelList size) collect:
		[:ind | Color perform: (colorPattern at: (ind \\ colorPattern size + 1))].
			
	pos _ 4 @ 6.
	delta _ 0 @ 30.
	rightmost _ 0.

	1 to: labelList size do:
		[:index |
			aButton _ SimpleButtonMorph new.
			aButton label: (labelList at: index); 
				color: (colorList at: index); 
				target: (targetList at: index);
				actionSelector: (selectionList at: index);
				position: pos.
			rightmost _ rightmost max: aButton right.
			pos _ pos + delta.
			aWorld addMorphBack: aButton].
	widthToUse _ rightmost + 10.
	aWorld submorphs do:
		[:m | m position: (((widthToUse - m width) // 2) @ m position y)].
	aWorld setProperty: #initialExtent toValue: (widthToUse @ (aButton bottom + 10)).
	aWorld openWithTitle: aTitle cautionOnClose: false! !


ControlManager removeSelector: #cmdDotEnabled:!
ControlManager removeSelector: #cmdDotEnabled!
ControlManager class removeSelector: #initialize!
Project removeSelector: #cmdDotEnabled!
ScreenController class removeSelector: #initialize!
ScreenController class removeSelector: #revertToStandardMenus!
Utilities class removeSelector: #durableChangesMenu!
Utilities class removeSelector: #durableHelpMenu!
Utilities class removeSelector: #durableOpenMenu!
Utilities class removeSelector: #durableScreenMenu!
Utilities class removeSelector: #durableWindowMenu!

Object subclass: #ControlManager
	instanceVariableNames: 'scheduledControllers activeController activeControllerProcess screenController newTopClicked '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Interface-Framework'!
MouseMenuController subclass: #ScreenController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Interface-Support'!

"Postscript:
"
Utilities initializeCommonRequestStrings!

