'From Squeak2.9alpha of 17 July 2000 [latest update: #3166] on 13 December 2000 at 9:53:39 am'!
"Change Set:		gotoMark
Date:			13 December 2000
Author:			Bob Arning

- adds red menu item to camera mark to go to that mark
- fix placement of camera mark when it overlaps left edge"!


!ZASMCameraMarkMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/13/2000 09:02'!
addAddHandMenuItemsForHalo: aMenu hand: aHandMorph
	"Add halo menu items to be handled by the invoking hand. The halo menu is invoked by clicking on the menu-handle of the receiver's halo."

	aMenu add: 'Go to this mark' action: #gotoMark.
	aMenu addLine.
	^super addAddHandMenuItemsForHalo: aMenu hand: aHandMorph
! !

!ZASMCameraMarkMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/13/2000 09:09'!
addMorphsTo: morphList pianoRoll: pianoRoll eventTime: t betweenTime: leftTime and: rightTime

	| startX pseudoEndTime |

	startX _ pianoRoll xForTime: startTimeInScore.
	pseudoEndTime _ pianoRoll timeForX: startX + self width.
	startTimeInScore > rightTime ifTrue: [^ self].  
	pseudoEndTime < leftTime ifTrue: [^ self].

	morphList add: 
		(self align: self bottomLeft
			with: startX @ self bottom).

! !

!ZASMCameraMarkMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/13/2000 09:05'!
encounteredAtTime: ticks inScorePlayer: scorePlayer atIndex: index inEventTrack: track secsPerTick: secsPerTick

	| nextAmbient m nextDurationInMs program now finalMark thisPage nextPage |

	self gotoMark.
	nextAmbient _ nil.
	index to: track size do: [ :i |
		(nextAmbient isNil and: [((m _ track at: i) morph) isKindOf: self class]) ifTrue: [
			nextAmbient _ m.
		].
	].
	nextAmbient ifNil: [^self].
	nextDurationInMs _ (nextAmbient time - ticks * secsPerTick * 1000) rounded.
	finalMark _ nextAmbient morph.
	thisPage _ self valueOfProperty: #bookPage.
	nextPage _ finalMark valueOfProperty: #bookPage.
	(thisPage = nextPage or: [thisPage isNil | nextPage isNil]) ifFalse: [^self].
	now _ Time millisecondClockValue.
	program _ Dictionary new.
	program
		at: #startTime put: now;
		at: #endTime put: now + nextDurationInMs;
		at: #startPoint put: (self valueOfProperty: #cameraPoint);
		at: #endPoint put: (finalMark valueOfProperty: #cameraPoint);
		at: #startZoom put: (self valueOfProperty: #cameraScale);
		at: #endZoom put: (finalMark valueOfProperty: #cameraScale).
	self cameraController setProgrammedMoves: {program}.

! !

!ZASMCameraMarkMorph methodsFor: 'as yet unclassified' stamp: 'RAA 12/13/2000 08:57'!
gotoMark

	self cameraController 
		turnToPage: (self valueOfProperty: #bookPage)
		position: (self valueOfProperty: #cameraPoint) 
		scale: (self valueOfProperty: #cameraScale).
	self setCameraValues.


! !

