'From Squeak2.9alpha of 17 July 2000 [latest update: #3179] on 16 December 2000 at 6:47:32 pm'!
"Change Set:		moreLayers
Date:			16 December 2000
Author:			Bob Arning

Enhance morphic layering with the addition of Morph>>addMorphInFrontOfLayer: which will insure that the morph in question appears in front of any morphs of the same priority. This will reduce unnecessary competition between layers since we will use this in PasteUpMorph>>addMorphFront:. The original Morph>>addMorphInLayer: will retain its current behavior of allowing morphs to be behind morphs of the same priority since this is necessary to prevent endless reshuffling by morphs which periodically reassert their position in the pecking order.

"!


!Morph methodsFor: 'WiW support' stamp: 'RAA 12/16/2000 18:47'!
addMorphInFrontOfLayer: aMorph

	| targetLayer |
	targetLayer _ aMorph morphicLayerNumber.
	submorphs do: [ :each |
		each == aMorph ifTrue: [^self].
		"the <= is the difference - it insures we go to the front of our layer"
		targetLayer <= each morphicLayerNumber ifTrue: [
			^self addMorph: aMorph inFrontOf: each
		].
	].
	self addMorphBack: aMorph
! !


!PasteUpMorph methodsFor: 'submorphs-add/remove' stamp: 'RAA 12/16/2000 18:37'!
addMorphFront: aMorph

	^self addMorphInFrontOfLayer: aMorph
! !

