'From Squeak2.9alpha of 17 July 2000 [latest update: #3340] on 31 January 2001 at 2:04:12 pm'!
"Change Set:		threadNav
Date:			31 January 2001
Author:			Bob Arning

For the internal thread navigation morph
- shift click on projct in the sorter to go to that project
- added menu item to insert new project into sequence

- also cleaned up superswiki query results"!


!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/31/2001 13:45'!
addButtons

	| marginPt i sz data images pageNumber proj f m b1 b2 dot arrowWidth arrowCenter vertices arrowHeight allMorphicProjects nameMorph |

	allMorphicProjects _ Project allMorphicProjects.
	self changeNoLayout.
	self hResizing: #rigid. "... this is very unlikely..."
	self vResizing: #rigid.
	marginPt _ 4@4.
	i _ self currentIndex.
	sz _ 50@40.
	arrowWidth _ 14.
	arrowHeight _ 17.
	data _ {
		{i - 1. 'Previous:'. #previousPage. #rightCenter. arrowWidth negated}.
		{i + 1. 'Next:'. #nextPage. #leftCenter. arrowWidth}
	}.
	images _ data collect: [ :tuple |
		pageNumber _ tuple first.
		((pageNumber between: 1 and: listOfPages size) and: 
				[(proj _ Project named: (listOfPages at: pageNumber) first in: allMorphicProjects) notNil]) ifTrue: [
			f _ (proj thumbnail ifNil: [(StringMorph contents: '???') imageForm]) scaledToSize: sz.
			arrowCenter _ f boundingBox perform: tuple fourth.
			vertices _ {
				arrowCenter - (0@arrowHeight).
				arrowCenter + (0@arrowHeight).
				arrowCenter + (tuple fifth @ 0).
			}.
			f getCanvas
				drawPolygon: vertices 
				color: Color orange 
				borderWidth: 0 
				borderColor: Color transparent.
			m _ ImageMorph new image: f.
			m setBalloonText: tuple second,' ',(listOfPages at: pageNumber) first.
			m addMouseUpActionWith: (
				MessageSend receiver: self selector: tuple third
			).
		] ifFalse: [
			f _ (Form extent: sz depth: 16) fillColor: Color lightGray.
			m _ ImageMorph new image: f.
		].
		m
	].
	b1 _ images first.
	b2 _ images second.
	dot _ EllipseMorph new extent: 16@16; color: Color orange lighter; borderWidth: 0.
	self addMorph: (b1 position: self position + marginPt).
	self addMorph: (b2 position: b1 topRight + (marginPt x @ 0)).
	self extent: b2 bottomRight - self position + marginPt.
	self addMorph: dot.
	dot align: dot center with: b1 bounds rightCenter + ((marginPt x @ 0) // 2).
	dot setBalloonText: threadName,'
more commands'.
	dot on: #mouseDown send: #moreCommands to: self.
	self fullBounds.
	self addMorph: (nameMorph _ SquishedNameMorph new).
	nameMorph
		target: self getSelector: #threadName setSelector: nil;
		color: Color transparent;
		width: self width;
		height: 15;
		align: nameMorph bottomLeft with: self bottomLeft.

! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/31/2001 13:42'!
clickFromSorterEvent: evt morph: aMorph

	(aMorph bounds containsPoint: evt cursorPoint) ifFalse: [^self].
	evt shiftPressed ifFalse: [^evt hand grabMorph: aMorph].

	(Project named: (aMorph valueOfProperty: #nameOfThisProject)) enter.
! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/31/2001 13:39'!
insertNewProject

	| newProj me |
	newProj _ Project newMorphicOn: nil.

	me _ CurrentProjectRefactoring currentProjectName.

	listOfPages withIndexDo: [ :each :index |
		each first = me ifTrue: [
			listOfPages add: {newProj name} afterIndex: index.
			^self switchToThread: threadName
		].
	].
	listOfPages add: {newProj name} afterIndex: listOfPages size.
	^self switchToThread: threadName

! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/31/2001 13:31'!
moreCommands

	| allThreads aMenu others |

	allThreads _ self class knownThreads.
	aMenu _ MenuMorph new defaultTarget: self.
	others _ (allThreads keys reject: [ :each | each = threadName]) asSortedCollection.
	others do: [ :each |
		aMenu add: 'switch to <',each,'>' selector: #switchToThread: argument: each.
	].
	aMenu 
		add: 'switch to recent projects' action: #getRecentThread;
		addLine;
		add: 'thread of all projects' action: #threadOfAllProjects;
		add: 'thread of no projects' action: #threadOfNoProjects;
		add: 'edit this thread' action: #editThisThread;
		addLine;
		add: 'First project in thread' action: #firstPage;
		add: 'Last project in thread' action: #lastPage;
		add: 'jump within this thread' action: #jumpWithinThread;
		add: 'insert new project' action: #insertNewProject;
		addLine;
		add: 'simply close this navigator' action: #delete.

	aMenu popUpEvent: self world primaryHand lastEvent in: self world! !

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/31/2001 13:23'!
morphsForMyContentsSizedTo: sz

	| allMorphicProjects morphsForPageSorter proj pvm |

	allMorphicProjects _ Project allMorphicProjects.
	'Assembling thumbnail images...'
		displayProgressAt: self cursorPoint
		from: 0 to: listOfPages size
		during: [:bar |
			morphsForPageSorter _ listOfPages withIndexCollect: [ :each :index | 
				bar value: index.
				(proj _ Project named: each first in: allMorphicProjects) ifNil: [
					nil
				] ifNotNil: [
					pvm _ ProjectViewMorph on: proj.
					pvm _ pvm imageForm scaledToSize: sz.
					pvm _ pvm asMorph.
					pvm setProperty: #nameOfThisProject toValue: each first.
					pvm setBalloonText: each first.
					pvm on: #mouseUp send: #clickFromSorterEvent:morph: to: self.
					pvm
				]
			].
		].
	^morphsForPageSorter
! !


!SuperSwikiServer methodsFor: 'testing' stamp: 'RAA 1/31/2001 14:03'!
showQueryAsPVM: resultStream
	| answer gif whatToShow projectName fileName firstURL wrapper currX currY maxX maxY |
"SuperSwikiServer testOnlySuperSwiki queryProjectsAndShow"

	resultStream reset; nextLine.
	answer _ RectangleMorph new
		useRoundedCorners;
		borderWidth: 0;
		borderColor: Color blue;
		color: Color paleBlue.
	currX _ currY _ maxX _ maxY _ 10.
	[resultStream atEnd] whileFalse: [
		projectName _ resultStream nextLine.
		fileName _ resultStream nextLine.
		gif _ self oldFileOrNoneNamed: projectName,'.gif'.
		gif ifNotNil: [gif _ GIFReadWriter formFromStream: gif].
		currX > 600 ifTrue: [
			currX _ 10.
			currY _ maxY + 10.
		].
		gif ifNil: [
			gif _ AlignmentMorph newColumn
				hResizing: #shrinkWrap;
				vResizing: #shrinkWrap;
				borderWidth: 8;
				borderColor: Color red;
				color: Color lightRed;
				addMorph: (StringMorph contents: 'No GIF for ',projectName);
				fullBounds;
				imageForm
		].
		firstURL _ self url.
		firstURL last == $/ ifFalse: [firstURL _ firstURL, '/'].

		whatToShow _ ProjectViewMorph new
			image: (gif asFormOfDepth: Display depth);
			lastProjectThumbnail: gif;
			setProperty: #SafeProjectName toValue: projectName;
			project: (DiskProxy 
				global: #Project 
				selector: #namedUrl: 
				args: {firstURL,fileName}
			).

		answer addMorphBack: (whatToShow position: currX @ currY).
		currX _ currX + whatToShow width + 10.
		maxX _ maxX max: currX.
		maxY _ maxY max: currY + whatToShow height.
	].
	maxX = 10 ifTrue: [
		^self inform: 'No projects found for your criteria'
	].
	answer extent: (maxX @ maxY) + (0@10).
	wrapper _ ScrollPane new extent: (answer width + 10) @ (answer height min: 400).
	wrapper color: Color white.
	wrapper scroller addMorph: answer.
	wrapper 
		openCenteredInWorld;
		useRoundedCorners;
		setScrollDeltas.! !

InternalThreadNavigationMorph removeSelector: #addButtonsAlan!
InternalThreadNavigationMorph removeSelector: #fewerButtonsMode!
