'From Squeak 2.2 of Sept 23, 1998 on 29 September 1998 at 9:56:56 am'!
"Change Set:		dropSysWindow-sw
Date:			29 September 1998
Author:			Scott Wallace

Keeps system windows from being annoyingly repelled by parts bins, etc, and from being annoyingly embedded in playfields/pages when dropped;  System windows, unless you set a preference to the contrary, generally all live on the world desktop and do not ever wish to be embedded in other morphs.

Adds preference 'allowSysWindowEmbedding' -- if true, then SystemWindows will be readily droppable within pasteups, but if not true, system windows will generally be kept at the desktop level, at least when manipulating them via the drag-and-drop UI"!


!HandMorph methodsFor: 'grabbing/dropping' stamp: 'sw 9/29/1998 09:50'!
dropTargetFor: aMorph event: evt
	"Return the morph that the given morph is to be dropped onto.  Return nil if we must repel the morph.  Return the world, if no other morph wants the dropping morph."

	| root coreSample |
	root _ nil.
	owner submorphsReverseDo: [:m |
		((m fullContainsPoint: evt cursorPoint) and:
		 [(m isKindOf: HaloMorph) not]) ifTrue: [root _ m]].
	root == nil ifTrue: [^ self world].
	coreSample _ root morphsAt: evt cursorPoint.
	(Preferences allowSysWindowEmbedding not and:
		[(aMorph isKindOf: SystemWindow)]) ifTrue: [^ self world].
	coreSample do:
		[:m |
			(m repelsMorph: aMorph event: evt) ifTrue:
				[^ nil]].

	coreSample do:
		[:m |
			(m wantsDroppedMorph: aMorph event: evt) ifTrue: [^ m]].
	^ self world
! !


!PasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'sw 9/29/1998 09:25'!
repelsMorph: aMorph event: ev
	(Preferences allowSysWindowEmbedding not and:
		[aMorph isKindOf: SystemWindow]) ifTrue: [^ false].

	isPartsBin == true ifTrue: [^ true].
	openToDragNDrop ifFalse: [^ true].
	(self wantsDroppedMorph: aMorph event: ev) ifFalse: [^ true].
	^ super repelsMorph: aMorph event: ev "consults #repelling flag"! !

!PasteUpMorph methodsFor: 'dropping/grabbing' stamp: 'sw 9/29/1998 09:29'!
wantsDroppedMorph: aMorph event: evt
	(self isPartsBin or: [self openToDragNDrop]) not ifTrue: [^ false].
	(self bounds containsPoint: evt cursorPoint) ifFalse: [^ false].
	((aMorph isKindOf: SystemWindow) and: [Preferences allowSysWindowEmbedding not])
		ifTrue:	[^ false].
	^ true ! !


"Postscript:
"
Preferences setPreference:  #allowSysWindowEmbedding toValue: false!

