'From Squeak 2.2 of Sept 23, 1998 on 30 September 1998 at 12:41:40 pm'!
"Change Set:		unscriptedFix-sw
Date:			30 September 1998
Author:			Scott Wallace

Fixes the bug that had added inst vars and methods to vanilla UnscriptedPlayer class (the metaclass) when executing the Try button associated with a method that had a player reference in it, such as 'car move toward dot'.  This update removes the bug and also patches up the instance structure of UnscriptedPlayer class and its method dictionary to get rid of whichever undesired inst vars and methods may have accumulated in the host image because of the bug."!

UnscriptedPlayer class
	instanceVariableNames: 'ephemeralPlayerRef '!

!UnscriptedPlayer class methodsFor: 'reference' stamp: 'sw 9/30/1998 09:14'!
ephemeralPlayerRef
	"UnscriptedPlayer ephemeralPlayerRef"
	^ ephemeralPlayerRef! !

!UnscriptedPlayer class methodsFor: 'reference' stamp: 'sw 9/30/1998 09:05'!
referenceSelectorFor: anObject
	"The use of this is for immediate evaluation of lines of script in a Viewer.  The class inst var 'ephemeralPlayerRef' is constantly reused for this purpose."

	ephemeralPlayerRef _ anObject.
	^ 'ephemeralPlayerRef'! !


!ViewerBook methodsFor: 'all' stamp: 'sw 9/30/1998 12:39'!
setPlayer: aPlayer
	| aPartsViewer |
	"currentPage ifNotNil: [currentPage partsViewer scriptedPlayer == aPlayer ifTrue: [^ self]]."

	self flag: #deferred.  "deploy viewer cache soon"
	self presenter associatedMorph "temporarily, so it can get initialized!!" addMorph:
		(aPartsViewer _ PartsViewer newSticky).
	aPartsViewer setPlayer: aPlayer.
	self presenter coloredTilesEnabled ifFalse:
		[aPartsViewer makeAllTilesGreen].
	self removeAllMorphs.
	self newPages: (OrderedCollection with: aPartsViewer) currentIndex: 1! !


"Postscript:
"
(UnscriptedPlayer class selectors select:
		[:aSel | aSel beginsWith: 'refU'])
	do:
		[:aSel | UnscriptedPlayer class removeSelector: aSel].
UnscriptedPlayer class instanceVariableNames: 'ephemeralPlayerRef'
!

