'From Squeak 2.2 of Sept 23, 1998 on 13 October 1998 at 1:48:49 pm'!
"Change Set:		timeStamp-sw
Date:			13 October 1998
Author:			Scott Wallace

Makes the extracting of the time-stamp for a method from a source file (finally) a much less heavy-weight operation, by just retrieving the current source, not all historical versions."!


!StringHolder methodsFor: 'message list menu' stamp: 'sw 10/13/1998 13:31'!
timeStamp
	|  selector  aMethod |
	^ (selector _ self selectedMessageName) ifNotNil:
		[aMethod _ self selectedClassOrMetaClass compiledMethodAt: selector ifAbsent: [nil].
		aMethod ifNotNil: [Utilities timeStampForMethod: aMethod]]! !


!Utilities reorganize!
('read me' seeClassSide)
!


!Utilities methodsFor: 'read me' stamp: 'sw 10/13/1998 13:14'!
seeClassSide
	"All the code for Utilitites is on the class side"! !


!Utilities class methodsFor: 'miscellaneous' stamp: 'sw 10/13/1998 13:38'!
timeStampForMethod: method
	"Answer the authoring time-stamp for the given method, retrieved from the sources or changes file, or nil if none is found"
	| position preamble tokens stamp file tokenCount |
	method fileIndex == 0 ifTrue: [^ nil].
	position _ method filePosition.
	file _ (SourceFiles at: method fileIndex) readOnlyCopy.
	file position: (0 max: position - 150).  "Skip back to before the preamble"
		[file position < (position - 1)]  "then pick it up from the front"
			whileTrue: [preamble _ file nextChunk].
		stamp _ nil.
		tokens _ (preamble findString: 'methodsFor:' startingAt: 1) > 0
			ifTrue: [Scanner new scanTokens: preamble]
			ifFalse: [Array new  "ie cant be back ref"].
		(((tokenCount _ tokens size) between: 7 and: 8) and: [(tokens at: tokenCount - 5) = #methodsFor:])
			ifTrue:
				[(tokens at: tokenCount - 3) = #stamp:
					ifTrue: ["New format gives change stamp and unified prior pointer"
							stamp _ tokens at: tokenCount - 2]].
		((tokenCount between: 5 and: 6) and: [(tokens at: tokenCount - 3) = #methodsFor:])
			ifTrue:
				[(tokens at: tokenCount  - 1) = #stamp:
					ifTrue: ["New format gives change stamp and unified prior pointer"
						stamp _ tokens at: tokenCount]].
	file close.
	^ stamp! !


