'From Squeak 2.2 of Sept 23, 1998 on 24 October 1998 at 1:11:01 pm'!
"Change Set:		ReframeMinSize2
Date:			24 October 1998
Author:			Dan Ingalls

A second tweak that prevents making SystemWindows too small.  This one prevents changing any dimension other than the one being dragged.
"!


!SystemWindow methodsFor: 'resize/collapse' stamp: 'di 10/24/1998 12:47'!
spawnReframeHandle: event
	"The mouse has crossed a pane border.  Spawn a reframe handle."
	| resizer localPt pt ptName newBounds |
	owner ifNil: [^ self  "Spurious mouseLeave due to delete"].
	paneMorphs do: [:p | ((p fullBounds insetBy: 1) containsPoint: event cursorPoint)
			ifTrue: [^ self  "Don't activate resizer if in a scrollbar"]].
	pt _ event cursorPoint.
	self bounds forPoint: pt closestSideDistLen:
		[:side :dist :len |  "Check for window side adjust"
		dist <= 2  ifTrue: [ptName _ side]].
	ptName ifNil:
		["Check for pane border adjust"
		^ self spawnPaneFrameHandle: event].
	#(topLeft bottomRight bottomLeft topRight) do:
		[:corner |  "Check for window corner adjust"
		(pt dist: (self bounds perform: corner)) < 20 ifTrue: [ptName _ corner]].

	resizer _ NewHandleMorph new followHand: event hand
		forEachPointDo:
			[:p | localPt _ self pointFromWorld: p.
			ptName = #top ifTrue: [newBounds _ self bounds withTop: localPt y].
			ptName = #bottom ifTrue: [newBounds _ self bounds withBottom: localPt y].
			ptName = #left ifTrue: [newBounds _ self bounds withLeft: localPt x].
			ptName = #right ifTrue: [newBounds _ self bounds withRight: localPt x].
			ptName = #topLeft ifTrue: [newBounds _ self bounds bottomRight rect: localPt].
			ptName = #bottomRight ifTrue: [newBounds _ self bounds topLeft rect: localPt].
			ptName = #bottomLeft ifTrue: [newBounds _ self bounds topRight rect: localPt].
			ptName = #topRight ifTrue: [newBounds _ self bounds bottomLeft rect: localPt].
			newBounds extent > (60@40) ifTrue: [self bounds: newBounds]]
		lastPointDo: [:lastPoint | ].
	event hand world addMorph: resizer.
	resizer startStepping! !


