'From Squeak3.1alpha of 5 February 2001 [latest update: #3841] on 15 March 2001 at 10:55:41 am'!
"Change Set:		DebugFileExtras-mdr
Date:			23 February 2001
Author:			Mike Rutenberg

Adds information about the Squeak VM and Image to the SqueakDebug.log file that is created when an error occurs.  Implemented in a lean way, assuming we are running short of memory.

Note: there is no way to get the exact version of the overall Squeak VM from within the image, so we settle for the name of the image that generated the interpreter."!


!SystemDictionary methodsFor: 'miscellaneous' stamp: 'RAA 3/15/2001 10:54'!
logError: errMsg inContext: aContext to: aFilename
	"Log the error message and a stack trace to the given file."
	| ff ctx |
	FileDirectory default deleteFileNamed: aFilename ifAbsent: [].
	(ff _ FileStream fileNamed: aFilename) ifNil: [^ self "avoid recursive errors"].
  	ff print: Date today; space; print: Time now; cr.
  	ff nextPutAll: errMsg; cr.
	ff cr.
	ff nextPutAll: 'VM: ';
		nextPutAll: Smalltalk platformName asString;
		nextPutAll: ' - ';
		nextPutAll: Smalltalk vmVersion asString;
		cr.
	ff nextPutAll: 'Image: ';
		nextPutAll: Smalltalk version asString;
		nextPutAll: ' [';
		nextPutAll: Smalltalk lastUpdateString asString;
		nextPutAll: ']';
		cr.
	ff cr.
	"Note: The following is an open-coded version of ContextPart>>stackOfSize:
	since this method may be called during a low space condition and we might
	run out of space for allocating the full stack."
	ctx _ aContext.
	[ctx == nil] whileFalse:[
		ff print: ctx; cr.
		ctx _ ctx sender].
	ff close.! !

