'From Squeak3.1alpha [latest update: #''Squeak3.1alpha'' of 28 February 2001 update 3892] on 3 April 2001 at 4:27:47 pm'!
"Change Set:		twoUnrelated-sw
Date:			3 April 2001
Author:			Scott Wallace

(1) Fixes bug seen when copying class changes from one side of a change sorter to the other when a class was marked as #addedAndRemoved in the source change set.
(2) Fixes bug that made inappropriate arrows be offered on AssignmentTiles for certain non-numeric types"!


!AssignmentTileMorph methodsFor: 'arrow' stamp: 'sw 4/3/2001 15:54'!
addArrowsIfAppropriate
	"If the receiver's slot is of an appropriate type, add arrows to the tile.  The list of types wanting arrows is at this point simply hard-coded."

	(#(number) includes: dataType)  ifTrue: [self addArrows]! !


!ClassChangeRecord methodsFor: 'all changes' stamp: 'sw 4/3/2001 14:16'!
noteChangeType: changeSymbol fromClass: class

	(changeSymbol = #new or: [changeSymbol = #add]) ifTrue:
		[changeTypes add: #add.
		changeTypes remove: #change ifAbsent: [].
		revertable _ false.
		^ self].
	changeSymbol = #change ifTrue:
		[(changeTypes includes: #add) ifTrue: [^ self].
		^ changeTypes add: changeSymbol].
	changeSymbol == #addedThenRemoved ifTrue:
		[^ self].  "An entire class was added but then removed"
	changeSymbol = #comment ifTrue:
		[^ changeTypes add: changeSymbol].
	changeSymbol = #reorganize ifTrue:
		[^ changeTypes add: changeSymbol].
	changeSymbol = #rename ifTrue:
		[^ changeTypes add: changeSymbol].
	(changeSymbol beginsWith: 'oldName: ') ifTrue:
		["Must only be used when assimilating other changeSets"
		(changeTypes includes: #add) ifTrue: [^ self].
		priorName _ changeSymbol copyFrom: 'oldName: ' size + 1 to: changeSymbol size.
		^ changeTypes add: #rename].
	changeSymbol = #remove ifTrue:
		[(changeTypes includes: #add)
			ifTrue: [changeTypes add: #addedThenRemoved]
			ifFalse: [changeTypes add: #remove].
		^ changeTypes removeAllFoundIn: #(add change comment reorganize)].

	self error: 'Unrecognized changeType'! !

