'From Squeak 2.2 of Sept 23, 1998 on 19 November 1998 at 6:35:26 pm'!
"Change Set:		Interrupt-Fix
Date:			19 November 1998
Author:			Andreas Raab

Fix for an interrupt problem occuring if the active controller's process is terminated"!


!ControlManager methodsFor: 'scheduling' stamp: 'ar 11/19/1998 18:31'!
interruptName: labelString
	"Create a Notifier on the active scheduling process with the given label. Make the Notifier the active controller."
	| suspendingList newActiveController |
	(suspendingList _ activeControllerProcess suspendingList) == nil
		ifTrue: [activeControllerProcess == Processor activeProcess
					ifTrue: [activeControllerProcess suspend]]
		ifFalse: [suspendingList remove: activeControllerProcess ifAbsent:[].
				activeControllerProcess offList].

	activeController ~~ nil ifTrue: [
		"Carefully de-emphasis the current window."
		activeController view topView deEmphasizeForDebugger].

	newActiveController _
		(Debugger
			openInterrupt: labelString
			onProcess: activeControllerProcess) controller.
	newActiveController centerCursorInView.
	self activeController: newActiveController.
! !


