'From Squeak2.9alpha of 13 June 2000 [latest update: #2915] on 11 November 2000 at 12:48:45 pm'!
"Change Set:		DumbMacHack-sma
Date:			11 November 2000
Author:			Stefan Matthias Aust

Make sure that the change set's file name is no longer than 31"!


!ChangeSet methodsFor: 'fileIn/Out' stamp: 'sma 11/11/2000 12:46'!
fileOut
	"File out the receiver, to a file whose name is a function of the change-set name and either of the date & time or chosen to have a unique numeric tag, depending on the preference 'sequentialChangeSetRevertableFileNames'"

	| file slips nameToUse |
	self checkForConversionMethods.
	nameToUse _ Preferences changeSetVersionNumbers
		ifTrue:
			[(self name, FileDirectory dot, 'cs') asFileName]
		ifFalse:
			[(self name, FileDirectory dot, Utilities dateTimeSuffix, 
				FileDirectory dot, 'cs') asFileName].
	nameToUse size > 31 ifTrue: [^ self inform: nameToUse , ' has ' , nameToUse size asString , ' letters - too long for the Mac'].
	Cursor write showWhile:
		[[file _ FileStream newFileNamed: nameToUse.
		file header; timeStamp.
		self fileOutPreambleOn: file.
		self fileOutOn: file.
		self fileOutPostscriptOn: file.
		file trailer] ensure: [file close]].

	Preferences checkForSlips ifFalse: [^ self].

	slips _ self checkForSlips.
	(slips size > 0 and: [(PopUpMenu withCaption: 'Methods in this fileOut have halts
or references to the Transcript
or other ''slips'' in them.
Would you like to browse them?' chooseFrom: 'Ignore\Browse slips') = 2])
		ifTrue: [Smalltalk browseMessageList: slips
							name: 'Possible slips in ', name]! !

