'From Squeak3.1alpha of 6 February 2001 [latest update: #4173] on 18 August 2001 at 11:35:37 am'!
"Change Set:		StarMorphShiftClickFix-nk
Date:			8 August 2001
Author:			Ned Konz

If you create a StarMorph and shift-click on it a couple of times,
you'll get a walkback because PolygonMorph doesn't know about
StarMorph's editing of its vertices.

This fixes the problem.
"!


!PolygonMorph methodsFor: 'editing' stamp: 'nk 8/8/2001 12:13'!
mouseDown: evt

	^ evt shiftPressed
		ifTrue: [((owner isKindOf: PolygonMorph) and: [owner includesHandle: self])
					ifTrue: ["Prevent insertion handles from getting edited"
							^ super mouseDown: evt].
				self toggleHandles.
				handles ifNil: [^ self].
				vertices withIndexDo:  "Check for click-to-drag at handle site"
					[:vertPt :vertIndex |
					((handles at: vertIndex*2-1 ifAbsent: [ ^self ]) containsPoint: evt cursorPoint) ifTrue:
						["If clicked near a vertex, jump into drag-vertex action"
						evt hand newMouseFocus: (handles at: vertIndex*2-1)]]]
		ifFalse: [super mouseDown: evt]! !

