'From Squeak3.2alpha of 2 October 2001 [latest update: #4478] on 13 November 2001 at 12:09:38 pm'!
"Change Set:		makeThumbnailTweak
Date:			13 November 2001
Author:			Dan Ingalls

A problem with magnify:by: fails to reproduce borders properly.  This changeSet works around the problem by tweaking the method Thumbnail>>makeThumbnailFromForm:.

As a validation of this fix, if you execute
	PartsBin clearThumbnailCache
and then destroy shared flaps, and then recreate the shared flaps, the thumbnails there will look much better.

Also modifies ColorForm>>blankCopyOf:scaledBy: so that it shares the method in Form.
"!


!ColorForm methodsFor: 'copying' stamp: 'di 11/12/2001 15:37'!
blankCopyOf: aRectangle scaledBy: scale

        | newForm |
        newForm _ super blankCopyOf: aRectangle scaledBy: scale.
        colors ifNotNil: [newForm colors: colors copy].
        ^ newForm! !


!Thumbnail methodsFor: 'thumnail creation' stamp: 'di 11/13/2001 11:39'!
makeThumbnailFromForm: aForm
	"Make a thumbnail from the form provided, obeying my min and max width and height preferences"

	|  scaleX scaleY margin opaque |
	scaleY _ minimumHeight / aForm height.  "keep height invariant"
	scaleX _ ((aForm width * scaleY) <= maximumWidth)
		ifTrue: [scaleY]  "the usual case; same scale factor, to preserve aspect ratio"
		ifFalse: [scaleY _ maximumWidth / aForm width].

	"self form: (aForm magnify: aForm boundingBox by: (scaleX @ scaleY) smoothing: 2)."
	"Note: A problem with magnify:by: fails to reproduce borders properly.
		The following code does a better job..."
	margin _ 1.0 / (scaleX@scaleY) // 2 max: 0@0.  "Extra margin around border"
	opaque _ (Form extent: aForm extent + margin depth: aForm depth) fillWhite.
	aForm displayOn: opaque at: 0@0 rule: Form paint.  "Opaque form shrinks better"
	self form: (opaque magnify: opaque boundingBox by: (scaleX @ scaleY) smoothing: 2).

	self extent: originalForm extent! !

