'From Squeak3.2alpha of 2 October 2001 [latest update: #4566] on 30 November 2001 at 12:01:23 pm'!
"Change Set:		LazyKeyboardFocus
Date:			30 November 2001
Author:			Dan Ingalls

This changeSet implements a mild form of sticky keyboard focus.  The idea is simply to remove most causes of focus being removed unecessarily, without making any other changes.

Also included is a small change that makes dragging of system windows by their title bar dependent not on holding down the button for long enough, but by dragging more than 5 pixels.
"!


!PluggableTextMorph methodsFor: 'pane events' stamp: 'di 11/30/2001 10:42'!
mouseLeave: event

	textMorph ifNotNil: [selectionInterval _ textMorph editor selectionInterval].
	super mouseLeave: event.
! !


!SystemWindow methodsFor: 'events' stamp: 'di 11/30/2001 11:30'!
mouseDown: evt
	| cp |
	self setProperty: #clickPoint toValue: evt cursorPoint.
	TopWindow == self ifFalse:
		[evt hand releaseKeyboardFocus.
		self activate].
	model windowActiveOnFirstClick ifTrue:
		["Normally window keeps control of first click.
		Need explicit transmission for first-click activity."
		cp _ evt cursorPoint.
		submorphs do: [:m | (m containsPoint: cp) ifTrue: [m mouseDown: evt]]]

! !

!SystemWindow methodsFor: 'events' stamp: 'di 11/30/2001 11:44'!
mouseMove: evt
	| cp |
	cp _ evt cursorPoint.
	self valueOfProperty: #clickPoint ifPresentDo: 
		[:firstClick |
		((self labelRect containsPoint: firstClick) and: [(cp dist: firstClick) > 5]) ifTrue:
		["If this is a drag that started in the title bar, then pick me up"
		^ self isSticky ifFalse:
			[self fastFramingOn 
				ifTrue: [self doFastFrameDrag]
				ifFalse: [evt hand grabMorph: self topRendererOrSelf]]]].
	model windowActiveOnFirstClick ifTrue:
		["Normally window takes control on first click.
		Need explicit transmission for first-click activity."
		submorphs do: [:m | (m containsPoint: cp) ifTrue: [m mouseMove: evt]]]! !


!ZoomAndScrollControllerMorph methodsFor: 'as yet unclassified' stamp: 'di 11/30/2001 10:54'!
mouseLeave: evt

	currentKeyDown _ Set new.
	hasFocus _ false.
	mouseMovePoint _ mouseDownPoint _ nil.
! !

SimpleHierarchicalListMorph removeSelector: #mouseLeave:!
PluggableListMorph removeSelector: #mouseLeave:!
