'From Squeak3.4beta of ''1 December 2002'' [latest update: #5147] on 8 December 2002 at 11:14:14 am'!
"Change Set:		FileListRefactor1-nk
Date:			7 December 2002
Author:			Ned Konz

This is a minor refactoring of the FileList that puts the services query on the class side where it belongs (at least if you want to use it for your own FileList, as I did).
"!


!FileList methodsFor: 'file list menu' stamp: 'nk 12/7/2002 12:56'!
itemsForFile: fullName
	"Answer a list of services appropriate for a file of the given full name"
	| suffix |
	suffix _ self class suffixOf: fullName.
	^ (self class itemsForFile: fullName) , (self myServicesForFile: fullName suffix: suffix)! !

!FileList methodsFor: 'file list menu' stamp: 'nk 12/7/2002 12:57'!
suffixOfSelectedFile
	"Answer the file extension of the receiver's selected file"
	^ self class suffixOf: self fullName.! !


!FileList class methodsFor: 'file reader registration' stamp: 'nk 12/7/2002 12:53'!
itemsForFile: fullName
	"Answer a list of services appropriate for a file of the given full name"

	| services suffix |
	suffix _ self suffixOf: fullName.
	services _ OrderedCollection new.
	self registeredFileReaderClasses do: [:reader |
		reader ifNotNil: [services addAll: (reader fileReaderServicesForFile: fullName suffix: suffix)]].
	^ services! !

!FileList class methodsFor: 'file reader registration' stamp: 'nk 12/7/2002 12:52'!
suffixOf: aName
	"Answer the file extension of the given file"
	^ aName
		ifNil:
			['']
		ifNotNil:
			[(FileDirectory extensionFor: aName) asLowercase]! !

FileList removeSelector: #suffixOf:!
