'From Squeak 2.3 beta of Nov 25, 1998 on 4 January 1999 at 11:11 am'!
"Change Set:		ColorSeesHideFix
Date:			4 January 1999
Author:			Dan Ingalls

Updates the implementations of fullDrawOn:without:andStopThere: to take into account the new hide/show mechanism in Morphic and EToys.
"!


!Morph methodsFor: 'drawing' stamp: 'di 1/4/1999 10:57'!
fullDrawOn: aCanvas without: stopMorph andStopThere: stopThere
	"Like fullDrawOn:, except it does not display stopMorph,
	and it will not display anything above it if stopThere is true.
	Returns true if it has hit stopMorph, and should stop."

	self visible ifFalse: [^ false].
	(aCanvas isVisible: self fullBounds) ifFalse: [^ false].
	(aCanvas isVisible: bounds) ifTrue: [self drawOn: aCanvas].
	submorphs isEmpty ifFalse:
		["draw back-to-front"
		submorphs reverseDo:
			[:m | m == stopMorph
				ifTrue: [stopThere ifTrue: [^ true]]
				ifFalse: [(m fullDrawOn: aCanvas without: stopMorph andStopThere: stopThere)
								ifTrue: [^ true]]]].  
	^ false! !


!TransformMorph methodsFor: 'drawing' stamp: 'di 1/4/1999 10:58'!
fullDrawOn: aCanvas without: stopMorph andStopThere: stopThere
	"Like fullDrawOn:, except it does not display stopMorph,
	and it will not display anything above it if stopThere is true.
	Returns true if it has hit stopMorph, and should stop."

	| clippingCanvas sourceQuad warp innerRect patchRect subCanvas offsetCanvas stopped patchForm |
	self visible ifFalse: [^ false].
	(aCanvas isVisible: self bounds) ifFalse: [^ false].
	self drawOn: aCanvas.
	transform isPureTranslation
	ifTrue:
		[clippingCanvas _ aCanvas copyOffset: transform offset negated truncated
									clipRect: self innerBounds.
		submorphs reverseDo:
			[:m | m == stopMorph
				ifTrue: [stopThere ifTrue: [^ true]]
				ifFalse: [(m fullDrawOn: clippingCanvas
								without: stopMorph
								andStopThere: stopThere)
							ifTrue: [^ true]]].
		^ false]
	ifFalse:
		[innerRect _ self innerBounds.

		"Render the submorphs visible in the clipping rectangle, as patchForm"
		patchRect _ 
			(transform globalBoundsToLocal: (aCanvas clipRect intersect: innerRect))
			intersect:
			(Rectangle merging: (self submorphs collect: [:m | m fullBounds])).
		subCanvas _ FormCanvas extent: patchRect extent depth: aCanvas depth.
		offsetCanvas _ subCanvas copyOffset: patchRect topLeft negated.
		stopped _ false.
		submorphs reverseDo:
			[:m | stopped ifFalse:
				["If we have not hit stopMorph..."
				(m == stopMorph  "and this submorph is not stopMorph"
					or: ["Then display it"
						m fullDrawOn: offsetCanvas
							without: stopMorph
							andStopThere: stopThere])
					ifTrue: ["We hit stopMorph here or below, so..."
							stopped _ stopThere]]].
		patchForm _ subCanvas form.

		"Now do a warping blt of the patchForm onto the incoming canvas"
		sourceQuad _ (transform sourceQuadFor: innerRect)
						collect: [:p | p - patchRect topLeft].
		warp _ aCanvas warpFrom: sourceQuad toRect: innerRect.
		warp cellSize: smoothing;  "installs a colormap if smoothing > 1"
			sourceForm: patchForm;
			warpBits.
		^ stopped]! !


