'From Squeak 2.3 beta of Nov 25, 1998 on 13 January 1999 at 3:39:34 pm'!
"Change Set:		lexCrLf
Date:			13 January 1999
Author:			Lex Spoon

Adds a couple of niceties added to CrLfFileStream.  It detects the system line-end conventions each time the image is started up, and when reading files, it detects line-ends as it goes.  This allows a file to have mixed line end conventions."!


!CrLfFileStream methodsFor: 'access' stamp: 'ls 11/5/1998 23:37'!
next
    | char secondChar |
    char _ super next.
    self isBinary ifTrue: [^char].
    char == Cr ifTrue:
        [secondChar _ super next.
        secondChar ifNotNil: [secondChar == Lf ifFalse: [self skip: -1]].
        ^Cr].
    char == Lf ifTrue: [^Cr].
    ^char! !

!CrLfFileStream methodsFor: 'access' stamp: 'ls 12/29/1998 17:15'!
next: n

		| string peekChar |
		string _ super next: n.
		string size = 0 ifTrue: [ ^string ].
		self isBinary ifTrue: [ ^string ].

		"if we just read a CR, and the next character is an LF, then skip the LF"
		( string last = Character cr ) ifTrue: [
			peekChar _ super next.		"super peek doesn't work because it relies on #next"
			peekChar ~= Character lf ifTrue: [
				super position: (super position - 1) ]. ].
 
		string _ string withSqueakLineEndings.

		string size = n ifTrue: [ ^string ].

		"string shrunk due to embedded crlfs; make up the difference"
		^string, (self next: n - string size)! !


!CrLfFileStream class methodsFor: 'class initialization' stamp: 'ls 10/28/1998 14:47'!
startUp
	self guessDefaultLineEndConvention! !


!SystemDictionary methodsFor: 'snapshot and quit' stamp: 'tk 1/13/1999 15:38'!
processStartUpList
	"Call the startUp method on each object that needs to gracefully restart itself after a snapshot."

	DisplayScreen startUp.
	FileDirectory startUp.
	CrLfFileStream startUp.
	Cursor startUp.
	Smalltalk installLowSpaceWatcher.
	InputSensor startUp.
	ProcessorScheduler startUp.
	Delay startUp.
	Smalltalk startUp.
	Smalltalk isMorphic
		ifTrue: [World fullRepaintNeeded]
		ifFalse: [ControlManager startUp].
! !


