'From Squeak 2.3 of January 14, 1999 on 3 February 1999 at 10:05:05 am'!
"Change Set:		quickViewerFixes-sw
Date:			3 February 1999
Author:			Scott Wallace

Fixes a couple of bugs in the the recent betterViewer fileout:

* Remove-instance-variable for a user-defined inst var in a viewer actually works now, rather than telling you that the feature is not-yet-implemented.

* Fixes the bug that allowed a portion of a viewer to be extracted from a palette.

* In the viewer-in-a-palette case, reduced the border-height at top, which really only serves to make it easer to do the drag that is not allowed in this case."!


!Player methodsFor: 'slots-user' stamp: 'sw 2/3/1999 09:52'!
removeSlotNamed: aSlotName
	(self okayToRemoveSlotNamed: aSlotName) ifFalse:
		[^ self inform: 'Sorry, ', aSlotName, ' is in
use in a script.'].
	self inform: 
'Caution!!  Any scripts that may reference
this instance variable may now be broken.
You may need to fix them up manually.  
In some future release, we''ll automatically
fix those up, hopefully.'.

	self class removeInstVarName: aSlotName asString.

	self updateAllViewers
! !


!TabbedPalette methodsFor: 'viewer tab' stamp: 'sw 2/3/1999 10:02'!
viewMorph: aMorph
	"The receiver is expected to have a viewer tab; select it, and target it to aMorph"
	| aPlayer aViewer |
	((currentPage isKindOf: Viewer) and: [currentPage scriptedPlayer == aMorph player])
		ifTrue:
			[^ self].
	self visible: false.
	aPlayer _ aMorph assuredPlayer.

	aViewer _  StandardViewer new initializeFor: aPlayer barHeight: 0.
	self showNoPalette.
	currentPage ifNotNil: [currentPage delete].
	self addMorphBack: (currentPage _ aViewer beSticky).
	self snapToEdgeIfAppropriate..
	self world startSteppingSubmorphsOf: aViewer.
	self visible: true! !


