'From Squeak3.1alpha of 4 February 2001 [latest update: #3641] on 19 February 2001 at 12:26:11 am'!
"Change Set:		GCDisplayFix-ar
Date:			19 February 2001
Author:			Andreas Raab

Fixes an ugly little bug in #reverseDisplayFrom:to: that went unnoticed so far."!


!Interpreter methodsFor: 'I/O primitives' stamp: 'ar 2/19/2001 00:22'!
reverseDisplayFrom: startIndex to: endIndex
	"Reverse the given range of Display words (at different bit depths, this will reverse different numbers of pixels). Used to give feedback during VM activities such as garbage collection when debugging. It is assumed that the given word range falls entirely within the first line of the Display."

	| displayObj dispBitsPtr w reversed |
	displayObj _ self splObj: TheDisplay.
	((self isPointers: displayObj) and: [(self lengthOf: displayObj) >= 4])
		ifFalse: [^ nil].
	w _ self fetchInteger: 1 ofObject: displayObj.
	dispBitsPtr _ (self fetchPointer: 0 ofObject: displayObj).
	(self isIntegerObject: dispBitsPtr) ifTrue:[^nil].
	dispBitsPtr _ dispBitsPtr + BaseHeaderSize.
	dispBitsPtr + (startIndex * 4) to: dispBitsPtr + (endIndex * 4) by: 4 do: [:ptr |
		reversed _ (self longAt: ptr) bitXor: 16rFFFFFFFF.
		self longAt: ptr put: reversed].
	self displayBitsOf: displayObj Left: 0 Top: 0 Right: w Bottom: 1.
	self ioForceDisplayUpdate.
! !

