'From Squeak3.1alpha of 28 February 2001 [latest update: #3804] on 6 March 2001 at 4:21:01 pm'!
"Change Set:		minor-sw
Date:			6 March 2001
Author:			Scott Wallace

1. Fixes typo in update 3791 concerning one of the built-in chg set names.
2. Use the nice checkbox form for the show-tiles toggle in the window menu"!


!CodeHolder methodsFor: 'tiles' stamp: 'sw 3/6/2001 16:16'!
addModelItemsToWindowMenu: aMenu
	"Add model-related item to the window menu"

	super addModelItemsToWindowMenu: aMenu. 
	Smalltalk isMorphic ifTrue:
		[aMenu addLine.
		aMenu addUpdating: #showingTilesString target: self action: #toggleShowingTiles]! !

!CodeHolder methodsFor: 'tiles' stamp: 'sw 3/6/2001 16:15'!
showingTilesString

	^ (self showingTiles
		ifTrue:
			['<yes>']
		ifFalse:
			['<no>']), 'show tiles'! !


!ChangeSorter class methodsFor: 'services' stamp: 'sw 3/6/2001 16:10'!
reorderChangeSets
	"Change the order of the change sets to something more convenient:
		First come the unnumbered changesets that come with the release.
		Next come the numbered updates.
		Next come all remaining changesets
	In a ChangeSorter, they will appear in the reversed order."

	"ChangeSorter reorderChangeSets"

	| newHead newMid newTail itsName |

	self gatherChangeSets.
	newHead _ OrderedCollection new.
	newMid _ OrderedCollection new.
	newTail _ OrderedCollection new.
	AllChangeSets do:
		[:aSet |
			itsName _ aSet name.
			((itsName beginsWith:  'Play With Me') or: [#('New Changes' 'The Worlds of Squeak' 'Fun with Morphic' 'Games' 'Fun With Music' 'Building with Squeak' 'Squeak and the Internet' 'Squeak in 3D' 'More About Sound') includes: itsName])
				ifTrue:
					[newHead add: aSet]
				ifFalse:
					[itsName startsWithDigit
						ifTrue:
							[newMid add: aSet]
						ifFalse:
							[newTail add: aSet]]].
	AllChangeSets _ newHead, newMid, newTail.
	Smalltalk isMorphic ifTrue: [SystemWindow wakeUpTopWindowUponStartup]! !

