'From Squeak3.1alpha of 28 February 2001 [latest update: #4120] on 4 June 2001 at 12:19:13 am'!
"Change Set:		mpegAppearance-jm
Date:			4 June 2001
Author:			John Maloney

Gradient-fill style appearance per Alan's request."!


!MPEGDisplayMorph methodsFor: 'initialization' stamp: 'jm 6/4/2001 00:11'!
initialize

	super initialize.
	super extent: 250@0.
	frameBuffer _ mpegFile _ nil.
	desiredFrameRate _ 10.0.
	allowFrameDropping _ true.
	running _ false.
	repeat _ false.
	volume _ 0.5.
! !

!MPEGDisplayMorph methodsFor: 'file open/close' stamp: 'jm 6/4/2001 00:13'!
openMPEGFile
	"Invoked by the 'Open' button. Prompt for a file name and try to open that file as an MPEG file."

	| result fullName |
	result _ StandardFileMenu oldFile.
	result ifNil: [^ self].
	self stopPlaying.
	fullName _ result directory pathName, FileDirectory slash, result name.
	self openFileNamed: fullName.
! !

!MPEGDisplayMorph methodsFor: 'drawing' stamp: 'jm 6/3/2001 23:57'!
drawOn: aCanvas
	"Draw the current frame image, if there is one. Otherwise, fill screen with gray."

	frameBuffer
		ifNil: [aCanvas fillRectangle: self bounds color: (Color gray: 0.75)]
		ifNotNil: [aCanvas drawImage: frameBuffer at: bounds origin].
! !


!MPEGMoviePlayerMorph methodsFor: 'initialization' stamp: 'jm 6/3/2001 23:43'!
initialize

	super initialize.
	self color: (Color gray: 0.9).  "old color"
	self fillStyle: self moviePlayerFillStyle.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	borderWidth _ 2.
	self listDirection: #topToBottom.
	self cornerStyle: #rounded.
	self layoutInset: 4.
	moviePlayer _ MPEGDisplayMorph new.
	self addMorphFront: moviePlayer.
	self addButtonRow.
	self addVolumeSlider.
	self addPositionSlider.
	self extent: 10@10.  "make minimum size"
! !

!MPEGMoviePlayerMorph methodsFor: 'private' stamp: 'jm 6/4/2001 00:04'!
addButtonRow

	| r repeatSwitch |
	r _ AlignmentMorph newRow vResizing: #shrinkWrap; color: Color transparent.
	r addMorphBack: (self buttonName: 'Open' action: #openMPEGFile).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Rewind' action: #rewindMovie).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Play' action: #startPlaying).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Stop' action: #stopPlaying).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: 'Rate' action: #setFrameRate).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	repeatSwitch _ SimpleSwitchMorph new
		offColor: (Color r: 0.7 g: 0.85 b: 1.0);
		onColor: (Color r: 0.516 g: 0.71 b: 1.0);
		fillStyle: self buttonFillStyle;
		borderWidth: 0;
		label: 'Repeat';
		actionSelector: #repeat:;
		target: moviePlayer;
		setSwitchState: moviePlayer repeat.
	r addMorphBack: repeatSwitch.
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).

	r addMorphBack: (self buttonName: '<' action: #previousFrame).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	r addMorphBack: (self buttonName: '>' action: #nextFrame).
	r addMorphBack: (Morph new extent: 4@1; color: Color transparent).
	self addMorphBack: r.
! !

!MPEGMoviePlayerMorph methodsFor: 'private' stamp: 'jm 6/3/2001 23:52'!
addPositionSlider

	| r |
	positionSlider _ SimpleSliderMorph new
		color: (Color r: 0.71 g: 0.871 b: 1.0);
		extent: 200@2;
		target: moviePlayer;
		actionSelector: #moviePosition:;
		adjustToValue: 0.
	r _ AlignmentMorph newRow
		color: Color transparent;
		layoutInset: 0;
		wrapCentering: #center; cellPositioning: #leftCenter;
		hResizing: #shrinkWrap;
		vResizing: #rigid;
		height: 24.
	r addMorphBack: (StringMorph contents: 'start ').
	r addMorphBack: positionSlider.
	r addMorphBack: (StringMorph contents: ' end').
	self addMorphBack: r.
! !

!MPEGMoviePlayerMorph methodsFor: 'private' stamp: 'jm 6/3/2001 23:53'!
addVolumeSlider

	| levelSlider r |
	levelSlider _ SimpleSliderMorph new
		color: (Color r: 0.71 g: 0.871 b: 1.0);
		extent: 200@2;
		target: moviePlayer;
		actionSelector: #volume:;
		adjustToValue: 0.5.
	r _ AlignmentMorph newRow
		color: Color transparent;
		layoutInset: 0;
		wrapCentering: #center; cellPositioning: #leftCenter;
		hResizing: #shrinkWrap;
		vResizing: #rigid;
		height: 24.
	r addMorphBack: (StringMorph contents: '  soft ').
	r addMorphBack: levelSlider.
	r addMorphBack: (StringMorph contents: ' loud').
	self addMorphBack: r.
! !

!MPEGMoviePlayerMorph methodsFor: 'private' stamp: 'jm 6/3/2001 23:41'!
buttonFillStyle

	| fill |
	fill _ GradientFillStyle ramp: {
		0.0->(Color r: 0.742 g: 0.903 b: 1.0).
		1.0->(Color r: 0.516 g: 0.71 b: 1.0)
	}.
	fill origin: self bounds topLeft + (14@3).
	fill direction: 8@6.
	fill radial: false.
	^ fill
! !

!MPEGMoviePlayerMorph methodsFor: 'private' stamp: 'jm 6/3/2001 23:42'!
buttonName: aString action: aSymbol

	^ SimpleButtonMorph new
		target: moviePlayer;
		label: aString;
		actionSelector: aSymbol;
		color: (Color gray: 0.8);  "old color"
		fillStyle: self buttonFillStyle;
		borderWidth: 0;
		borderColor: #raised.
! !

!MPEGMoviePlayerMorph methodsFor: 'private' stamp: 'jm 6/3/2001 23:42'!
moviePlayerFillStyle

	| fill |
	fill _ GradientFillStyle ramp: {
		0.0->(Color r: 0.355 g: 0.548 b: 1.0).
		1.0->(Color r: 0.774 g: 0.935 b: 1.0)
	}.
	fill origin: self bounds topLeft + (61@7).
	fill direction: 33@37.
	fill radial: false.
	^ fill
! !

