'From Squeak3.1alpha of 28 February 2001 [latest update: #4197] on 13 July 2001 at 9:36:44 pm'!
"Change Set:		navigatorCtl-sw
Date:			13 July 2001
Author:			Scott Wallace

Allows control over showing/hiding the project navigator bar via the flaps menu -- an exact dual of the way that the momentary showing of flaps can be governed from a navigator bar.  This gives the user a straightforward and direct way to control whether or not the navigator should be showing -- formerly, the user had to go to a Preferences panel for this"!


!Preferences class methodsFor: 'get/set' stamp: 'sw 7/13/2001 21:34'!
enableProjectNavigator
	"Answer whether the project-navigator menu item should be enabled"

	^ true! !

!Preferences class methodsFor: 'get/set' stamp: 'sw 7/13/2001 21:34'!
navigatorShowingString
	"Answer a string for the show-project-navigator menu item"

	^ (self showProjectNavigator
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		, 'show navigator'
! !


!TheWorldMenu methodsFor: 'windows & flaps menu' stamp: 'sw 7/13/2001 18:19'!
formulateFlapsMenu: aMenu
	"Fill aMenu with appropriate content"

	aMenu addTitle: 'flaps'.
	aMenu addStayUpItem.
	aMenu addUpdating: #navigatorShowingString enablementSelector: #enableProjectNavigator target: Preferences selector: #togglePreference:  argumentList: #(showProjectNavigator).
	aMenu balloonTextForLastItem: 'Whether the project navigator bar should be shown at the bottom of the screen.'.
	Flaps sharedFlapsAllowed
		ifTrue:
			[self fillIn: aMenu from:
				{{#suppressFlapsString.
					{CurrentProjectRefactoring.
					#currentToggleFlapsSuppressed}.
				'Whether prevailing flaps should be shown in the project right now or not.'}.
				nil}.
			Flaps addIndividualGlobalFlapItemsTo: aMenu].
.
     self fillIn: aMenu from: {
			nil.

               {'make a new flap'.
			{Flaps. #addLocalFlap}.
			'Create a new flap.  You can later make it into a shared flap is you wish.'}.

			nil.}.
	Flaps sharedFlapsAllowed
		ifTrue:
			[self fillIn: aMenu from: {
				{'destroy all shared flaps'.
				{Flaps. #disableGlobalFlaps}.
				'Destroy all the shared flaps and disable their use in all projects.'}}]
		ifFalse:
			[aMenu add: 'install default shared flaps' target: Flaps action: #enableGlobalFlaps.
			aMenu balloonTextForLastItem: 'Create the default set of shared flaps'.
			aMenu addLine].

	self fillIn: aMenu from: {
			nil.
			{'about flaps...'.
			{Flaps . #explainFlaps}.
			'Gives a window full of details about how to use flaps.'}}.
! !

