'From Squeak3.1alpha of 28 February 2001 [latest update: #4356] on 29 September 2001 at 3:38:54 pm'!
"Change Set:		StringHashPrim-ar
Date:			29 September 2001
Author:			Andreas Raab

Add a primitive for String>>hash. The primitive can be tremendously helpful when dealing with dictionaries of Strings/Symbols."!


!MiscPrimitivePlugin class methodsFor: 'translation' stamp: 'ar 9/28/2001 04:29'!
translatedPrimitives
	"an assorted list of various primitives"
	^#(
		(Bitmap compress:toByteArray:)
		(Bitmap decompress:fromByteArray:at:)
		(Bitmap encodeBytesOf:in:at:)
		(Bitmap encodeInt:in:at:)
		(String compare:with:collated:)
		(String translate:from:to:table:)	
		(String findFirstInString:inSet:startingAt:)
		(String indexOfAscii:inString:startingAt:)
		(String findSubstring:in:startingAt:matchTable:)
		(String stringHash:initialHash:)
		(SampledSound convert8bitSignedFrom:to16Bit:)
	)
! !


!String class methodsFor: 'primitives' stamp: 'ar 9/28/2001 04:35'!
stringHash: aString initialHash: speciesHash

	| stringSize hash low |
	<primitive: 'primitiveStringHash' module: 'MiscPrimitivePlugin'>

	self var: #aHash declareC: 'int speciesHash'.
	self var: #aString declareC: 'unsigned char *aString'.

	stringSize _ aString size.
	hash _ speciesHash bitAnd: 16rFFFFFFF.
	1 to: stringSize do: [:pos |
		hash _ hash + (aString at: pos) asciiValue.
		"Begin hashMultiply"
		low _ hash bitAnd: 16383.
		hash _ (16r260D * low + ((16r260D * (hash bitShift: -14) + (16r0065 * low) bitAnd: 16383) * 16384)) bitAnd: 16r0FFFFFFF.
	].
	^ hash! !

!String methodsFor: 'comparing' stamp: 'ar 9/28/2001 04:31'!
hash
	"#hash is implemented, because #= is implemented"
	^String stringHash: self initialHash: self species hash! !

