'From Squeak3.2alpha of 2 October 2001 [latest update: #4609] on 15 December 2001 at 2:24:52 pm'!
"Change Set:		BorderedStringMorph
Date:			15 December 2001
Author:			Andreas Raab

Adds a so-called 'bordered' string morph using Bob Arnings hack for how labels in project views are drawn. Generally useful for labeling objects requiring some background contrast."!

StringMorph subclass: #BorderedStringMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!

!StringMorph methodsFor: 'accessing' stamp: 'ar 12/12/2001 02:44'!
fitContents

	| newBounds boundsChanged |
	newBounds _ self measureContents.
	boundsChanged _ bounds extent ~= newBounds.
	self extent: newBounds.		"default short-circuits if bounds not changed"
	boundsChanged ifFalse: [self changed]! !

!StringMorph methodsFor: 'accessing' stamp: 'ar 12/12/2001 02:43'!
measureContents
	| scanner |
	scanner _ DisplayScanner quickPrintOn: Display box: Display boundingBox font: self fontToUse.
	^(((scanner stringWidth: contents) max: self minimumWidth)  @ scanner lineHeight).
! !


!BorderedStringMorph methodsFor: 'as yet unclassified' stamp: 'ar 12/12/2001 03:03'!
drawOn: aCanvas
	| nameForm |
	font _ self fontToUse.
	nameForm _ Form extent: bounds extent depth: 8.
	nameForm getCanvas text: contents bounds: nameForm boundingBox font: self fontToUse color: Color black.
	(bounds origin + 1) eightNeighbors do: [ :pt |
		aCanvas
			stencil: nameForm 
			at: pt
			color: self borderColor.
	].
	aCanvas
		stencil: nameForm 
		at: bounds origin + 1 
		color: color.


	
! !

!BorderedStringMorph methodsFor: 'as yet unclassified' stamp: 'ar 12/14/2001 20:02'!
initWithContents: aString font: aFont emphasis: emphasisCode
	super initWithContents: aString font: aFont emphasis: emphasisCode.
	self borderStyle: (SimpleBorder width: 1 color: Color white).! !

!BorderedStringMorph methodsFor: 'as yet unclassified' stamp: 'ar 12/12/2001 03:03'!
initialize
	super initialize.
	self borderStyle: (SimpleBorder width: 1 color: Color white).! !

!BorderedStringMorph methodsFor: 'as yet unclassified' stamp: 'ar 12/12/2001 03:03'!
measureContents
	^super measureContents +2.! !

