'From Squeak3.6beta of ''4 July 2003'' [latest update: #5411] on 7 September 2003 at 6:05:55 pm'!
"Change Set:		BrowsePools-ar
Date:			7 September 2003
Author:			Andreas Raab

Adds an enquiry about uses of pools in some class. For example:

(SystemNavigation new)
	browseAllReferencesToPool: B3DEngineConstants from: B3DRenderEngine

"!


!SystemNavigation methodsFor: 'browse' stamp: 'ar 9/7/2003 18:05'!
browseAllReferencesToPool: poolOrName from: aClass
	"Open a message list on all messages referencing the given pool"
	| pool list |
	(poolOrName isString)
		ifTrue:[pool := Smalltalk at: poolOrName asSymbol]
		ifFalse:[pool := poolOrName].
	list := self allReferencesToPool: pool from: aClass.
	self
		browseMessageList: list
		name: 'users of ', poolOrName name.
	^list! !

!SystemNavigation methodsFor: 'query' stamp: 'ar 9/7/2003 17:58'!
allReferencesToPool: aPool from: aClass
	"Answer all the references to variables from aPool"
	| ref list |
	list := OrderedCollection new.
	aClass withAllSubclassesDo:[:cls|
		cls selectorsAndMethodsDo:[:sel :meth|
			ref := meth literals detect:[:lit|
				lit isVariableBinding and:[(aPool bindingOf: lit key) notNil]
			] ifNone:[nil].
			ref ifNotNil:[
				list add:(MethodReference new setStandardClass: cls methodSymbol: sel)
			].
		].
	].
	^list! !

