'From Squeak3.5 of ''11 April 2003'' [latest update: #5180] on 30 July 2003 at 12:45:51 pm'!
"Change Set:		PackagePaneBrowser-one-segment-category-fix
Date:			30 July 2003
Author:			Julian Fitzell

When someone creates a category (say Foo) as well as some sub-categories (like Foo-Bar), the PackagePaneBrowser won't show you the classes in Foo when you select Foo in the first column.  This fixes is so that it will.  As long as you have nothing selected in the second column, the browser will show you the classes that are in the base package selected in the first column.

This involved a little refactoring so some predicate methods were added for clarity.  More work could be done in this area."!


!PackagePaneBrowser methodsFor: 'package list' stamp: 'JF 7/30/2003 12:35'!
categoryExistsForPackage
	^ self hasPackageSelected
		and: [(systemOrganizer categories indexOf: self package asSymbol) ~= 0]
! !

!PackagePaneBrowser methodsFor: 'package list' stamp: 'JF 7/30/2003 12:24'!
hasPackageSelected

	^ packageListIndex ~= 0! !

!PackagePaneBrowser methodsFor: 'package list' stamp: 'JF 7/30/2003 12:25'!
package
	"Answer the receiver's 'package'."

	^ self hasPackageSelected
		ifFalse: [nil]
		ifTrue: [self packageList at: packageListIndex]
! !

!PackagePaneBrowser methodsFor: 'system category list' stamp: 'JF 7/30/2003 12:23'!
hasSystemCategorySelected
	^ systemCategoryListIndex ~= 0! !

!PackagePaneBrowser methodsFor: 'class list' stamp: 'JF 7/30/2003 12:26'!
classList
	"Answer an array of the class names of the selected category. Answer an 
	empty array if no selection exists."

	^ self hasSystemCategorySelected 
		ifFalse:
			[self packageClasses]
		ifTrue: [systemOrganizer listAtCategoryNumber:
			(systemOrganizer categories indexOf: self selectedSystemCategoryName asSymbol)]! !

!PackagePaneBrowser methodsFor: 'class list' stamp: 'JF 7/30/2003 12:36'!
packageClasses
	^ self categoryExistsForPackage
		ifFalse: [Array new]
		ifTrue:
			[systemOrganizer listAtCategoryNumber:
				(systemOrganizer categories indexOf: self package asSymbol)]! !

