'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5607] on 17 December 2003 at 4:18:56 pm'!
"Change Set:		ClassRefsBrowsing
Date:			17 December 2003
Author:			tim@sumeru.stanford.edu

This is a replacement for the older ClassRefBrowseFix changeset dating back to 16 May 2003. 
Browser>class references is supposed to find all the methods where a class is referenced - but unfortunately it misses all those places where a named primitive call is made. For example ,try finding references to LargeIntegersPlugin - you won't find Integer>bitOr:

The cause of this is the way the plugin class is referenced in those methods; instead of a lookupkey as in the usual methods, we have an array with the plugin's moduleName, which is not always the same as the plugin's class name. The main code change is to StringHolder>browseClassRefs to defer to the actual class for a list of referring methods. This allows the basic #allCallsOn (which in this code also looks for references to the symbol naming the class, a possibly useful general facility which would point out places where <Smalltalk at: #classname> is used) to be subclassed for plugins.
The method name is not particularly good but I couldn't think of anything better at the time."!


!Behavior methodsFor: '*system-support' stamp: 'tpr 12/17/2003 16:04'!
allCallsOn
	"Answer a SortedCollection of all the methods that refer to me by name or as part of an association in a global dict."


	^ (self  systemNavigation allCallsOn:  (self environment associationAt: self theNonMetaClass name)), (self  systemNavigation allCallsOn:  self theNonMetaClass name)	! !


!StringHolder methodsFor: 'message list menu' stamp: 'tpr 12/17/2003 15:43'!
browseClassRefs

	| cls |
	(cls _ self selectedClass) ifNotNil: [
		self systemNavigation browseAllCallsOnClass: cls theNonMetaClass]
! !


!SystemNavigation methodsFor: 'browse' stamp: 'tpr 12/17/2003 16:01'!
browseAllCallsOnClass: aClass
	"Create and schedule a message browser on each method that refers to 
	aClass. For example, SystemNavigation new browseAllCallsOnClass: Object."
	self
		browseMessageList: aClass allCallsOn asSortedCollection
		name: 'Users of class ' , aClass theNonMetaClass name
		autoSelect: aClass theNonMetaClass name! !

