'From Squeakeasy0.0 of 13 May 2003 [latest update: #25] on 16 May 2003 at 12:34:21 am'!
"Change Set:		parametersCleanup-sw
Date:			16 May 2003
Author:			Scott Wallace

Adds a Preferences method for remove unwanted Parameters entries, and invokes that method in the postscript to remove three superfluous 'Parameters' entries.
Also, adds a 'senders of this key' command, and a stay-up item, to the key-list menu for DictionaryInspector; these were both very useful in investigating usage of the various parameters."!


!DictionaryInspector methodsFor: 'menu' stamp: 'sw 5/16/2003 00:33'!
dictionaryMenu: aMenu
	"Set up the key-list menu for a dictionary inspector"

	aMenu title: 'Dictionary key'.
	Smalltalk isMorphic ifTrue:
		[aMenu addStayUpItem].
	^ aMenu addList: #(
		('inspect'						inspectSelection)
		('copy name'					copyName)
		('references'					selectionReferences)
		('objects pointing to this value'	objectReferencesToSelection)
		('senders of this key'			sendersOfSelectedKey)
		-
		('refresh view'					calculateKeyArray)
		-
		('add key'						addEntry)
		('rename key'					renameEntry)
		('remove'						removeSelection)
		-
		('basic inspect'					inspectBasic))! !

!DictionaryInspector methodsFor: 'menu' stamp: 'sw 5/16/2003 00:00'!
sendersOfSelectedKey
	"Create a browser on all senders of the selected key"

	| aKey |
	self selectionIndex = 0 ifTrue: [^ self changed: #flash].
	((aKey _ keyArray at: selectionIndex) isKindOf: Symbol) ifFalse: [^ self changed: #flash].
	object class == MethodDictionary ifTrue: [^ self changed: #flash].
	Smalltalk browseAllCallsOn: aKey! !


!Preferences class methodsFor: 'parameters' stamp: 'sw 5/16/2003 00:27'!
expungeParameter: aKey
	"If Parameters holds an entry under the given key, remove the entry.  No senders in the current system, but called from the postscript of the change-set that defines it, and potentially useful otherwise."

	Parameters removeKey: aKey ifAbsent: []! !

"Postscript:"
Preferences expungeParameter: #Prevailing.
Preferences expungeParameter: #PersonalPreferences.
Preferences expungeParameter: #systemLanguage.
!

