'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5657] on 9 February 2004 at 1:43:54 pm'!
"Change Set:		FileDirectory-checkName-localName-fix-jf
Date:			7 February 2004
Author:			Julian Fitzell

FileDirectory class>>checkName:fixErrors: was passing on only the local name portion of the fileName you give it.  This is problematic if you were trying to get a valid file name from, for example, a string that happens to have a forward slash in it on a Unix filesystem.  The behaviour is also unusual since the method returns the fixed string if the second parameter is true, and this means that if you passed in a full path you would get only the last segment back.  Non of the in-image senders of this method depended on the behaviour since they all pass in only a local path anyway.

This changeset changes the behaviour to pass the complete string on for checking.  It also changes the fullName method parameter name to fileName and changes the comment appropriately."!


!FileDirectory class methodsFor: 'name utilities' stamp: 'jf 2/7/2004 17:22'!
checkName: fileName fixErrors: flag
	"Check a string fileName for validity as a file name on the current default file system. Answer the original file name if it is valid. If the name is not valid (e.g., it is too long or contains illegal characters) and fixing is false, raise an error. If fixing is true, fix the name (usually by truncating and/or tranforming characters), and answer the corrected name. The default behavior is to truncate the name to 31 chars. Subclasses can do any kind of checking and correction appropriate to the underlying platform."

	^ DefaultDirectory
		checkName: fileName
		fixErrors: flag
! !

