'From Squeak3.2gamma of 15 January 2002 [latest update: #4917] on 5 August 2003 at 8:40:44 am'!
"Change Set:		utf8
Date:			16 September 2002
Author:			Jonas hrn

Two small methods added to String for conversion between ISO-8859-1 and UTF-8.
"!


!String methodsFor: 'internet' stamp: 'JO 9/2/2002 11:54'!
isoToUtf8
	"Convert ISO 8559-1 to UTF-8"
	| s v |
	s _ WriteStream on: (String new: self size).

	self do: [:c |
		v _ c asciiValue.
		(v > 128)
			ifFalse: [s nextPut: c]
			ifTrue: [
				s nextPut: (192+(v >> 6)) asCharacter.
				s nextPut: (128+(v bitAnd: 63)) asCharacter]].
	^s contents. 
! !

!String methodsFor: 'internet' stamp: 'JO 9/2/2002 11:59'!
utf8ToIso
	"Only UTF-8 characters that maps to 8-bit ISO-8559-1 values are converted. Others raises an error"
	| s i c v c2 v2 |
	s _ WriteStream on: (String new: self size).
	
	i _ 1.
	[i <= self size] whileTrue: [
		c _ self at: i. i_i+1.
		v _ c asciiValue.
		(v > 128)
			ifFalse: [ s nextPut: c ]
			ifTrue: [((v bitAnd: 252) == 192)
				ifFalse: [self error: 'illegal UTF-8 ISO character']
				ifTrue: [
					(i > self size) ifTrue: [ self error: 'illegal end-of-string, expected 2nd byte of UTF-8'].
					c2 _ self at: i. i_i+1.
					v2 _ c2 asciiValue.
					((v2 bitAnd: 192) = 128) ifFalse: [self error: 'illegal 2nd UTF-8 char']. 
					s nextPut: ((v2 bitAnd: 63) bitOr: ((v << 6) bitAnd: 192)) asCharacter]]].
	^s contents. 
! !

