'From Squeak3.7alpha of 11 September 2003 [latest update: #5816] on 11 March 2004 at 5:50:31 pm'!
"Change Set:		GenieStubs-nk
Date:			11 March 2004
Author:			Ned Konz
Version:			4

This package supplies replacements for a few methods that will let Genie-aware applications run (without Genie) without change in an image with Genie removed (i.e. in post-5764 images).

I recommend that this package be added to the update stream.
"!


!Morph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/10/2004 09:58'!
allowsGestureStart: evt
	^false! !

!Morph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/10/2004 14:30'!
handleMouseDown: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent hand removePendingBalloonFor: self.
	anEvent hand removePendingHaloFor: self.
	anEvent wasHandled: true.

	(anEvent controlKeyPressed
			and: [Preferences cmdGesturesEnabled])
		ifTrue: [^ self invokeMetaMenu: anEvent].

	"Make me modal during mouse transitions"
	anEvent hand newMouseFocus: self event: anEvent.
	anEvent blueButtonChanged ifTrue:[^self blueButtonDown: anEvent].
	
	"this mouse down could be the start of a gesture, or the end of a gesture focus"
	(self isGestureStart: anEvent)
		ifTrue: [^ self gestureStart: anEvent].

	self mouseDown: anEvent.
	anEvent hand removeHaloFromClick: anEvent on: self.

	(self handlesMouseStillDown: anEvent) ifTrue:[
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue + self mouseStillDownThreshold
			arguments: {anEvent copy resetHandlerFields}
			stepTime: self mouseStillDownStepRate ].
! !

!Morph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/11/2004 17:45'!
isGestureStart: anEvent
	"This mouse down could be the start of a gesture, or the end of a gesture focus"

	anEvent hand isGenieEnabled
		ifFalse: [ ^false ].

	(self allowsGestureStart: anEvent)
		ifTrue: [^ true ].		"could be the start of a gesture"

	"otherwise, check for whether it's time to disable the Genie auto-focus"
	(anEvent hand isGenieFocused
		and: [anEvent whichButton ~= anEvent hand focusStartEvent whichButton])
			ifTrue: [anEvent hand disableGenieFocus].

	^false! !

!Morph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/11/2004 17:30'!
mouseStillDownStepRate
	"At what rate do I want to receive #mouseStillDown: notifications?"
	^1! !

!Morph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/10/2004 06:38'!
redButtonGestureDictionaryOrName: aSymbolOrDictionary! !

!Morph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/10/2004 06:38'!
yellowButtonGestureDictionaryOrName: aSymbolOrDictionary! !


!HandMorph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/10/2004 10:06'!
autoFocusRectangleBoundsFor: aMorph
	^aMorph bounds! !

!HandMorph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/10/2004 10:15'!
disableGenieFocus
! !

!HandMorph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/11/2004 17:47'!
enableGenie
	self error: 'Genie is not available for this hand'.! !

!HandMorph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/11/2004 17:44'!
focusStartEvent
	^nil! !

!HandMorph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/10/2004 10:06'!
genieGestureProcessor
	^nil! !

!HandMorph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/11/2004 17:45'!
isGenieAvailable
	"Answer whether the Genie gesture recognizer is available for this hand"
	^false! !

!HandMorph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/11/2004 17:46'!
isGenieEnabled
	"Answer whether the Genie gesture recognizer is enabled for this hand"
	^false! !

!HandMorph methodsFor: '*geniestubs-stubs' stamp: 'nk 3/11/2004 17:46'!
isGenieFocused
	"Answer whether the Genie gesture recognizer is auto-focused for this hand"
	^false! !


!MouseButtonEvent methodsFor: '*geniestubs-accessing' stamp: 'nk 3/11/2004 17:44'!
whichButton
	^whichButton! !

