'From Squeak3.7-m17n of 30 June 2004 [latest update: #6] on 9 July 2004 at 6:52:35 am'!
"Change Set:		FileStreamPrep
Date:			8 July 2004
Author:			Yoshiki Ohshima

Preparation for the next update."!


!FileStream class methodsFor: 'concrete classes' stamp: 'yo 7/5/2004 20:18'!
concreteStream
	"Who should we really direct class queries to?  "
	^ MultiByteFileStream.
! !

!FileStream class methodsFor: 'file reader services' stamp: 'yo 7/5/2004 21:01'!
cs

	^ 'cs' clone.
! !

!FileStream class methodsFor: 'file reader services' stamp: 'yo 7/5/2004 20:18'!
isSourceFileSuffix: suffix

	^ (FileStream sourceFileSuffixes includes: suffix) or: [suffix = '*'].
! !

!FileStream class methodsFor: 'file reader services' stamp: 'yo 7/5/2004 21:00'!
multiCs

	^ 'mcs' clone.
! !

!FileStream class methodsFor: 'file reader services' stamp: 'yo 7/5/2004 21:01'!
multiSt

	^ 'mst' clone.
! !

!FileStream class methodsFor: 'file reader services' stamp: 'yo 7/7/2004 09:43'!
sourceFileSuffixes

	^ {FileStream st. FileStream cs. FileStream multiSt. FileStream multiCs} asSet asArray.

! !

!FileStream class methodsFor: 'file reader services' stamp: 'yo 7/5/2004 21:01'!
st

	^ 'st' clone.
! !

!FileStream class methodsFor: 'file reader services' stamp: 'yo 7/6/2004 20:56'!
writeSourceCodeFrom: aStream baseName: baseName isSt: stOrCsFlag useHtml: useHtml

	| extension converter f fileName |
	aStream contents isAsciiString ifTrue: [
		stOrCsFlag ifTrue: [
			extension _ (FileDirectory dot, FileStream st).
		] ifFalse: [
			extension _ (FileDirectory dot, FileStream cs).
		].
		converter _ MacRomanTextConverter new.
	] ifFalse: [
		stOrCsFlag ifTrue: [
			extension _ (FileDirectory dot, FileStream st "multiSt").
		] ifFalse: [
			extension _ (FileDirectory dot, FileStream cs "multiCs").
		].
		converter _ UTF8TextConverter new.
	].
	fileName _ useHtml ifTrue: [baseName, '.html'] ifFalse: [baseName, extension].
	f _ FileStream newFileNamed: fileName.
	f ifNil: [^ self error: 'Cannot open file'].
	(converter isMemberOf: UTF8TextConverter) ifTrue: [self writeUTF8PreambleOn: f].
	f converter: converter.
	f nextPutAll: aStream contents.
	f close.
! !

!FileStream class methodsFor: 'file reader services' stamp: 'yo 7/8/2004 06:30'!
writeUTF8PreambleOn: aStream

	aStream nextPutAll: '"<utf-8>"
| me |
ctx _ thisContext.
[ctx == nil or:[ctx receiver isKindOf: FileStream]] whileFalse:[ctx _ ctx sender].
ctx ifNotNil:[me _ ctx receiver].
me ifNotNil: [me converter: UTF8TextConverter new.]!!
'
! !


!MultiByteBinaryOrTextStream methodsFor: 'as yet unclassified' stamp: 'yo 7/7/2004 09:43'!
setEncoderForSourceCodeNamed: streamName

	| l |
	l _ streamName asLowercase.
"	((l endsWith: FileStream multiCs) or: [
		(l endsWith: FileStream multiSt) or: [
			(l endsWith: (FileStream multiSt, '.gz')) or: [
				(l endsWith: (FileStream multiCs, '.gz'))]]]) ifTrue: [
					self converter: UTF8TextConverter new.
					^ self.
	].
"
	((l endsWith: FileStream cs) or: [
		(l endsWith: FileStream st) or: [
			(l endsWith: (FileStream st, '.gz')) or: [
				(l endsWith: (FileStream cs, '.gz'))]]]) ifTrue: [
					self converter: MacRomanTextConverter new.
					^ self.
	].

	self converter: UTF8TextConverter new.
! !


!MultiByteFileStream methodsFor: 'private' stamp: 'yo 7/9/2004 06:51'!
setEncoderForSourceCodeNamed: streamName

	| l |
	l _ streamName asLowercase.
"	((l endsWith: FileStream multiCs) or: [
		(l endsWith: FileStream multiSt) or: [
			(l endsWith: (FileStream multiSt, '.gz')) or: [
				(l endsWith: (FileStream multiCs, '.gz'))]]]) ifTrue: [
					self converter: UTF8TextConverter new.
					^ self.
	].
"
	((l endsWith: FileStream cs) or: [
		(l endsWith: FileStream st) or: [
			(l endsWith: (FileStream st, '.gz')) or: [
				(l endsWith: (FileStream cs, '.gz'))]]]) ifTrue: [
					self converter: MacRomanTextConverter new.
					^ self.
	].

	self converter: UTF8TextConverter new.
! !

