'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5976] on 16 August 2004 at 2:26:10 pm'!
"Change Set:		smReload
Date:			16 August 2004
Author:			Yoshiki Ohshima

Fix the SqueakMap open problem."!


!ReadWriteStream methodsFor: 'fileIn/Out' stamp: 'yo 8/16/2004 13:45'!
fileOutClass: extraClass andObject: theObject
	"Write a file that has both the source code for the named class and an object as bits.  Any instance-specific object will get its class written automatically."

	| class srefStream |
	self setFileTypeToObject.
		"Type and Creator not to be text, so can attach correctly to an email msg"
	self text.
	self header; timeStamp.

	extraClass ifNotNil: [
		class _ extraClass.	"A specific class the user wants written"
		class sharedPools size > 0 ifTrue:
			[class shouldFileOutPools
				ifTrue: [class fileOutSharedPoolsOn: self]].
		class fileOutOn: self moveSource: false toFile: 0].
	self trailer.	"Does nothing for normal files.  HTML streams will have trouble with object data"
	self binary.

	"Append the object's raw data"
	srefStream _ SmartRefStream on: self.
	srefStream nextPut: theObject.  "and all subobjects"
	srefStream close.		"also closes me"
! !


!SMSqueakMap methodsFor: 'checkpoints' stamp: 'yo 8/16/2004 14:23'!
saveCheckpoint: contentWithFilename
	"Save the map checkpoint to disk if it is not there already."

	| file directory sz fname content |
	directory _ self directory.
	sz _ contentWithFilename size.
	fname _ contentWithFilename last: sz - (contentWithFilename lastIndexOf: $:).
	content _ contentWithFilename first: sz - fname size - 1.
	(directory fileExists: fname) ifFalse: [
		["file _ directory newFileNamed: (directory nextNameFor: 'map' extension: 'sgz')."
		file _ directory newFileNamed: fname.
		file converter: Latin1TextConverter new.
		file nextPutAll: content]
			ensure: [file close]]! !

