'From Squeakland 3.8.5976 of 25 August 2004 [latest update: #323] on 7 September 2004 at 1:37:51 pm'!
"Change Set:		launchFix-mir
Date:			7 September 2004
Author:			Michael Rueger

Fixes a bug causing projects to be loaded multiple times at startup. Cause is a weird interactive between resuming and update loading (which includes a save-no-quit)."!

Object subclass: #AutoStart
	instanceVariableNames: 'parameters '
	classVariableNames: 'InstalledLaunchers Active '
	poolDictionaries: ''
	category: 'System-Support'!

!AutoStart class methodsFor: 'class initialization' stamp: 'mir 9/7/2004 13:36'!
startUp: resuming
	"The image is either being newly started (resuming is true), or it's just been snapshotted.
	If this has just been a snapshot, skip all the startup stuff."

	| startupParameters launchers |
	resuming ifFalse: [ ^self ].

	HTTPClient determineIfRunningInBrowser.
	startupParameters _ AbstractLauncher extractParameters.
	(startupParameters includesKey: 'apiSupported' asUppercase )
		ifTrue: [
			HTTPClient browserSupportsAPI: ((startupParameters at: 'apiSupported' asUppercase) asUppercase = 'TRUE').
			HTTPClient isRunningInBrowser
				ifFalse: [HTTPClient isRunningInBrowser: true]].
	self checkForUpdates.
	self active ifTrue: [
		self active: false.
		^ self].
	self checkForPluginUpdate.
	launchers _ self installedLaunchers collect: [:launcher |
		launcher new].
	launchers do: [:launcher |
		launcher parameters: startupParameters].
	launchers do: [:launcher |
		Smalltalk at: #WorldState ifPresent: [ :ws | ws addDeferredUIMessage: [launcher startUp]]].
	self active: true
! !

!AutoStart class methodsFor: 'private' stamp: 'mir 9/7/2004 13:34'!
active
	^ Active == true! !

!AutoStart class methodsFor: 'private' stamp: 'mir 9/7/2004 13:36'!
active: aBoolean
	Active := aBoolean! !

"Postscript:
"

AutoStart active: true.
!