'From Squeak3.6beta of ''4 July 2003'' [latest update: #5395] on 12 August 2003 at 1:05:20 am'!
"Change Set:		MoveSoundBufferOutOfSound
Date:			11 August 2003
Author:			Adam Spitz

SoundBuffer seems to be used by a lot more than just the Sound stuff. This changeset moves it out of the Sound-* categories so that we can remove the rest of the Sound stuff."

Smalltalk organization classifyAll: {#SoundBuffer} under: 'System-SoundBuffer'.!

ArrayedCollection variableWordSubclass: #SoundBuffer
	instanceVariableNames: ''
	classVariableNames: 'SineTable '
	poolDictionaries: ''
	category: 'System-SoundBuffer'!

!GraphMorph methodsFor: 'commands' stamp: 'ads 7/31/2003 11:11'!
loadSineWave

	self loadSoundData: SoundBuffer sineTable.
! !


!SoundBuffer methodsFor: 'utilities' stamp: 'ads 7/31/2003 15:15'!
storeExtendedFloat: aNumber on: aBinaryStream
	"Store an Apple extended-precision 80-bit floating point number on the given stream."
	"Details: I could not find the specification for this format, so constants were determined empirically based on assumption of 1-bit sign, 15-bit exponent, 64-bit mantissa. This format does not seem to have an implicit one before the mantissa as some float formats do."

	| n isNeg exp mantissa |
	n _ aNumber asFloat.
	isNeg _ false.
	n < 0.0 ifTrue: [
		n _ 0.0 - n.
		isNeg _ true].
	exp _ (n log: 2.0) ceiling.
	mantissa _ (n * (2 raisedTo: 64 - exp)) truncated.
	exp _ exp + 16r4000 - 2.  "not sure why the -2 is needed..."
	isNeg ifTrue: [exp _ exp bitOr: 16r8000].  "set sign bit"
	aBinaryStream nextPut: ((exp bitShift: -8) bitAnd: 16rFF).
	aBinaryStream nextPut: (exp bitAnd: 16rFF).
	8 to: 1 by: -1 do: [:i | aBinaryStream nextPut: (mantissa digitAt: i)].! !


!SoundBuffer class methodsFor: 'class initialization' stamp: 'ads 7/31/2003 11:13'!
initialize
	"Build a sine wave table."
	"SoundBuffer initialize"

	| tableSize radiansPerStep peak |
	tableSize _ 4000.
	SineTable _ self newMonoSampleCount: tableSize.
	radiansPerStep _ (2.0 * Float pi) / tableSize asFloat.
	peak _ ((1 bitShift: 15) - 1) asFloat.  "range is +/- (2^15 - 1)"
	1 to: tableSize do: [:i |
		SineTable at: i put: (peak * (radiansPerStep * (i - 1)) sin) rounded].
! !

!SoundBuffer class methodsFor: 'class initialization' stamp: 'ads 7/31/2003 11:13'!
sineTable
	"Answer a SoundBuffer containing one complete cycle of a sine wave."

	^ SineTable
! !

SoundBuffer initialize!
