'From Squeak3.7beta of ''1 April 2004'' [latest update: #5954] on 22 June 2004 at 6:28:06 pm'!
"Change Set:		BrowseCodeFilesFix-nk v2
Date:			22 June 2004
Author:			Ned Konz

Fixes browseCodeFiles service from the FileList.

Removes reference to FileContentsBrowser from the FileList (as Stef wanted to do).

Allows composite pattern, and initializes it.
Requires FileListServicesForDirectories-nk loaded first.

"
!


!FileContentsBrowser class methodsFor: 'file list services' stamp: 'nk 6/12/2004 11:41'!
fileReaderServicesForDirectory: aDirectory
	^{ self serviceBrowseCodeFiles }! !

!FileContentsBrowser class methodsFor: 'file list services' stamp: 'nk 6/22/2004 18:25'!
selectAndBrowseFile: aFileList
	"When no file are selected you can ask to browse several of them"

	| selectionPattern files |
	selectionPattern := FillInTheBlank request:'What files?' initialAnswer: '*.cs;*.st'.
	files _ (aFileList directory fileNamesMatching: selectionPattern) 
				collect: [:each | aFileList directory fullNameFor: each].
	self browseFiles: files.


! !

!FileContentsBrowser class methodsFor: 'file list services' stamp: 'nk 6/12/2004 11:35'!
serviceBrowseCodeFiles

	^  (SimpleServiceEntry 
		provider: self
		label: 'browse code files' 
		selector: #selectAndBrowseFile:)
		argumentGetter: [ :fileList | fileList ];
		yourself! !


!FileDirectory methodsFor: 'file name utilities' stamp: 'nk 6/22/2004 18:25'!
fileNamesMatching: pat
	"
	FileDirectory default fileNamesMatching: '*'
	FileDirectory default fileNamesMatching: '*.image;*.changes'
	"
	
	| files |
	files _ OrderedCollection new.
	
	(pat findTokens: ';', String crlf) do: [ :tok | 
		files addAll: (self fileNames select: [:name | tok match: name]) ].
	
	^files
! !

FileList removeSelector: #serviceBrowseCodeFiles!
FileContentsBrowser class removeSelector: #services!

!FileContentsBrowser class reorganize!
('instance creation' browseCompressedCodeStream: browseFile: browseStream: browseStream:named:)
('window color' windowColorSpecification)
('class initialization' initialize unload)
('file list services' browseFiles: fileReaderServicesForDirectory: fileReaderServicesForFile:suffix: selectAndBrowseFile: serviceBrowseCode serviceBrowseCodeFiles serviceBrowseCompressedCode)
!

