'From Squeak3.7gamma of ''17 July 2004'' [latest update: #5987] on 29 September 2004 at 4:43:35 pm'!
"Change Set:		DateAndTimeDaysAfterMonthEnds-bvs
Date:			29 September 2004
Author:			Benjamin Schroeder

As reported by Avi Bryant, version 3.6 would give an error when a date like

	Date year: 2004 month: 2 day: 30
	Date year: 2004 month: 2 day: 0
	
was created, as the 30th and 0th are 'out-of-bounds' for February of that year.

It looks like a check, formerly in Date>>newDay:month:year:, was missing after the transition to Chronology classes.  This changeset restores the check."!


!DateAndTime class methodsFor: 'squeak protocol' stamp: 'bvs 9/29/2004 16:43'!
year: year month: month day: day hour: hour minute: minute second: second nanoSecond: nanoCount offset: offset
	"Return a DateAndTime"

	| monthIndex daysInMonth p q r s julianDayNumber since |

	monthIndex _ month isInteger ifTrue: [month] ifFalse: [Month indexOfMonth: month].
	daysInMonth _ Month
		daysInMonth: monthIndex
		forYear: year.
	day < 1 ifTrue: [self error: 'day may not be zero or negative'].
	day > daysInMonth ifTrue: [self error: 'day is after month ends']. 	
	
	p _ (monthIndex - 14) quo: 12.
	q _ year + 4800 + p.
	r _ monthIndex - 2 - (12 * p).
	s _ (year + 4900 + p) quo: 100.

	julianDayNumber _
 		( (1461 * q) quo: 4 ) +
			( (367 * r) quo: 12 ) -
 				( (3 * s) quo: 4 ) +
 					( day - 32075 ).

	since _ Duration days: julianDayNumber hours: hour 
				minutes: minute seconds: second nanoSeconds: nanoCount.

	^ self basicNew
 		ticks: since ticks offset: offset;
		yourself.! !


!DateAndTimeTest methodsFor: 'Tests' stamp: 'bvs 9/29/2004 16:22'!
testErrorWhenDayIsAfterMonthEnd

	self
		should:
			[DateAndTime
				year: 2004
				month: 2
				day: 30]
		raise: Error.

	self
		shouldnt:
			[DateAndTime
				year: 2004
				month: 2
				day: 29]
		raise: Error.
	! !

!DateAndTimeTest methodsFor: 'Tests' stamp: 'bvs 9/29/2004 16:29'!
testErrorWhenDayIsBeforeMonthStart

	self
		should:
			[DateAndTime
				year: 2004
				month: 2
				day: -1]
		raise: Error.

	self
		should:
			[DateAndTime
				year: 2004
				month: 2
				day: 0]
		raise: Error.
		
	self
		shouldnt:
			[DateAndTime
				year: 2004
				month: 2
				day: 1]
		raise: Error.
	! !

