'From Squeak3.8alpha of ''17 July 2004'' [latest update: #5976] on 4 September 2004 at 6:00:23 pm'!
"Change Set:		GriddingAndGraphFix
Date:			4 September 2004
Author:			Karl Ramberg

Making a grid or a background graph paper would give you an error if you used a point size over 36@36. No real reason other than a comment saying '... because it was that way before ...'. This change set removes that limitation."!


!Morph methodsFor: 'e-toy support' stamp: 'kfr 9/4/2004 15:22'!
gridFormOrigin: origin grid: smallGrid background: backColor line: lineColor

	| bigGrid gridForm gridOrigin |
	gridOrigin _ origin \\ smallGrid.
	bigGrid _ (smallGrid asPoint x) @ (smallGrid asPoint y).
	gridForm _ Form extent: bigGrid depth: Display depth.
	backColor ifNotNil: [gridForm fillWithColor: backColor].
	gridOrigin x to: gridForm width by: smallGrid x do:
		[:x | gridForm fill: (x@0 extent: 1@gridForm height) fillColor: lineColor].
	gridOrigin y to: gridForm height by: smallGrid y do:
		[:y | gridForm fill: (0@y extent: gridForm width@1) fillColor: lineColor].
	^ InfiniteForm with: gridForm
! !


!PasteUpMorph methodsFor: 'gridding' stamp: 'kfr 9/4/2004 15:44'!
setGridSpec
	"Gridding rectangle provides origin and modulus"
	| response result |
	response _ FillInTheBlank
			request: 'New grid origin (usually 0@0):' translated
			initialAnswer: self gridOrigin printString.
	response isEmpty ifTrue: [^ self].
	result _ [Compiler evaluate: response] ifError: [^ self].
	(result isPoint and: [(result >= (0@0))])
		ifTrue: [self gridOrigin: result]
		ifFalse: [self inform: ('Must be a Point with coordinates (for example 10@10)' translated )].

	response _ FillInTheBlank
			request: 'New grid spacing:' translated
			initialAnswer: self gridModulus printString.
	response isEmpty ifTrue: [^ self].
	result _ [Compiler evaluate: response] ifError: [^ self].
	(result isPoint and: [(result > (0@0)) ])
		ifTrue: [self gridModulus: result]
		ifFalse: [self inform: ('Must be a Point with coordinates (for example 10@10)' translated )].

! !

