'From Squeak3.8.2a of ''26 Oct 2007'' [latest update: #6747] on 19 November 2007 at 1:32:54 pm'!
!CharacterSet methodsFor: 'collection ops' stamp: 'nice 5/9/2006 23:02'!
size
	^map sum! !
!CharacterSet methodsFor: 'testing' stamp: 'nice 5/9/2006 23:23'!
hasWideCharacters
	^false! !
!String methodsFor: 'accessing' stamp: 'nice 5/9/2006 23:47'!
indexOfAnyOf: aCharacterSet startingAt: start ifAbsent: aBlock 
	"returns the index of the first character in the given set, starting from start "
	
	| ans |
	ans := self isWideString
				ifTrue: ["Fallback to naive implementation"
					self class
						findFirstInString: self
						inCharacterSet: aCharacterSet
						startingAt: start]
				ifFalse: ["We now we contain only byte characters
						So use a byteArrayMap opimized for primitive call"
					self class
						findFirstInString: self
						inSet: aCharacterSet byteArrayMap
						startingAt: start].
	ans = 0
		ifTrue: [^ aBlock value]
		ifFalse: [^ ans]! !
!String class methodsFor: 'primitives' stamp: 'nice 5/9/2006 23:44'!
findFirstInString: aString inCharacterSet: aCharacterSet startingAt: start 
	"Trivial, non-primitive version"
	
	1
		to: aString size
		do: [:i | (aCharacterSet
					includes: (aString at: i))
				ifTrue: [^ i]].
	^ 0! !

!String methodsFor: 'accessing' stamp: 'nice 3/15/2007 21:03'!
indexOfAnyOf: aCharacterSet startingAt: start ifAbsent: aBlock 
	"returns the index of the first character in the given set, starting from start "
	
	| ans |
	ans := self isWideString
				ifTrue: ["Fallback to naive implementation"
					self class
						findFirstInString: self
						inCharacterSet: aCharacterSet
						startingAt: start]
				ifFalse: ["We know we contain only byte characters
						So use a byteArrayMap opimized for primitive call"
					self class
						findFirstInString: self
						inSet: aCharacterSet byteArrayMap
						startingAt: start].
	ans = 0
		ifTrue: [^ aBlock value]
		ifFalse: [^ ans]! !
!String class methodsFor: 'primitives' stamp: 'nice 3/15/2007 20:59'!
findFirstInString: aString inCharacterSet: aCharacterSet startingAt: start 
	"Trivial, non-primitive version"
	
	start
		to: aString size
		do: [:i | (aCharacterSet
					includes: (aString at: i))
				ifTrue: [^ i]].
	^ 0! !
