'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5657] on 24 January 2004 at 1:37:43 am'!
"Change Set:		InstallAccuFonts
Date:			24 January 2004
Author:			Doug Way, Bob Arning, Ned Konz, Duane Maxwell

Installs new Accufont bitmap StrikeFonts.  This also replaces most existing Squeak fonts (including the Apple NewYork font), making the Apple font clause in the Squeak license irrelevant.  The acknowledgement to Arts Management Systems Ltd.required by the Accufont license is added to the StrikeFont class comment.

The Accufonts were encoded in this postscript by first installing the AccuFonts.4.sar from SqueakMap, and then appending each Accufont to a file via TextStyle>>compressedMIMEEncodedStream.

Possible remaining problems:  Character widths for some punctuation characters could use some adjusting... e.g. the Accuny period character is quite wide.  Also, some fonts such as Accuny09 and Accuny10 have the same size of 12, which can cause problems for some tools.

- Doug Way

v5:
Converted the .sar file to a single changeset for inclusion in the update stream.  Font files are encoded and installed in the postscript.  The original Apple fonts are also replaced at the end of the postscript.

v4:
* Reset default sizes for system font, code font, etoys font and flaps font.
* Removed SystemWindowIcons-nk.cs from the .sar (no longer needed)
* Removed the Dingbats fonts (Accumo, Accuca). They clutter up the 'system fonts...' menu by appearing as jibberish, which is annoying. Also, I'm not sure we really want such obviously Apple-related dingbats in the image such as the Apple logo, compact Mac, etc., even if they were "cleanly" generated.
* Added acknowledgement from the AccuFonts license (the contact info for Doug Easterbrook) to the StrikeFont class comment.  The license specifies that the acknowledgement appear somewhere, and that seemed like as good a place as any.

v3:
added X and O window icons if you replace the stock fonts.

v2:
Reduced memory usage by throwing away original font data.

v1:
This code is the first attempt to replace existing Squeak fonts with new ones.  The first pass replaces all instance of the existing fonts with 'Accu'  versions.  The second pass loads in additional fonts.  The transcript will show the progress
on loading the various fonts.  An attempt is made to make existing windows still display, even though the font will change - in doing so, there may be duplicates of the Accuny font until those windows are closed and the garbage collector scavenges them.

Per the arrangement with Arts Management Systems, Ltd, an attempt has been made to encode copyright information into the fonts.  This is done by converting the copyright notice as a bitmap in glyph 16rF0, which is unused in these fonts.  Depending upon the pointsize of the font, various versions of this notice appear.

Submitted by:  Duane Maxwell, exobox

AccuFontLicense:
---------------------

Copyright Arts Management Systems, Ltd.

 Arts Management Systems Ltd.

 The fonts distributed as part of this base image are derived from fonts copyright Arts Management Systems, Ltd. Use of the fonts in derivative software products is allowed. 

 The fonts should retain their AccuFont names.

 The acknowledgement should read: 

>Doug Easterbrook
>Arts Management Systems Ltd.
>mailto:doug@artsman.com
>http://www.artsman.com
>Phone (403) 215-5701    Fax (403) 215-5704
"
!

!StrikeFont commentStamp: 'dew 1/1/2004 20:58' prior: 0!
I represent a compact encoding of a set of Forms corresponding to characters in the ASCII character set. All the forms are placed side by side in a large form whose height is the font height, and whose width is the sum of all the character widths. The xTable variable gives the left-x coordinates of the subforms corresponding to the glyphs. Characters are mapped to glyphs by using the characterToGyphMap.

Subclasses can have non-trivial mapping rules as well as different representations for glyphs sizes (e.g., not using an xTable). If so, these classes should return nil when queried for xTable and/or the characterToGlyphMap. This will cause the CharacterScanner primitive to fail and query the font for the width of a character (so that a more programatical approach can be implemented).

For display, fonts need to implement two messages:
	#installOn: aDisplayContext foregroundColor: foregroundColor backgroundColor: backgroundColor
This method installs the receiver (a font) on the given DisplayContext (which may be an instance of BitBlt or Canvas (or any of it's subclasses). The font should take the appropriate action to initialize the display context so that further display operations can be optimized.
	#displayString: aString on: aDisplayContext from: startIndex to: stopIndex at: aPoint kern: kernDelta
This method is called for each subsequent run of characters in aString which is to be displayed with the (previously installed) settings.

--------------------------------
The "AccuFont" StrikeFonts by Doug Easterbrook were added to the Squeak image for the 3.7 release.  The following acknowledgement must remain in the image (in this class comment) as long as the Accufonts are in the image:

>Doug Easterbrook
>Arts Management Systems Ltd.
>mailto:doug@artsman.com
>http://www.artsman.com
>Phone (403) 215-5701    Fax (403) 215-5704
!

!TextStyle methodsFor: 'mime file in/out' stamp: 'nk 1/19/2004 20:27'!
compressedMIMEEncodedStream
	"Answer a ReadWriteStream with my compressed, stored representation as Base64"

	| s ff ffcontents s2 gzs |
	s _ RWBinaryOrTextStream on: ''.
	ff _ SmartRefStream on: s reset.
	TextConstants at: #forceFontWriting put: true.
	[ ff nextPut: self ] ensure: [ TextConstants at: #forceFontWriting put: false ].
	ffcontents _ s contents.
	ff close.
	s2 _ RWBinaryOrTextStream on: ''.
	gzs _ GZipWriteStream on: s2.
	gzs nextPutAll: ffcontents.
	gzs close.
	s2 reset.
	s _ RWBinaryOrTextStream on: (ByteArray new: 10000).
	Base64MimeConverter mimeEncode: s2 to: s.
	^s ascii; reset
! !

!TextStyle class methodsFor: 'mime file in/out' stamp: 'nk 1/19/2004 20:36'!
collectionFromCompressedMIMEString: aString
	"aString holds a compressed, Base64 representation of a SmartRefStream storage of a TextStyle.
	Install the TextStyle."

	| this newName style heights data |
	data := (Base64MimeConverter mimeDecode: aString as: String) unzipped.
	(RWBinaryOrTextStream with: data) reset; fileIn.
	this := SmartRefStream scannedObject.

	"now install it"

	newName _ this fontArray first familyName.
	this fontArray do: [:aFont | aFont familyName = newName ifFalse: [
		self error: 'All must be same family']].
	style _ TextConstants at: newName asSymbol ifAbsent: [
		^ TextConstants at: newName asSymbol put: this].		"new family"
	this fontArray do: [:aFont | "add new fonts"
		heights _ style fontArray collect: [:bFont | bFont height].
		(heights includes: aFont height) ifFalse: [
			style fontAt: style fontArray size + 1 put: aFont]].
! !

"Postscript:"

	| allFonts fontName newFont nameTransformDict fontTransformDict sz |
	
"Install Accuny font"
TextStyle collectionFromCompressedMIMEString: 'H4sIAAAAAAAAAOW9D3gU13kvfM7M7MysNGhnBbZHZi2NFhlkN2lGlgNrW0YjeQHhOrb8r3W+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'.

"Install Accumon font"
TextStyle collectionFromCompressedMIMEString: 'H4sIAAAAAAAAAOVbe3iUV50+53znm3wJgXwzGWiKY/jmy0AGtmuHoBVbTL8MAwz0QhJa765M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'.

"Install Accusf font"
TextStyle collectionFromCompressedMIMEString: 'H4sIAAAAAAAAANWae3QcV33H752ZncdqtY9YdVeHdTROICbh0ZUVHMUVkRQZm6Rx7EamtKXQ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'.

"Install Accuat font"
TextStyle collectionFromCompressedMIMEString: 'H4sIAAAAAAAAANWafXSb5XnGn+d9X72vTGRkEeC8LiFSQkZWtrFXiIavJK8DWQiMACPZ2q1j
02tZdlRkyUgy2AWi13iV2OZixjYWCkug3dhnNxj7XkPlqpPZanD3URbWDRQ88LpuIE+DyK2Q
dl/PK8kfmNN/N+Xkp/d59bzPcz/Xc9/38zySdx5IJYcDh+8ejVp3hS6/yoqPHLUCycHAzp3B
YOBwdCQTHe6PpgJXGEZo587AJ+NWJprOBEZHBuji2sAlH9t1RejOQDIRuCIYuNlKjFqpcdS9
MmBlAsHgtaHgtVcagZHhndu6u7fd1v+paCRzOGIlEtRiInpvIJaIZWJWPPbpKH1ONdLR+GAg
PWylMndEBw9nUlFreJvCGFPcgM8biVvpdCCdSY1GMqOpaBfdldVz9scimVgyQV2j7oWoa3B6
OR9v2pdOJyMxC1VU1bEBVTgqM94jM1O98HCUBEhEolZ/PHpDMh6PihZXVXNeonLX/lj6rttT
ybFxfO4Sn/t6huLJfivuNH+rNRz1bRpJRQ9H0VIy5dscSSYcs5Opzk3vqpv7UkNpp/Uj0bHM
4cx4PIrWu53WuwaTicy+VMoa952LywPWcCw+fph087njsUT0xlRswOfut0g/Kvm6SNKhxHA0
kfFtGoyl0pmbEgMonJOKdq43pWJDR9uFrozVn3ba95L6Q7HEkc4NLR61BmKJIV/PQHTQGo1n
DpABeG6sLYjr9mQsITSVHXP5mI+PO58pB5KpYXykOh8p/bFM2ue6NzaQOepTj0ZhhM81QH5G
xeTgYDqaEc+dQ7MfuyuKvvD0ZufpzZGjVsqKZKKpI8kb4+MjRw9ZIz517AimzacO4U7apyQg
v5IZHyF1hmOJfelILEZX1tjK1cdF/5606OSWaGII3VvpCMTQBqKti7HbhEE+NWWlqU9fV3q0
Px1JxUZIvvToSDTVKrijwxQ16Vja5x2IpmL3kK/dI0xP+7pGoA1mSgxLvT6WGbZG1jiW88Hh
8eH+ZHy9Y/rEHEQHNvJJ57lbRxGfH2yw6w6qbyWGHD9qTYyapFmPJXxqJJmiGHRqbiJfziQ/
EBitZg5ZQxSkowPRdR13UxSMxK3xQ9GB2Ojwug/P+XB7Ma+JoXV3z7+FnC56ezIdg3I3JTLR
odVjcrxMSLHuprZxXc++fppacpS2/2xg+PoBkzdgSkWKiSIWA2uzCR4+hwq3EORwpxhB8flV
+QE3HxEV26W3RWnlY/60c6NdPIUmHmuX3iUooVZJmgPqK89Kb6LyS51iXdjQKskXAw+s1JZ3
relJDvvkRCy+8vEDq+2UH0PPt7VLCyhtaZeeX1PzJdF1q6Roa0pbhCHtUmj1c8ptTqmbvS10
79nM36ULzpT/+3DcQaxG24FLgB3A9wGXAjuB7wc+ClwG/ADwg8APAZcDPwwYQBC4AggBVwIf
A3YBVwFXA9cA1wLXAbuBPcBewAT6gH3A9cANwH7gR4ADwI3AQeAm4GbgR4FbgEPArcBtwO3A
jwF3AIeBI8CPAz8BfBz4BPCTwE8BnwR+GrgT+BngZ4EwYAH9QAQYAKLAIDAEHAViwKeAu4A4
MAwkgCQwAtwNpIA0kAFGgXuAe4ExQOwMPg3cB9wPPAAcA7KADUwADwKTwM8BnwFyQB54CPh5
4BeAXwSmgM8CDwPTwCPALwGPAr8M/Arwq8BjwK8Bx4HHgc8BTwBPAr8OnABOAk8BTwOfB74A
/Abwm8AzwG8Bvw38DvC7wO8Bvw98EfgD4A+BZ4HngD8Cngf+GPgT4E+BPwP+HPgL4C+BvwK+
BJwCXgC+DBSAGeArQBH4KvDXQAmYBV4E/gb4W+BrwBzwEvAyMA98Hfg74O+BfwD+EfgG8Arw
T8Bp4FXgn4FvAv8C/CvwGvA6UAbOAG8AC8C/AW8CbwGLwL8D3wL+A/g28J/AfwFvA+8AFWAJ
+G+gCvwP8C7wHnAWqAHLwHeA7wJ14H2gATSRBCWxCv1/gNjyesTq2EmCl3eS0c2d5PGJTtjH
OmF6byfUPtOJlMc7/vzFjtfNdHzjG50Z/FZH51pbPw5buA/oBWALRxblSIccyY0jX3GYwZFL
ODIDhwUcUcsRnBwWcEQPRyxwuC2H/3G4FIeDcMw5x+RJ6FJCl9LFAFK9hKwsIbNKSJESsp6E
vCYhVUnoUkK6kZBGJKQMCVlAQnRL6FdCIEoIMAkjlzByCSOX4M8SfFeCO0rwOqlJkLuA84CL
AKxCMpYYGUuHjMVBRr6XkcJlDF9GPpWRImXkPxkZTkYik5Gq5M91gFwiQwgZcS4jamWEn4yI
kjELMmZBxgQoGgA1FJihwAwFzqBg8VIwCwoWGwWLiAKPUCCOgsyvwCAFBikQR4E4CjxCQU5U
kOsUpC8FGUlBklGQNxQkCgUGKTBIQcAqMEhBMLmgi+t8ACu2C0uvC7a4sGi6sDa6sMi5YIYL
i40LFrhggQs+6UIed8EjXPBJF3zShSToglu4kKBcyEMupBYXUoYLWcCFSVHdAA4r6kcA7ApU
rPEqVnEVy7GK0FCxVKrQQMW6paJzFVOhwi1U5HsV+VlFelWRQFW4owp3VJG0VDiDCmdQkVo0
nK60HmALgH41bDA09KthFjTEgoZlW0PnGtZkDRZoWFw1BISGgNCwKGkYuYa1QkPm16C9BjM0
OKaGrKzBMTWEhobEqCHXuXHMcHsBOIMbuyU3JsANM9wYvht7CzcscGPJdyMk3UgKbvikOy/Q
o/JTm+yl3W++Pco2MZ027r207aBxUNRfjJ0XBhQg55K46yBd224mMfHiNqGLHiqg5DGibDO9
S307qP6lUt9+bGmYFlD7XuxmGmp2M9qhPuWW+nrcn79ekR50B9xIHS72Im1P6UHeR2/i1WuL
NnV9DzVPPZXZGBmD5nlORxqkLRh2ZWg3zC6g6eiaMC5mV/l4D7Xg9vVwt3LDIz09UkBi7gnD
b5epV8lm5Vbzk5WztbrH8GBnfM3qLrziawwP+obFm9vDxMsZrsYCEIY6LtPbJpxlZjyODrR5
ZfLrZRqt/BTuJFc/zYpGdna5udygbi8Tgh2TtIW6as4u1I/5RS1vgfFaNl+tZ+drjfHF/Jdq
FX8zXzP9Z2pNrdrcXZ3fLc+/ML64PMn0AocJ5xK28NzYFvr2gj3h2K7ny8e8i/WmtjDPJcgk
9bGegJsp++i6zybrJdzeNmFX/Iw3qVOm7d9hs2ztfRghzzNebGTLrFipNWCmytAPySxede9M
bS/us+2er0AnNl5mdVJkconaaZb9+brpXYat/vwbsRqZXC342BkNwy+9ejyY84TVLWL4TdVb
rZ9rzlfrTVPMtr/MZBp6tZGdX+4Mf7aePUk1ptcOv7fMbDF8b3v4rVeh9U46mN5K07+IR+cl
zp7a4XmwjwV6zu9yb98xZdt9tx/sVej2wdS+iYppy03qnUlxkoimqK3DAnSYXXq/2dZha1sH
3vAv1LOiYkih7T9nD42XOZX35Ks2U8MFkwyfFjrQCK+rr9YhpL563IIOWeHjxXM9Ic9Wg1A0
HK8PN2WPMRfMGaXenFGU9XDYYxQ91lQI/0O6ldOtSd0oBSfsiyqsT6a8xDz0jxmejXQ4QA/r
EXo0SDl/oodtJpfsc29nPbhkgYfYpW7c3n7jGTtoy7t0q+Z/8Aj5Y7E3J0ZKtHJkWSn42clW
q/x4R4ccmhYVQ+5JN5NtZhSCVDbUINll2TA8pxfJaGMu9AVcW7aPTQoZZo7P2KzlDkIGfRcN
QchgMEOPNItrZChsKEOBZPjI12mk30MGtiIDMgAF57bpJdvgxV16vxK4nrJVodj7MMVriM2t
HTFmHiOurB+xeKkFMWI17Iw4wlaP+Ion2iOmmS+wZm5meQJDvgwmGkWVGcYgmasXjZIRppQT
YRgyzxkqJ+XkXnvVkEkRtDXxbK9t2QW9wLRihTKH3z9ffDg01Vyq+8382aXlxWveue+1s6fe
WWgNWWYYsl+bqdxPqNXu3+vfcvesOXmmQpfpJxeveTnQ/Zzt16q79IE3DmwXOvCHx8/Y1kQj
nS8XjPkadPCPPQAd5L2ewmod7D1OiemeyGu9dqTiMbLTz1EmeIuGRyqygjPzXxM6PNzWIV+p
0ltYdbd1GAmXzOmyfox0mGl42Fss4jGnOjpcxNbqEJ7zVHlbh4J3YbneME+a8wvQYblhfnn+
7Hc/RAdzeqHWINATWfNJ0mG2isuWDpNlM1/d1fvVR2+iLOmtFPljzSW7MNNITwsdZpffnzTr
DUcHs1BRHl3RIVtr6aCHhA66np1+3mby3Fodnlijw6BcU/nrpAPcloVJh3Ktac5XjKZR4BMN
lZf2RurQYa82c8IsyltbOkxXPVlv2dGBlb1sxg7rM7Yn0jtVCk4Fp6zcLk9ELwWPz0UuIkek
exF9LtLWoQwdcAv36YlIcIpul0LOJd1mpENw+rvvkQ4HhQ7NM4+VzCU7bASnwmGaoWJteTI4
VdpCOqh6iB/v6uroUInorbgweqdgmOGhzsRyahbL2Xyh5sRFROiQa+vATnuWTkKHrN2ADrxQ
b7I5wyiaBYprWc4di9QRFy0d2v4wveDJ5itrdSjWWKTXbumwu62DzIQOu/RCSVUxpJYOnJ4g
H4vwDXWYsIPTy+9RXEAHbjfPPFMyqxSzLR1ouZ7kUy9frVJ+0SlFnKfYzsqwSoemHhQ6hFXS
gWY59ORqHVoZsa0DHbB7l3NtHQpFVbbJ2eaMcNFfoKytyupgpJ0fcqvzg0weaJAOY9oJ/qzK
J2yDdNAWSAdznQ6Voh4PTm3RZybJH4QOTn7In6kd8+cXOOJiQx1qlB9EXHC7yJ/B4mM1SIcC
6UBxMeuvvzJCOkzpnpnjO2jH0dLBjixXxSrZJCtVPlmBPyBBDzXWxMUla3VQTwcfz7XjgnTQ
WEsH+pDyw3odOkvDBjrM2N4VHTpxwWstHYryhvlhYx2es818BTocaOWHUimI/NDRof62WX8l
rHqXpnSz6DnIA5380NaBqTNCB10nHfBdzeBqHQz5w3Ug3dVzSQejpYPV0GU1214iHR3C1tR6
HWRdlbmtU570IC5If9Ih1NaBlh79asRFae0S2c4P3C6EDc86HbxLtJ5UxLrZJ3ToLVGepB7R
tIgLFg/ab1k5b+W0HpI9jj8462aklR50eWKKDMt5jBUdVtbNtg4XsDOyetpaowFtlBwNnG0C
U/dMrtHAWNFgChpQW9CglzSgtXwlRzpDREw4GqzKkWs12DBHamdyfKIgdks2Nh+0W6KNcIit
0WCqRDNrnNaZ7HFyQ0uDVm7QORcaqGGhAc9tqEEXKy/wQuvogs16zaIdKulBgoRY00u7aC+t
GeGmWTLEVodpJ5xdNKdd9Mnd9zdPjC+eyJ6QaRNaGfOXqV3vC15t2faQGV5a/prmCfNEtSRW
S/Pk/OJkrVrvMWtnT85j7dxKbSzSo0sNZ6s+LxZMk9o8tehc4jZlwkbQZvde55gp80Wy0Ut7
gzFalhvj74xRrnyH1s4s6TGiM63R1UVRK9OumHbR2VoX28nrXoYN9H3zYyxi5cl06rS1ga7Q
uSBfy06vl0KuhCt1sd+DFMe83qWa158vh4/5hU/JMqQQ5ylG7Z1oSWFu5XQuKY95C2uk0KqV
eta/1d+Wwu/PL05W7q737K2cnW5LMU1WzZbr/tklqju7JLZTdPvUgthOidskRd0kKUKtzSdf
/E6ddK5WxszZYlsK//j9Js2gkEJ51JFiiQ5WeyokBR2yGM5UjhSTT65IQYPjNVOumF4cRAus
0EUnINEPRFDoEIgDrDhEy6TSBTgets6mzgm3i12ChaTlf+1DHdR0Tr3kyTish51n/ThW4gws
VyvMcEZTEGdgeraX3sTBV9vWOhGvtgfB5m7ZExBPtuzxrLcnuJE9dL4VB306WHU7R+6PiqaM
9jcPK0bwKWHE9X3CCLiH+LrBYxxil9A8bHUa3N3avuOc2T4VSKLtPrStoW3fSpt1cRON3cku
Ihm2fKAVr83upvq07Quy9rcpzne09Isff3rlW1yfe18kMmplguLHJanz8xa+w6IUAJ4n/u6C
c6XZbIrvrBXxJL6dCPDv8RLPC+rA+Rt9kdzjYo+o3fhjhxvwVxAW/VjOVdnKXCt+GVR79jt/
bND5OwTUp18Pt32Tg992al3YqnVo7d8siEHxbd3d/wvlqo9M3SIAAA=='.

"Install Accushi font"
TextStyle collectionFromCompressedMIMEString: 'H4sIAAAAAAAAANWZe3xbZRnH33N7m7TpkrQOTlxZT1mh4gWTHcA5I23Z7DZsGa7zgojmNDlp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'.

"Install Accuve font"
TextStyle collectionFromCompressedMIMEString: 'H4sIAAAAAAAAAOWbbXgU5bnHn3ndXZgku0TshCxkAhGwKs5kBRaNJJE0hhrBI7ZCbXt2M9kN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'.

"Install Accujen font"
TextStyle collectionFromCompressedMIMEString: 'H4sIAAAAAAAAAOW9fXwb13UmfOcDMwNqRAwoOhlaEDGEIIty2nhgOjJksyJIQxal2hFlu026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'.

"Install Accula font"
TextStyle collectionFromCompressedMIMEString: 'H4sIAAAAAAAAAOV7fXwcx3nezOzs3ezhQMyCkATZNDl3hEIobWSQlG1ERa3dw5E82pIFk3IS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'.


	"create mapping from existing fonts to their replacements"
	nameTransformDict _ Dictionary new.
	nameTransformDict add: #NewYork10 -> 'Accuny10'.
	nameTransformDict add: #NewYork12 -> 'Accuny12'.
	nameTransformDict add: #NewYork15 -> 'Accuny14'.
	nameTransformDict add: #NewYork18 -> 'Accuny18'.
	nameTransformDict add: #NewYork24-> 'Accuny24'.
	nameTransformDict add: #ComicPlain09 -> 'Accujen09'.
	nameTransformDict add: #ComicPlain10 -> 'Accujen10'.
	nameTransformDict add: #ComicPlain12 -> 'Accujen12'.
	nameTransformDict add: #ComicPlain14 -> 'Accujen14'.
	nameTransformDict add: #ComicBold09 -> 'Accujen09'.
	nameTransformDict add: #ComicBold10 -> 'Accujen10'.
	nameTransformDict add: #ComicBold12 -> 'Accujen12'.
	nameTransformDict add: #ComicBold14 -> 'Accujen14'.
	nameTransformDict add: #ComicBold18 -> 'Accujen18'.

	"collect all font references in the current image"
	Smalltalk garbageCollect.
	allFonts _ StrikeFont allInstances.
	fontTransformDict _ Dictionary new.

	"replace fonts currently in use in the image"
	allFonts do: [ :font |
		fontName _ font name asSymbol.
		fontName last isDigit ifFalse: [
			sz _ font pointSize.
			fontName _ (font familyName asString,
				(sz < 10 ifTrue: [ '0',sz printString] ifFalse: [ sz printString]))
					asSymbol].
		(nameTransformDict includesKey: fontName)
			ifTrue:
				[newFont _ allFonts detect: [:f | f name = (nameTransformDict at: fontName)].
				fontTransformDict at: font put: newFont copy]
			ifFalse: [Transcript show: 'cannot find ',fontName; cr]
		].
	
	"do the 'become:'s in a separate loop to be safe"
	fontTransformDict keysAndValuesDo:
		[:oldF :newF |
			newF reset.
			Transcript show: 'converting ', oldF name, ' to ', newF name; cr.
			oldF become: newF].
	Smalltalk garbageCollect.

	"Remove entries for old fonts in the TextConstants dictionary"
	#(NewYork ComicPlain ComicBold) do: [ :oldName |
		TextConstants removeKey: oldName asSymbol ifAbsent: []].

	"Somehow some font defaults get reset to different sizes during Accufont installation... need to set these back to the appropriate defaults."
	Preferences setSystemFontTo: ((TextStyle named: 'Accuny') fontNamed: 'Accuny10').
	Preferences setCodeFontTo: ((TextStyle named: 'Accuny') fontNamed: 'Accuny10').
	Preferences setEToysFontTo: ((TextStyle named: 'Accujen') fontNamed: 'Accujen10').
	Preferences setFlapsFontTo: ((TextStyle named: 'ComicSansMS') fontOfPointSize: 12).

	Smalltalk garbageCollect. "make sure old StrikeFont instances are gone"

!

